--
-- PostgreSQL database dump
--

-- Dumped from database version 12.9
-- Dumped by pg_dump version 14.1 (Debian 14.1-1.pgdg110+1)

-- Started on 2021-11-17 21:10:22 +05

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

DROP DATABASE "Uchet";
--
-- TOC entry 6431 (class 1262 OID 16441)
-- Name: Uchet; Type: DATABASE; Schema: -; Owner: -
--

CREATE DATABASE "Uchet" WITH TEMPLATE = template0 ENCODING = 'UTF8' LOCALE = 'ru_RU.UTF-8';


\connect "Uchet"

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- TOC entry 43 (class 2615 OID 16443)
-- Name: bpd; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA "bpd";

CREATE EXTENSION IF NOT EXISTS plpython3u WITH SCHEMA pg_catalog;

CREATE EXTENSION IF NOT EXISTS btree_gist WITH SCHEMA public;

CREATE EXTENSION IF NOT EXISTS pgcrypto WITH SCHEMA public;

CREATE EXTENSION IF NOT EXISTS pldbgapi WITH SCHEMA public;

CREATE EXTENSION IF NOT EXISTS "uuid-ossp" WITH SCHEMA public;


--
-- TOC entry 3020 (class 1247 OID 1467191)
-- Name: action; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."action" AS ENUM (
    'insert',
    'insert_mass',
    'update',
    'delete',
    'move',
    'copy',
    'clone',
    'select',
    'rollback',
    'lock',
    'unlock',
    'connect',
    'reconnect',
    'disconnect',
    'execute',
    'init',
    'clear',
    'cast',
    'merging',
    'include',
    'exclude',
    'restore'
);


--
-- TOC entry 2943 (class 1247 OID 1385211)
-- Name: action_sql; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."action_sql" AS ENUM (
    'select',
    'insert',
    'update',
    'delete',
    'all'
);


--
-- TOC entry 2022 (class 1247 OID 25856)
-- Name: argument; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."argument" AS (
	"name" character varying,
	"type" character varying,
	"mode" character varying
);


--
-- TOC entry 2656 (class 1247 OID 792019)
-- Name: argument2; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."argument2" AS (
	"name" character varying,
	"type" character varying,
	"typcategory" character varying,
	"mode" character varying
);


--
-- TOC entry 2748 (class 1247 OID 1082638)
-- Name: cclass_prop; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."cclass_prop" AS (
	"id" bigint,
	"id_class" bigint,
	"timestamp_class" timestamp without time zone,
	"on_inherit" boolean,
	"inheritance" boolean,
	"id_prop_inherit" bigint,
	"timestamp_class_inherit" timestamp without time zone,
	"id_prop_type" integer,
	"id_data_type" integer,
	"name" character varying,
	"desc" character varying,
	"sort" integer,
	"on_override" boolean,
	"on_val" boolean,
	"string_val" character varying,
	"tablename" character varying,
	"ready" boolean,
	"id_conception" bigint,
	"id_class_definition" bigint,
	"timestamp_class_definition" timestamp without time zone,
	"id_prop_definition" bigint,
	"on_override_prop_inherit" boolean,
	"on_global" boolean,
	"id_global_prop" bigint,
	"tag" character varying
);


--
-- TOC entry 2736 (class 1247 OID 1054225)
-- Name: cdoc_category; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."cdoc_category" AS (
	"id" bigint,
	"id_conception" bigint,
	"name" character varying,
	"desc" character varying,
	"on" boolean,
	"on_grouping" boolean,
	"doc_count" bigint,
	"is_use" boolean,
	"timestamp" timestamp without time zone
);


--
-- TOC entry 2952 (class 1247 OID 1343372)
-- Name: cdoc_file; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."cdoc_file" AS (
	"id" bigint,
	"uuid" "uuid",
	"md5" character varying,
	"id_conception" bigint,
	"catalog" integer,
	"id_document" bigint,
	"name" character varying,
	"extension" character varying,
	"version" character varying,
	"versiondate" "date",
	"fulltxtsrch_on" boolean,
	"timestamp" timestamp without time zone,
	"data_length" integer
);


--
-- TOC entry 2696 (class 1247 OID 852100)
-- Name: cdoc_link; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."cdoc_link" AS (
	"id" bigint,
	"id_conception" bigint,
	"id_document" bigint,
	"id_category" integer,
	"name" character varying,
	"regnum" character varying,
	"regdate" "date",
	"id_entity" integer,
	"id_entity_instance" bigint,
	"id_sub_entity_instance" bigint
);


--
-- TOC entry 2745 (class 1247 OID 1082635)
-- Name: cobject_prop; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."cobject_prop" AS (
	"id_class_prop" bigint,
	"id_object_carrier" bigint,
	"timestamp_object_carrier" timestamp without time zone,
	"id_class" bigint,
	"timestamp_class" timestamp without time zone,
	"on_inherit" boolean,
	"inheritance" boolean,
	"id_prop_inherit" bigint,
	"timestamp_class_inherit" timestamp without time zone,
	"id_prop_type" integer,
	"id_data_type" integer,
	"name" character varying,
	"desc" character varying,
	"sort" integer,
	"on_override" boolean,
	"on_val_object" boolean,
	"on_val_class" boolean,
	"id_conception" bigint,
	"id_class_definition" bigint,
	"timestamp_class_definition" timestamp without time zone,
	"id_prop_definition" bigint,
	"string_val" character varying,
	"id_global_prop" bigint,
	"on_global" boolean,
	"tag" character varying
);


--
-- TOC entry 2776 (class 1247 OID 1158747)
-- Name: day_type; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."day_type" AS ENUM (
    'working',
    'off',
    'pre_holiday',
    'holiday'
);


--
-- TOC entry 2025 (class 1247 OID 39961)
-- Name: errarg; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."errarg" AS (
	"errid" integer,
	"errdesc" character varying
);


--
-- TOC entry 2028 (class 1247 OID 305511)
-- Name: errarg2; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."errarg2" AS (
	"err_id" integer,
	"errdesc" character varying,
	"entity_id" integer,
	"action_id" integer,
	"errsubclass_id" integer,
	"errsubclass_desc" character varying
);


--
-- TOC entry 3011 (class 1247 OID 1437601)
-- Name: errarg_action; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."errarg_action" AS (
	"err_id" integer,
	"errdesc" character varying,
	"entity_id" integer,
	"entity_instance_id" bigint,
	"entity_instance_name" character varying,
	"action_id" integer,
	"action_desc" character varying
);


--
-- TOC entry 3008 (class 1247 OID 889990)
-- Name: errarg_cast; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."errarg_cast" AS (
	"err_id" integer,
	"errdesc" character varying,
	"entity_id" integer,
	"entity_instance_id" bigint,
	"entity_instance_name" character varying,
	"action_id" integer,
	"action_desc" character varying
);


--
-- TOC entry 2717 (class 1247 OID 961124)
-- Name: errarg_object_add; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."errarg_object_add" AS (
	"err_id" integer,
	"errdesc" character varying,
	"class_id" bigint,
	"class_name" character varying,
	"object_id" bigint,
	"object_name" character varying,
	"action_id" integer,
	"action_desc" character varying
);


--
-- TOC entry 2031 (class 1247 OID 33514)
-- Name: nestingrules; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."nestingrules" AS (
	"id_prototype" bigint,
	"id_nested" bigint
);


--
-- TOC entry 2034 (class 1247 OID 33833)
-- Name: path; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."path" AS (
	"id" bigint,
	"id_parent" bigint,
	"id_root" bigint,
	"name" character varying,
	"level" integer
);


--
-- TOC entry 2037 (class 1247 OID 195619)
-- Name: path2; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."path2" AS (
	"id" bigint,
	"timestamp" timestamp without time zone,
	"tablename" character varying,
	"id_parent" bigint,
	"timestamp_parent" timestamp without time zone,
	"id_root" bigint,
	"name" character varying,
	"level" integer
);


--
-- TOC entry 2575 (class 1247 OID 625957)
-- Name: path3; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."path3" AS (
	"id_position" bigint,
	"id_object" bigint,
	"name_object" character varying,
	"id_object_carrier" bigint,
	"name_oject_carrier" character varying,
	"id_class_prop_object_carrier" bigint,
	"name_class_prop_object_carrier" character varying,
	"level" integer
);


--
-- TOC entry 2733 (class 1247 OID 1062812)
-- Name: path4; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."path4" AS (
	"id" bigint,
	"id_parent" bigint,
	"id_root" bigint,
	"id_pos_temp" bigint,
	"name" character varying,
	"level" integer
);


--
-- TOC entry 2699 (class 1247 OID 834016)
-- Name: pyw_errarg; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."pyw_errarg" AS (
	"errid" integer,
	"errdesc" character varying,
	"file_uuid" "uuid",
	"file_count" integer
);


--
-- TOC entry 2781 (class 1247 OID 1166824)
-- Name: range_work_state; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."range_work_state" AS ENUM (
    'free',
    'planed',
    'reserved',
    'expired',
    'completed',
    'processed'
);


--
-- TOC entry 2789 (class 1247 OID 1187540)
-- Name: range_work_type; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."range_work_type" AS ENUM (
    'working',
    'off',
    'overtime',
    'lunch_break',
    'night'
);


--
-- TOC entry 2925 (class 1247 OID 1359278)
-- Name: role_base; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."role_base" AS (
	"oid" "oid",
	"rolinherit" boolean,
	"rolname" character varying,
	"description" "text"
);


--
-- TOC entry 2898 (class 1247 OID 1298528)
-- Name: roles; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."roles" AS (
	"oid" "oid",
	"rolinherit" boolean,
	"rolname" character varying,
	"description" "text"
);


--
-- TOC entry 2040 (class 1247 OID 27036)
-- Name: state; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."state" AS ENUM (
    'on',
    'off',
    'all'
);


--
-- TOC entry 2043 (class 1247 OID 48299)
-- Name: tblcol; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."tblcol" AS (
	"name" character varying,
	"type" character varying,
	"length" integer
);


--
-- TOC entry 2659 (class 1247 OID 793118)
-- Name: tblcol2; Type: TYPE; Schema: bpd; Owner: -
--

CREATE TYPE "bpd"."tblcol2" AS (
	"name" character varying,
	"type" character varying,
	"typcategory" character varying,
	"length" integer
);

--
-- TOC entry 506 (class 1259 OID 854391)
-- Name: doc_category_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."doc_category_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


SET default_table_access_method = "heap";

--
-- TOC entry 493 (class 1259 OID 793650)
-- Name: doc_category; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."doc_category" (
    "id" bigint DEFAULT "nextval"('"bpd"."doc_category_id_seq"'::"regclass") NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(1000) NOT NULL,
    "id_conception" bigint NOT NULL,
    "on" boolean NOT NULL,
    "on_grouping" boolean NOT NULL,
    "timestamp" timestamp without time zone NOT NULL
);


--
-- TOC entry 496 (class 1259 OID 799906)
-- Name: doc_file; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."doc_file" (
    "uuid" "uuid" NOT NULL,
    "id_document" bigint NOT NULL,
    "name" character varying(255) NOT NULL,
    "md5" character varying(50) NOT NULL,
    "timestamp" timestamp without time zone NOT NULL,
    "extension" character varying(10) NOT NULL,
    "catalog" integer NOT NULL,
    "version" character varying(100) NOT NULL,
    "versiondate" "date" NOT NULL,
    "ts_vector" "tsvector",
    "fulltxtsrch_on" boolean NOT NULL,
    "id_conception" bigint NOT NULL,
    "id" bigint NOT NULL,
    "data_length" integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 492 (class 1259 OID 793613)
-- Name: doc_link; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."doc_link" (
    "id" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint NOT NULL,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_document" bigint NOT NULL
);


--
-- TOC entry 495 (class 1259 OID 799897)
-- Name: document; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."document" (
    "id" bigint NOT NULL,
    "name" character varying(255) NOT NULL,
    "desc" character varying(1000) NOT NULL,
    "id_category" bigint NOT NULL,
    "timestamp" timestamp without time zone NOT NULL,
    "regnum" character varying(100) NOT NULL,
    "regdate" "date" NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_parent" bigint NOT NULL,
    "is_inside" boolean GENERATED ALWAYS AS (("id_parent" > 0)) STORED,
    "package_item" boolean GENERATED ALWAYS AS (("id_parent" > 0)) STORED NOT NULL
);


--
-- TOC entry 517 (class 1259 OID 1049143)
-- Name: vdocument; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vdocument" AS
 SELECT "d"."id",
    "d"."id_conception",
    "d"."id_parent",
    "d"."id_category",
    "dc"."on_grouping",
    "d"."package_item",
    "d"."name",
    "d"."desc",
    "d"."regnum",
    "d"."regdate",
    (EXISTS ( SELECT
           FROM "bpd"."doc_link" "dl"
          WHERE ("dl"."id_document" = "d"."id"))) AS "has_link",
    (EXISTS ( SELECT
           FROM "bpd"."document" "doc_child"
          WHERE ("doc_child"."id_parent" = "d"."id"))) AS "has_doc",
    (EXISTS ( SELECT
           FROM "bpd"."doc_file" "df"
          WHERE ("df"."id_document" = "d"."id"))) AS "has_file",
    "d"."timestamp",
    "d"."is_inside"
   FROM ("bpd"."document" "d"
     LEFT JOIN "bpd"."doc_category" "dc" ON (("dc"."id" = "d"."id_category")));

--
-- TOC entry 352 (class 1259 OID 94756)
-- Name: class; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class" (
    "id" bigint NOT NULL,
    "id_con" bigint NOT NULL,
    "id_group" bigint NOT NULL,
    "id_parent" bigint NOT NULL,
    "id_root" bigint NOT NULL,
    "level" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT 'н/д'::"text" NOT NULL,
    "on" boolean NOT NULL,
    "on_extensible" boolean DEFAULT true NOT NULL,
    "on_abstraction" boolean DEFAULT true NOT NULL,
    "id_unit_conversion_rule" integer NOT NULL,
    "barcode_manufacturer" bigint DEFAULT 0 NOT NULL,
    "barcode_local" bigint DEFAULT 0 NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL,
    "id_group_root" bigint DEFAULT 0 NOT NULL,
    "timestamp_parent" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "id_unit" integer DEFAULT '-1'::integer NOT NULL,
    "timestamp_root" timestamp without time zone NOT NULL,
    "timestamp_child_change" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "name_format" character varying(255) DEFAULT 'none'::character varying NOT NULL,
    "quantity_show" boolean DEFAULT true NOT NULL,
    "path_array" bigint[] DEFAULT ARRAY[0] NOT NULL,
    CONSTRAINT "id" CHECK (("id" > 0)),
    CONSTRAINT "id_root" CHECK (("id" >= 0))
);


--
-- TOC entry 309 (class 1259 OID 25694)
-- Name: conception; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."conception" (
    "id" bigint NOT NULL,
    "name" character varying(100) NOT NULL,
    "on" boolean NOT NULL,
    "desc" character varying(2044),
    "default" boolean DEFAULT false NOT NULL,
    "pos_recycle" bigint DEFAULT '-1'::integer NOT NULL,
    "pos_temp_recycle" bigint DEFAULT '-1'::integer NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    "group_recycle" bigint DEFAULT '-1'::integer NOT NULL,
    "on_root_create" boolean DEFAULT true NOT NULL,
    "actcatalog" integer DEFAULT 1 NOT NULL
);


--
-- TOC entry 350 (class 1259 OID 94742)
-- Name: group; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."group" (
    "id" bigint NOT NULL,
    "id_parent" bigint NOT NULL,
    "id_root" bigint NOT NULL,
    "level" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT 'н/д'::"text" NOT NULL,
    "id_con" bigint NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    "on_class" boolean DEFAULT true NOT NULL,
    "timestamp_child_change" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "path_array" bigint[] DEFAULT ARRAY[0] NOT NULL
);


--
-- TOC entry 552 (class 1259 OID 1166600)
-- Name: int_class_path; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class_path" AS
 WITH RECURSIVE "rgroup"("id_path", "id", "id_parent", "level", "path", "spath", "cycle") AS (
         SELECT "rg"."id",
            "rg"."id",
            "rg"."id_parent",
            0,
            ARRAY["rg"."id"] AS "array",
            "concat"("rg"."name") AS "concat",
            false AS "bool"
           FROM "bpd"."group" "rg"
        UNION ALL
         SELECT "rgroup_1"."id_path",
            "rgc"."id",
            "rgc"."id_parent",
            ("rgroup_1"."level" + 1),
            (ARRAY["rgc"."id"] || "rgroup_1"."path"),
            "concat"("rgc"."name", '\', "rgroup_1"."spath") AS "concat",
            ("rgc"."id" = ANY ("rgroup_1"."path"))
           FROM ("bpd"."group" "rgc"
             JOIN "rgroup" "rgroup_1" ON (("rgroup_1"."id_parent" = "rgc"."id")))
          WHERE (NOT "rgroup_1"."cycle")
        ), "grouppath"("id_path", "spath") AS (
         SELECT DISTINCT "rg"."id_path",
            "first_value"("rg"."spath") OVER (PARTITION BY "rg"."id_path" ORDER BY "rg"."level" DESC) AS "first_value"
           FROM "rgroup" "rg"
        ), "rclass"("id_path", "id", "id_parent", "level", "path", "spath", "cycle") AS (
         SELECT "rc"."id",
            "rc"."id",
            "rc"."id_parent",
            0,
            ARRAY["rc"."id"] AS "array",
            "concat"("rc"."name") AS "concat",
            false AS "bool"
           FROM ONLY "bpd"."class" "rc"
        UNION ALL
         SELECT "rclass_1"."id_path",
            "rcc"."id",
            "rcc"."id_parent",
            ("rclass_1"."level" + 1),
            (ARRAY["rcc"."id"] || "rclass_1"."path"),
            "concat"("rcc"."name", '\', "rclass_1"."spath") AS "concat",
            ("rcc"."id" = ANY ("rclass_1"."path"))
           FROM (ONLY "bpd"."class" "rcc"
             JOIN "rclass" "rclass_1" ON (("rclass_1"."id_parent" = "rcc"."id")))
          WHERE (NOT "rclass_1"."cycle")
        ), "classpath"("id_path", "spath") AS (
         SELECT DISTINCT "rc"."id_path",
            "first_value"("rc"."spath") OVER (PARTITION BY "rc"."id_path" ORDER BY "rc"."level" DESC) AS "first_value"
           FROM "rclass" "rc"
        )
 SELECT "c"."id",
    "concat"(COALESCE("gp"."spath", ''::"text"), '\\', COALESCE("cp"."spath", ''::"text")) AS "path"
   FROM ((ONLY "bpd"."class" "c"
     LEFT JOIN "grouppath" "gp" ON (("gp"."id_path" = "c"."id_group")))
     LEFT JOIN "classpath" "cp" ON (("cp"."id_path" = "c"."id")));


--
-- TOC entry 502 (class 1259 OID 827688)
-- Name: int_class_ready; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class_ready" AS
SELECT
    NULL::bigint AS "id",
    NULL::boolean AS "ready";


--
-- TOC entry 368 (class 1259 OID 120737)
-- Name: object_general_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."object_general_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 354 (class 1259 OID 94786)
-- Name: object; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object" (
    "id" bigint DEFAULT "nextval"('"bpd"."object_general_id_seq"'::"regclass") NOT NULL,
    "id_class" bigint NOT NULL,
    "id_position" bigint DEFAULT '-1'::integer NOT NULL,
    "bquantity" numeric NOT NULL,
    "id_position_root" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "barcode_unit" bigint DEFAULT 0 NOT NULL,
    "id_unit_conversion_rule" integer NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL,
    "timestamp_class" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "name" character varying(255) NOT NULL,
    "id_class_root" bigint NOT NULL,
    "id_group" bigint NOT NULL,
    "id_group_root" bigint NOT NULL,
    "id_object_carrier" bigint DEFAULT '-1'::integer NOT NULL,
    "desc" character varying(2044) DEFAULT 'н/д'::character varying NOT NULL,
    "id_class_prop_object_carrier" bigint DEFAULT '-1'::integer NOT NULL,
    "id_pos_temp_prop" bigint DEFAULT '-1'::integer NOT NULL,
    "is_inside" boolean GENERATED ALWAYS AS ((("id_object_carrier" > 0) OR ("id_pos_temp_prop" > 0))) STORED,
    "mc" numeric DEFAULT 0 NOT NULL,
    CONSTRAINT "check_self_integration" CHECK (("id" <> "id_object_carrier"))
);


--
-- TOC entry 562 (class 1259 OID 1209270)
-- Name: vclass; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass" AS
 SELECT "c"."id",
    "c"."timestamp",
    true AS "has_active",
    "c"."timestamp_child_change",
    "c"."id_con",
    "c"."id_group",
    "c"."id_group_root",
    "c"."id_parent",
    "c"."timestamp_parent",
    "c"."id_root",
    "c"."timestamp_root",
    "c"."level",
    ("c"."level" = 0) AS "is_root",
    (("c"."tableoid")::"regclass")::character varying AS "tablename",
    "c"."name",
    "c"."name_format",
    "c"."quantity_show",
    "c"."desc",
    "c"."on",
    "c"."on_extensible",
    "c"."on_abstraction",
    "c"."id_unit",
    "c"."id_unit_conversion_rule",
    "c"."barcode_manufacturer",
    "c"."barcode_local",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE ("cc"."id_parent" = "c"."id"))) AS "include_child_class",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "co"
          WHERE (("co"."id_class" = "c"."id") AND ("co"."timestamp_class" = "c"."timestamp")))) AS "include_child_object",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND (NOT "cc"."on_abstraction")))) AS "include_child_real_class",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND "cc"."on_abstraction"))) AS "include_child_abstract_class",
    ( SELECT "count"(1) AS "count"
           FROM ONLY "bpd"."class" "cc"
          WHERE ("cc"."id_parent" = "c"."id")) AS "child_count",
    ("con"."group_recycle" = "c"."id_group_root") AS "in_recycle",
    "c"."on_freeze",
    "c_ready"."ready",
    "c_path"."path"
   FROM (((ONLY "bpd"."class" "c"
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "c"."id_con")))
     LEFT JOIN "bpd"."int_class_ready" "c_ready" ON (("c_ready"."id" = "c"."id")))
     LEFT JOIN "bpd"."int_class_path" "c_path" ON (("c_path"."id" = "c"."id")));

--
-- TOC entry 365 (class 1259 OID 116113)
-- Name: class_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop" (
    "id" bigint NOT NULL,
    "id_prop_inherit" bigint DEFAULT '-1'::integer NOT NULL,
    "id_class" bigint DEFAULT 0 NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "id_data_type" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) NOT NULL,
    "inheritance" boolean NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL,
    "on_inherit" boolean NOT NULL,
    "on_override" boolean NOT NULL,
    "id_prop_type" integer NOT NULL,
    "timestamp_class_inherit" timestamp without time zone,
    "id_conception" bigint NOT NULL,
    "id_prop_definition" bigint DEFAULT '-1'::integer NOT NULL,
    "id_class_definition" bigint DEFAULT '-1'::integer NOT NULL,
    "timestamp_class_definition" timestamp without time zone,
    "tag" character varying DEFAULT ''::character varying NOT NULL
);


--
-- TOC entry 423 (class 1259 OID 462267)
-- Name: class_prop_enum_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_enum_val" (
    "id_class_prop" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "id_prop_enum" bigint NOT NULL,
    "id_prop_enum_val" bigint,
    "inheritance" boolean NOT NULL
);


--
-- TOC entry 433 (class 1259 OID 514851)
-- Name: class_prop_link_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_link_val" (
    "id_class_prop" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint,
    "inheritance" boolean NOT NULL,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer
);


--
-- TOC entry 390 (class 1259 OID 203159)
-- Name: class_prop_obj_val_class; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_obj_val_class" (
    "id" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "id_class_prop" bigint NOT NULL,
    "id_class_val" bigint,
    "bquantity_max" numeric DEFAULT '-1'::integer NOT NULL,
    "bquantity_min" numeric DEFAULT '-1'::integer NOT NULL,
    "timestamp_class_val" timestamp without time zone,
    "embed_mode" integer DEFAULT 0 NOT NULL,
    "embed_single" boolean DEFAULT true NOT NULL,
    "embed_class_real_id" bigint DEFAULT '-1'::integer NOT NULL,
    "id_unit_conversion_rule" integer DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 375 (class 1259 OID 159939)
-- Name: class_prop_user_big_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_user_big_val" (
    "id_class_prop" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "val_text" "text",
    "val_bytea" "bytea",
    "val_json" "json",
    "max_val" numeric DEFAULT 500 NOT NULL,
    "id_class" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "inheritance" boolean NOT NULL,
    "min_val" numeric DEFAULT 1 NOT NULL,
    "max_on" boolean DEFAULT false NOT NULL,
    "min_on" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 373 (class 1259 OID 159923)
-- Name: class_prop_user_small_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_user_small_val" (
    "id_class_prop" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_real" real,
    "val_numeric" numeric,
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_timestamp" timestamp without time zone,
    "val_money" "money",
    "val_double" double precision,
    "max_val" numeric NOT NULL,
    "round" integer NOT NULL,
    "id_class" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "inheritance" boolean NOT NULL,
    "val_bigint" bigint,
    "min_val" numeric DEFAULT 0 NOT NULL,
    "max_on" boolean DEFAULT false NOT NULL,
    "min_on" boolean DEFAULT false NOT NULL,
    "round_on" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 472 (class 1259 OID 637740)
-- Name: global_prop_link_class_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."global_prop_link_class_prop" (
    "id_conception" bigint NOT NULL,
    "id_global_prop" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "id_class_prop_definition" bigint NOT NULL
);


--
-- TOC entry 422 (class 1259 OID 461883)
-- Name: prop_enum_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_enum_val" (
    "id" bigint NOT NULL,
    "id_prop_enum" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "val_numeric" numeric,
    "val_varchar" character varying(100),
    "id_object_reference" bigint DEFAULT '-1'::integer NOT NULL,
    "timestamp" timestamp without time zone NOT NULL,
    "sort" bigint DEFAULT 1 NOT NULL
);


--
-- TOC entry 485 (class 1259 OID 791697)
-- Name: vclass_prop; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop" AS
 SELECT "cp"."id",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."on_inherit",
    "cp"."inheritance",
    "cp"."id_prop_inherit",
    COALESCE("cp"."timestamp_class_inherit", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_inherit",
    "cp"."id_prop_type",
    "cp"."id_data_type",
    "cp"."name",
    "cp"."desc",
    "cp"."sort",
    "cp"."on_override",
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END
            WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
            WHEN 4 THEN (COALESCE("lv"."id_entity_instance", (0)::bigint) > 0)
            ELSE false
        END AS "on_val",
    COALESCE(
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN "sv"."val_varchar"
                WHEN 2 THEN ("sv"."val_int")::character varying
                WHEN 3 THEN ("sv"."val_numeric")::character varying
                WHEN 4 THEN ("sv"."val_real")::character varying
                WHEN 5 THEN ("sv"."val_double")::character varying
                WHEN 6 THEN (("sv"."val_money")::numeric)::character varying
                WHEN 7 THEN 'Текст'::character varying
                WHEN 8 THEN 'Изображение'::character varying
                WHEN 9 THEN ("sv"."val_boolean")::character varying
                WHEN 10 THEN ("sv"."val_date")::character varying
                WHEN 11 THEN ("sv"."val_time")::character varying
                WHEN 12 THEN ("sv"."val_interval")::character varying
                WHEN 13 THEN ("sv"."val_timestamp")::character varying
                WHEN 14 THEN 'Json'::character varying
                WHEN 15 THEN ("sv"."val_bigint")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN "pev"."val_varchar"
                WHEN 3 THEN ("pev"."val_numeric")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 3 THEN 'Объект'::character varying
            WHEN 4 THEN 'Ссылка'::character varying
            ELSE 'н/д'::character varying
        END, 'н/д'::character varying) AS "string_val",
    (("cp"."tableoid")::"regclass")::character varying AS "tablename",
        CASE "cp"."id_prop_type"
            WHEN 1 THEN (
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END OR "cp"."on_override")
            WHEN 2 THEN (
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END OR ("cp"."on_override" AND (COALESCE("ev"."id_prop_enum", (0)::bigint) > 0)))
            WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
            WHEN 4 THEN ((COALESCE("lv"."id_entity_instance", (0)::bigint) > 0) OR ("cp"."on_override" AND ("lv"."id_entity" IS NOT NULL)))
            ELSE false
        END AS "ready",
    "cp"."id_conception",
    "cp"."id_class_definition",
    "cp"."timestamp_class_definition",
    "cp"."id_prop_definition",
        CASE "cp"."inheritance"
            WHEN true THEN COALESCE("cp_inherit"."on_override", false)
            WHEN false THEN "cp"."on_override"
            ELSE NULL::boolean
        END AS "on_override_prop_inherit",
    ("lgp"."id_global_prop" IS NOT NULL) AS "on_global",
    COALESCE("lgp"."id_global_prop", (0)::bigint) AS "id_global_prop",
    "cp"."tag"
   FROM (((((((((ONLY "bpd"."class_prop" "cp"
     LEFT JOIN ONLY "bpd"."class_prop" "cp_inherit" ON (("cp_inherit"."id" = "cp"."id_prop_inherit")))
     LEFT JOIN ONLY "bpd"."class_prop_user_small_val" "sv" ON (("sv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class_prop_user_big_val" "bv" ON (("bv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class_prop_enum_val" "ev" ON (("ev"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")))
     LEFT JOIN ONLY "bpd"."class_prop_link_val" "lv" ON (("lv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class_prop_obj_val_class" "ov" ON (("ov"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class" "class_val" ON (("class_val"."id" = "ov"."id_class_val")))
     LEFT JOIN "bpd"."global_prop_link_class_prop" "lgp" ON (("lgp"."id_class_prop_definition" = "cp"."id_prop_definition")))
  ORDER BY "cp"."sort", "cp"."name";


--
-- TOC entry 728 (class 1255 OID 1082641)
-- Name: int_cast_vclass_prop_to_cclass_prop("bpd"."vclass_prop"); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_cast_vclass_prop_to_cclass_prop"("ivclass_prop" "bpd"."vclass_prop") RETURNS "bpd"."cclass_prop"
    LANGUAGE "plpgsql" IMMUTABLE PARALLEL SAFE
    AS $$
DECLARE
 result  "bpd"."cclass_prop"%ROWTYPE;
BEGIN
     result = ivclass_prop;
     RETURN result;
END;
$$;


--
-- TOC entry 523 (class 1259 OID 1082643)
-- Name: int_class_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class_ext" AS
 SELECT "cp"."id_class" AS "id",
    "array_agg"(("cp".*)::"bpd"."cclass_prop" ORDER BY "cp"."sort") AS "property_list"
   FROM "bpd"."vclass_prop" "cp"
  GROUP BY "cp"."id_class";


--
-- TOC entry 563 (class 1259 OID 1209275)
-- Name: vclass_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_ext" AS
 SELECT "c"."id",
    "c"."timestamp",
    true AS "has_active",
    "c"."timestamp_child_change",
    "c"."id_con",
    "c"."id_group",
    "c"."id_group_root",
    "c"."id_parent",
    "c"."timestamp_parent",
    "c"."id_root",
    "c"."timestamp_root",
    "c"."level",
    ("c"."level" = 0) AS "is_root",
    (("c"."tableoid")::"regclass")::character varying AS "tablename",
    "c"."name",
    "c"."name_format",
    "c"."quantity_show",
    "c"."desc",
    "c"."on",
    "c"."on_extensible",
    "c"."on_abstraction",
    "c"."id_unit",
    "c"."id_unit_conversion_rule",
    "c"."barcode_manufacturer",
    "c"."barcode_local",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE ("cc"."id_parent" = "c"."id"))) AS "include_child_class",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "co"
          WHERE (("co"."id_class" = "c"."id") AND ("co"."timestamp_class" = "c"."timestamp")))) AS "include_child_object",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND (NOT "cc"."on_abstraction")))) AS "include_child_real_class",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND "cc"."on_abstraction"))) AS "include_child_abstract_class",
    ( SELECT "count"(1) AS "count"
           FROM ONLY "bpd"."class" "cc"
          WHERE ("cc"."id_parent" = "c"."id")) AS "child_count",
    ("con"."group_recycle" = "c"."id_group_root") AS "in_recycle",
    "c"."on_freeze",
    "cp_list"."property_list",
    "c_ready"."ready",
    "c_path"."path"
   FROM ((((ONLY "bpd"."class" "c"
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "c"."id_con")))
     LEFT JOIN "bpd"."int_class_ext" "cp_list" ON (("cp_list"."id" = "c"."id")))
     LEFT JOIN "bpd"."int_class_ready" "c_ready" ON (("c_ready"."id" = "c"."id")))
     LEFT JOIN "bpd"."int_class_path" "c_path" ON (("c_path"."id" = "c"."id")));


--
-- TOC entry 1023 (class 1255 OID 1435561)
-- Name: class_act_base_ext_allowed_by_id_group(bigint, bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_base_ext_allowed_by_id_group"("iid_group" bigint, "iid_position" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" SECURITY DEFINER
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
  --**************************************************************************
    --ДАТА: 24.08.2020
    --Автор: Иванов Д.Ю.
    --Версия: 2.0
    --Описание: Функция возвращает список активных разрешенных базовых классов по идентификатору группы
    --**************************************************************************
     pos_found "bpd"."position"%ROWTYPE; --Позиция для которой определяется список разрешенных групп на основе разрешения уровня 1 группа на шаблон 
     on_rulel2_class_on_position BOOLEAN; --Для позиции активирован список разрешающих правил уровня 2 класс на позицию
BEGIN
    SELECT * INTO pos_found FROM "bpd"."position" WHERE id = iid_position;
    IF pos_found IS NOT NULL THEN 
        --Проверка активации списка разрешающих правил уровня 2 класс на позицию для указанной позиции
        on_rulel2_class_on_position = EXISTS(SELECT 1 FROM "bpd"."rulel2_class_on_position" rl2 
                                                WHERE rl2.id_position = iid_position);
        IF on_rulel2_class_on_position THEN
            RETURN QUERY 
                SELECT vc.* FROM "bpd"."vclass_ext" vc
                            JOIN "bpd"."rulel2_class_on_position" rl2 ON rl2.id_class = vc.id
                                WHERE (rl2.id_position = iid_position) AND  vc.is_root AND (vc.id_group = iid_group)
                                ORDER BY  "name";
        ELSE
            RETURN QUERY 
                SELECT rl1.* FROM "bpd"."class_ext_allowed_rl1_by_id_position"(iid_position) rl1
                WHERE  rl1.is_root AND (rl1.id_group = iid_group)
                ORDER BY  "name";
        END IF;
    END IF;
END;
$$;





--
-- TOC entry 1043 (class 1255 OID 1436304)
-- Name: class_act_ext_allowed_rl1_by_id_position(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_ext_allowed_rl1_by_id_position"("iid_position" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
	--**************************************************************************
    --ДАТА: 15.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 2.0
    --Описание: Функция возвращает список активных представлений расширенных классов на основе разрешения уровня 1 группа на шаблон по идентификатору позиции
    --**************************************************************************
   
    pos_found "bpd"."position"%ROWTYPE; --Позиция для которой определяется список разрешенных групп на основе разрешения уровня 1 группа на шаблон 
BEGIN
    SELECT * INTO pos_found FROM "bpd"."position" WHERE id = iid_position;
    IF pos_found IS NOT NULL THEN 
           
        RETURN QUERY 
            (WITH 
                RECURSIVE rgroup ("id", "id_parent", "patch", "cycle") AS 
                (SELECT 
                    rg."id",
                    rg."id_parent",
                    ARRAY [rg."id"],
                    false
                FROM "bpd"."group" rg
                JOIN "bpd"."rulel1_group_on_pos_temp" rl1 ON rl1.id_group = rg.id
                WHERE rl1.id_pos_temp =  pos_found.id_pos_temp
                UNION all
                SELECT 
                    rgc."id",
                    rgc."id_parent",
                    rgroup."patch" || ARRAY [rgc."id"],    
                    rgc."id" = ANY(rgroup."patch")
                FROM "bpd"."group" rgc
                JOIN rgroup ON rgroup."id" = rgc."id_parent"
                WHERE NOT "cycle"
                )
                SELECT c.* FROM "bpd"."vclass_ext" c 
                    WHERE
                    EXISTS(SELECT FROM rgroup WHERE c.id_group = rgroup.id) )
        ORDER BY "name";
    END IF;
END;
$$;

--
-- TOC entry 1042 (class 1255 OID 1436282)
-- Name: class_act_ext_by_id(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_ext_by_id"("iid" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "sql" STABLE SECURITY DEFINER ROWS 10 PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
	--**************************************************************************
    --ДАТА: 15.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция возвращает активное представление расширенного класса по идентификатору 
    --**************************************************************************
    SELECT * FROM bpd.vclass_ext WHERE "id" = iid;
$$;


--
-- TOC entry 1058 (class 1255 OID 1437220)
-- Name: class_act_ext_by_id_conception_msk_name(bigint, character varying); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_ext_by_id_conception_msk_name"("iid_conception" bigint, "name_mask" character varying) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
 	--**************************************************************************
    --ДАТА: 15.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 2.0
    --Описание: Функция возвращает список активных представлений расширенных классов по маске имени 
    --**************************************************************************
    class_array BIGINT[]; --Массив элементов
BEGIN

    class_array = (SELECT array_agg(c.id) FROM bpd.class c WHERE  (c.id_con = iid_conception) AND  (LOWER(c.name) LIKE concat('%', LOWER(name_mask), '%')));
    
    RETURN QUERY SELECT 
    c.id,
    c."timestamp",
    true AS has_active,
    c.timestamp_child_change,
    c.id_con,
    c.id_group,
    c.id_group_root,
    c.id_parent,
    c.timestamp_parent,
    c.id_root,
    c.timestamp_root,
    c.level,
    (c.level = 0) AS is_root,
    ((c.tableoid)::regclass)::character varying AS tablename,
    c.name,
    c.name_format,
    c.quantity_show,
    c."desc",
    c."on",
    c.on_extensible,
    c.on_abstraction,
    c.id_unit,
    c.id_unit_conversion_rule,
    c.barcode_manufacturer,
    c.barcode_local,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id))) AS include_child_class,
    (EXISTS ( SELECT 1
           FROM bpd.object co
          WHERE ((co.id_class = c.id) AND (co.timestamp_class = c."timestamp")))) AS include_child_object,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND (NOT cc.on_abstraction)))) AS include_child_real_class,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND cc.on_abstraction))) AS include_child_abstract_class,
    ( SELECT count(1) AS count
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id)) AS child_count,
    (con.group_recycle = c.id_group_root) AS in_recycle,
    c.on_freeze,
    cp_list.property_list,
    c_ready.ready,
    c_path.path
   FROM ONLY bpd.class c
     LEFT JOIN bpd.conception con ON (con.id = c.id_con)
     LEFT JOIN "bpd"."int_class_ext_prop_by_id_class_array"(class_array) cp_list ON ((cp_list.id = c.id))
     LEFT JOIN "bpd"."int_class_ready_by_id_class_array"(class_array) c_ready ON ((c_ready.id = c.id))
     LEFT JOIN "bpd"."int_class_path_by_id_class_array"(class_array) c_path ON ((c_path.id = c.id))
   WHERE c."id" = ANY(class_array)  
     
     ORDER BY c.name;             
END;
$$;


--
-- TOC entry 1057 (class 1255 OID 1437216)
-- Name: class_act_ext_by_id_global_prop(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_ext_by_id_global_prop"("iid_global_prop" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
    --**************************************************************************
    --ДАТА: 24.08.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция возвращает список активных представлений расширенных классов по идентификатору глобального свойства
    --**************************************************************************
    class_array BIGINT[]; --Массив объектов
BEGIN
    class_array = (SELECT array_agg(c.id) FROM ONLY bpd.class c 
                        WHERE EXISTS(SELECT FROM "bpd"."global_prop_link_class_prop" gpl 
                        WHERE (gpl."id_global_prop" = iid_global_prop) AND (gpl."id_class" = c.id)));

    RETURN QUERY  
    SELECT 
    c.id,
    c."timestamp",
    true AS has_active,
    c.timestamp_child_change,
    c.id_con,
    c.id_group,
    c.id_group_root,
    c.id_parent,
    c.timestamp_parent,
    c.id_root,
    c.timestamp_root,
    c.level,
    (c.level = 0) AS is_root,
    ((c.tableoid)::regclass)::character varying AS tablename,
    c.name,
    c.name_format,
    c.quantity_show,
    c."desc",
    c."on",
    c.on_extensible,
    c.on_abstraction,
    c.id_unit,
    c.id_unit_conversion_rule,
    c.barcode_manufacturer,
    c.barcode_local,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id))) AS include_child_class,
    (EXISTS ( SELECT 1
           FROM bpd.object co
          WHERE ((co.id_class = c.id) AND (co.timestamp_class = c."timestamp")))) AS include_child_object,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND (NOT cc.on_abstraction)))) AS include_child_real_class,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND cc.on_abstraction))) AS include_child_abstract_class,
    ( SELECT count(1) AS count
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id)) AS child_count,
    (con.group_recycle = c.id_group_root) AS in_recycle,
    c.on_freeze,
    cp_list.property_list,
    c_ready.ready,
    c_path.path
   FROM ((((ONLY bpd.class c
     LEFT JOIN bpd.conception con ON ((con.id = c.id_con)))
     LEFT JOIN "bpd"."int_class_ext_prop_by_id_class_array"(class_array) cp_list ON ((cp_list.id = c.id)))
     LEFT JOIN "bpd"."int_class_ready_by_id_class_array"(class_array) c_ready ON ((c_ready.id = c.id)))
     LEFT JOIN "bpd"."int_class_path_by_id_class_array"(class_array) c_path ON ((c_path.id = c.id)))
    WHERE c.id = ANY(class_array)
    ORDER BY "name";
END;
$$;


--
-- TOC entry 1054 (class 1255 OID 1437211)
-- Name: class_act_ext_by_id_group(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_ext_by_id_group"("iid_group" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
    --**************************************************************************
    --ДАТА: 25.05.2021
    --Автор: Иванов Д.Ю.
    --Версия: 3.0
    --Описание: Функция возвращает список активных представлений расширенных классов по идентификатору группы
    --**************************************************************************
    class_array BIGINT[]; --Массив объектов
BEGIN
    class_array = (SELECT array_agg(c.id) FROM ONLY bpd.class c WHERE (c.id_group = iid_group) AND c."level" = 0);
    
    RETURN QUERY  
    SELECT 
    c.id,
    c."timestamp",
    true AS has_active,
    c.timestamp_child_change,
    c.id_con,
    c.id_group,
    c.id_group_root,
    c.id_parent,
    c.timestamp_parent,
    c.id_root,
    c.timestamp_root,
    c.level,
    (c.level = 0) AS is_root,
    ((c.tableoid)::regclass)::character varying AS tablename,
    c.name,
    c.name_format,
    c.quantity_show,
    c."desc",
    c."on",
    c.on_extensible,
    c.on_abstraction,
    c.id_unit,
    c.id_unit_conversion_rule,
    c.barcode_manufacturer,
    c.barcode_local,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id))) AS include_child_class,
    (EXISTS ( SELECT 1
           FROM bpd.object co
          WHERE ((co.id_class = c.id) AND (co.timestamp_class = c."timestamp")))) AS include_child_object,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND (NOT cc.on_abstraction)))) AS include_child_real_class,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND cc.on_abstraction))) AS include_child_abstract_class,
    ( SELECT count(1) AS count
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id)) AS child_count,
    (con.group_recycle = c.id_group_root) AS in_recycle,
    c.on_freeze,
    cp_list.property_list,
    c_ready.ready,
    c_path.path
   FROM ((((ONLY bpd.class c
     LEFT JOIN bpd.conception con ON ((con.id = c.id_con)))
     LEFT JOIN "bpd"."int_class_ext_prop_by_id_class_array"(class_array) cp_list ON ((cp_list.id = c.id)))
     LEFT JOIN "bpd"."int_class_ready_by_id_class_array"(class_array) c_ready ON ((c_ready.id = c.id)))
     LEFT JOIN "bpd"."int_class_path_by_id_class_array"(class_array) c_path ON ((c_path.id = c.id)))
    WHERE c.id = ANY(class_array)
    ORDER BY "name";    
END;
$$;

--
-- TOC entry 1044 (class 1255 OID 1437070)
-- Name: class_act_ext_by_id_parent(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_ext_by_id_parent"("iid_parent" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
    class_array BIGINT[]; --Массив объектов
BEGIN
    class_array = (SELECT array_agg(c.id) FROM ONLY bpd.class c WHERE c.id_parent = iid_parent);

    RETURN QUERY  
    SELECT 
    c.id,
    c."timestamp",
    true AS has_active,
    c.timestamp_child_change,
    c.id_con,
    c.id_group,
    c.id_group_root,
    c.id_parent,
    c.timestamp_parent,
    c.id_root,
    c.timestamp_root,
    c.level,
    (c.level = 0) AS is_root,
    ((c.tableoid)::regclass)::character varying AS tablename,
    c.name,
    c.name_format,
    c.quantity_show,
    c."desc",
    c."on",
    c.on_extensible,
    c.on_abstraction,
    c.id_unit,
    c.id_unit_conversion_rule,
    c.barcode_manufacturer,
    c.barcode_local,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id))) AS include_child_class,
    (EXISTS ( SELECT 1
           FROM bpd.object co
          WHERE ((co.id_class = c.id) AND (co.timestamp_class = c."timestamp")))) AS include_child_object,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND (NOT cc.on_abstraction)))) AS include_child_real_class,
    (EXISTS ( SELECT 1
           FROM ONLY bpd.class cc
          WHERE ((cc.id_parent = c.id) AND cc.on_abstraction))) AS include_child_abstract_class,
    ( SELECT count(1) AS count
           FROM ONLY bpd.class cc
          WHERE (cc.id_parent = c.id)) AS child_count,
    (con.group_recycle = c.id_group_root) AS in_recycle,
    c.on_freeze,
    cp_list.property_list,
    c_ready.ready,
    c_path.path
   FROM ((((ONLY bpd.class c
     LEFT JOIN bpd.conception con ON ((con.id = c.id_con)))
     LEFT JOIN "bpd"."int_class_ext_prop_by_id_class_array"(class_array) cp_list ON ((cp_list.id = c.id)))
     LEFT JOIN "bpd"."int_class_ready_by_id_class_array"(class_array) c_ready ON ((c_ready.id = c.id)))
     LEFT JOIN "bpd"."int_class_path_by_id_class_array"(class_array) c_path ON ((c_path.id = c.id)))
    WHERE c.id = ANY(class_array)
    ORDER BY "name";
END;
$$;

--
-- TOC entry 1092 (class 1255 OID 1437614)
-- Name: class_act_real_ext_by_id_group(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_act_real_ext_by_id_group"("iid_group" bigint) RETURNS SETOF "bpd"."vclass_ext"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
 	--**************************************************************************
    --ДАТА: 15.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 2.0
    --Описание: Функция возвращает список активных представлений вещественных расширенных классов по идентификатору группы
    --**************************************************************************
BEGIN
    RETURN QUERY  SELECT * FROM bpd.vclass_ext WHERE "id_group" = iid_group AND "on_abstraction" = FALSE  ORDER BY "name";
END;
$$;


--
-- TOC entry 1101 (class 1255 OID 1437647)
-- Name: class_allowed_rl2_for_group_by_id_position(bigint, bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."class_allowed_rl2_for_group_by_id_position"("iid_position" bigint, "iid_group" bigint) RETURNS SETOF "bpd"."vclass"
    LANGUAGE "plpgsql" STABLE SECURITY DEFINER PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $$
DECLARE
	--**************************************************************************
    --ДАТА: 15.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 2.0
    --Описание: Функция возвращает список разрешенных активных классов с учетом разрешения уровня 2 класс на позицию для выбранной группы по идентификатору позиции
    --**************************************************************************
    
    pos_found "bpd"."position"%ROWTYPE; --Позиция для которой определяется список разрешенных групп на основе разрешения уровня 1 группа на шаблон 
    on_rulel2_class_on_position BOOLEAN; --Для позиции активирован список разрешающих правил уровня 2 класс на позицию
BEGIN
     
    SELECT * INTO pos_found FROM "bpd"."position" WHERE id = iid_position;
    IF pos_found IS NOT NULL THEN 
        --Проверка активации списка разрешающих правил уровня 2 класс на позицию для указанной позиции
        on_rulel2_class_on_position = EXISTS(SELECT 1 FROM "bpd"."rulel2_class_on_position" rl2 
                                                WHERE rl2.id_position = iid_position);
        IF on_rulel2_class_on_position THEN
            RETURN QUERY 
                    SELECT vc.* FROM "bpd"."vclass" vc
                            JOIN "bpd"."rulel2_class_on_position" rl2 ON rl2.id_class = vc.id
                                WHERE rl2.id_position = pos_found.id AND vc.id_group = iid_group;
        ELSE
                RETURN QUERY 
                    SELECT rl1.* FROM "bpd"."class_act_by_id_group"(iid_group) rl1;
        END IF;
    END IF;
END;
$$;

--
-- TOC entry 441 (class 1259 OID 554330)
-- Name: pattern_string; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pattern_string" (
    "sort" integer NOT NULL,
    "pattern" character varying(50) NOT NULL,
    "name" character varying(50) DEFAULT 'none'::character varying NOT NULL
);


--
-- TOC entry 442 (class 1259 OID 554604)
-- Name: vpattern_string; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpattern_string" AS
 SELECT "pattern_string"."sort",
    "pattern_string"."pattern",
    "pattern_string"."name"
   FROM "bpd"."pattern_string";

CREATE TABLE "bpd"."object_prop_enum_val" (
    "id_object" bigint NOT NULL,
    "id_class_prop" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "id_prop_enum" bigint NOT NULL,
    "id_prop_enum_val" bigint
);


--
-- TOC entry 452 (class 1259 OID 611833)
-- Name: pos_temp_prop_enum_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_prop_enum_val" (
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_prop_enum" bigint NOT NULL,
    "id_prop_enum_val" bigint
);


--
-- TOC entry 448 (class 1259 OID 611727)
-- Name: position_prop_enum_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."position_prop_enum_val" (
    "id_position" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_prop_enum" bigint NOT NULL,
    "id_prop_enum_val" bigint
);


--
-- TOC entry 420 (class 1259 OID 461875)
-- Name: prop_enum; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_enum" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(100) NOT NULL,
    "id_prop_enum_use_area" integer NOT NULL,
    "timestamp" timestamp without time zone NOT NULL
);


--
-- TOC entry 429 (class 1259 OID 509949)
-- Name: vprop_enum_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vprop_enum_val" AS
 SELECT "pev"."id_conception",
    "pev"."id_prop_enum",
    "pe"."id_prop_enum_use_area",
    "pev"."id" AS "id_prop_enum_val",
    "pe"."id_data_type",
    COALESCE("pev"."val_numeric", (0)::numeric) AS "val_numeric",
    COALESCE("pev"."val_varchar", ''::character varying(100)) AS "val_varchar",
    ((EXISTS ( SELECT 1
           FROM "bpd"."class_prop_enum_val" "cpev"
          WHERE ("cpev"."id_prop_enum_val" = "pev"."id"))) OR (EXISTS ( SELECT 1
           FROM "bpd"."object_prop_enum_val" "opev"
          WHERE ("opev"."id_prop_enum_val" = "pev"."id"))) OR (EXISTS ( SELECT 1
           FROM "bpd"."pos_temp_prop_enum_val" "ptpev"
          WHERE ("ptpev"."id_prop_enum_val" = "pev"."id"))) OR (EXISTS ( SELECT 1
           FROM "bpd"."position_prop_enum_val" "ppev"
          WHERE ("ppev"."id_prop_enum_val" = "pev"."id")))) AS "is_use",
    "pev"."id_object_reference",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "o"
          WHERE ("o"."id" = "pev"."id_object_reference"))) AS "has_object_reference",
    "pe"."timestamp" AS "timestamp_prop_enum",
    "pev"."timestamp",
    "pev"."sort"
   FROM ("bpd"."prop_enum_val" "pev"
     JOIN "bpd"."prop_enum" "pe" ON (("pe"."id" = "pev"."id_prop_enum")));


--
-- TOC entry 430 (class 1259 OID 509954)
-- Name: vclass_prop_enum_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_enum_val" AS
 SELECT "cp"."id_conception",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."id_prop_enum", ('-1'::integer)::bigint) AS "id_prop_enum",
    COALESCE("cv"."id_prop_enum_val", ('-1'::integer)::bigint) AS "id_prop_enum_val",
    COALESCE("pev"."val_numeric", (0)::numeric) AS "val_numeric",
    COALESCE("pev"."val_varchar", ''::character varying(100)) AS "val_varchar",
    COALESCE("pev"."is_use", false) AS "is_use",
    COALESCE("pev"."id_object_reference", ('-1'::integer)::bigint) AS "id_object_reference",
    COALESCE("pev"."has_object_reference", false) AS "has_object_reference",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
            WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
            ELSE false
        END AS "on_val"
   FROM ((ONLY "bpd"."class_prop" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_enum_val" "cv" ON (("cv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."vprop_enum_val" "pev" ON (("pev"."id_prop_enum_val" = "cv"."id_prop_enum_val")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[1, 3, 15])) AND ("cp"."id_prop_type" = 2));


--
-- TOC entry 436 (class 1259 OID 519091)
-- Name: vclass_prop_link_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_link_val" AS
 SELECT "cp"."id_conception",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."id_entity", 0) AS "id_entity",
    COALESCE("cv"."id_entity_instance", (0)::bigint) AS "id_entity_instance",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
    (COALESCE("cv"."id_entity_instance", (0)::bigint) > 0) AS "on_val",
    COALESCE("cv"."id_sub_entity_instance", ('-1'::integer)::bigint) AS "id_sub_entity_instance"
   FROM (ONLY "bpd"."class_prop" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_link_val" "cv" ON (("cv"."id_class_prop" = "cp"."id")))
  WHERE (("cp"."id_data_type" = 15) AND ("cp"."id_prop_type" = 4));

--
-- TOC entry 439 (class 1259 OID 533130)
-- Name: vclass_prop_object_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_object_val" AS
 SELECT "cp"."id" AS "id_class_prop",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."id", ('-1'::integer)::bigint) AS "id",
    ("class_val"."id" IS NOT NULL) AS "on_val",
    COALESCE("cv"."id_class_val", ('-1'::integer)::bigint) AS "id_class_val",
    COALESCE("cv"."timestamp_class_val", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_val",
    COALESCE("cv"."bquantity_max", ('-1'::integer)::numeric) AS "bquantity_max",
    COALESCE("cv"."bquantity_min", ('-1'::integer)::numeric) AS "bquantity_min",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE
            WHEN ("cv"."embed_mode" = ANY (ARRAY[0, 1, 2])) THEN COALESCE("cv"."embed_mode", 0)
            ELSE 0
        END AS "embed_mode",
    COALESCE("cv"."embed_single", false) AS "embed_single",
    COALESCE("cv"."embed_class_real_id", ('-1'::integer)::bigint) AS "embed_class_real_id",
    COALESCE("cv"."id_unit_conversion_rule", '-1'::integer) AS "id_unit_conversion_rule"
   FROM ((ONLY "bpd"."class_prop" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_obj_val_class" "cv" ON (("cv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class" "class_val" ON (("class_val"."id" = "cv"."id_class_val")))
  WHERE ("cp"."id_prop_type" = 3);



--
-- TOC entry 415 (class 1259 OID 409061)
-- Name: cfg_prop_spec_limit2; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_prop_spec_limit2" (
    "id_prop_data_type" integer NOT NULL,
    "max_name" character varying(50) NOT NULL,
    "max_limit_on" boolean NOT NULL,
    "max_upper" numeric NOT NULL,
    "max_lower" numeric NOT NULL,
    "max_default" numeric NOT NULL,
    "min_name" character varying(50) NOT NULL,
    "min_limit_on" boolean NOT NULL,
    "min_upper" numeric NOT NULL,
    "min_lower" numeric NOT NULL,
    "min_default" numeric NOT NULL,
    "round_name" character varying(50) NOT NULL,
    "round_limit_on" boolean NOT NULL,
    "round_upper" integer NOT NULL,
    "round_lower" integer NOT NULL,
    "round_default" integer NOT NULL,
    "max_used" boolean DEFAULT false NOT NULL,
    "min_used" boolean DEFAULT false NOT NULL,
    "round_used" boolean DEFAULT false NOT NULL,
    "round_on_default" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 459 (class 1259 OID 620775)
-- Name: vclass_prop_user_big_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_user_big_val" AS
 SELECT "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."min_val", ('-1'::integer)::numeric) AS "min_val",
    COALESCE("cv"."min_on", false) AS "min_on",
    COALESCE("cv"."max_val", ('-1'::integer)::numeric) AS "max_val",
    COALESCE("cv"."max_on", false) AS "max_on",
    "cv"."val_text",
    "cv"."val_bytea",
    "cv"."val_json",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 7 THEN ("cv"."val_text" IS NOT NULL)
            WHEN 8 THEN ("cv"."val_bytea" IS NOT NULL)
            WHEN 14 THEN ("cv"."val_json" IS NOT NULL)
            ELSE NULL::boolean
        END AS "on_val",
    "sl"."max_used",
    "sl"."min_used"
   FROM ((ONLY "bpd"."class_prop" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_user_big_val" "cv" ON (("cv"."id_class_prop" = "cp"."id")))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "cp"."id_data_type")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[7, 8, 14])) AND ("cp"."id_prop_type" = 1));


--
-- TOC entry 417 (class 1259 OID 441753)
-- Name: vclass_prop_user_small_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_user_small_val" AS
 SELECT "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."min_val", ('-1'::integer)::numeric) AS "min_val",
    COALESCE("cv"."min_on", false) AS "min_on",
    COALESCE("cv"."max_val", ('-1'::integer)::numeric) AS "max_val",
    COALESCE("cv"."max_on", false) AS "max_on",
    COALESCE("cv"."round", "sl"."round_default") AS "round",
    COALESCE("cv"."round_on", "sl"."round_on_default") AS "round_on",
    "cv"."val_varchar",
    "cv"."val_int",
    "cv"."val_numeric",
    "cv"."val_real",
    "cv"."val_double",
    "cv"."val_money",
    "cv"."val_boolean",
    "cv"."val_date",
    "cv"."val_time",
    "cv"."val_interval",
    "cv"."val_timestamp",
    "cv"."val_bigint",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 1 THEN ("cv"."val_varchar" IS NOT NULL)
            WHEN 2 THEN ("cv"."val_int" IS NOT NULL)
            WHEN 3 THEN ("cv"."val_numeric" IS NOT NULL)
            WHEN 4 THEN ("cv"."val_real" IS NOT NULL)
            WHEN 5 THEN ("cv"."val_double" IS NOT NULL)
            WHEN 6 THEN ("cv"."val_money" IS NOT NULL)
            WHEN 9 THEN ("cv"."val_boolean" IS NOT NULL)
            WHEN 10 THEN ("cv"."val_date" IS NOT NULL)
            WHEN 11 THEN ("cv"."val_time" IS NOT NULL)
            WHEN 12 THEN ("cv"."val_interval" IS NOT NULL)
            WHEN 13 THEN ("cv"."val_timestamp" IS NOT NULL)
            WHEN 15 THEN ("cv"."val_bigint" IS NOT NULL)
            ELSE NULL::boolean
        END AS "on_val",
    "sl"."max_used",
    "sl"."min_used",
    "sl"."round_used"
   FROM ((ONLY "bpd"."class_prop" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_user_small_val" "cv" ON (("cv"."id_class_prop" = "cp"."id")))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "cp"."id_data_type")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 15])) AND ("cp"."id_prop_type" = 1));


--
-- TOC entry 381 (class 1259 OID 172361)
-- Name: class_unit_conversion_rules; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_unit_conversion_rules" (
    "id_class" bigint NOT NULL,
    "id_unit_conversion_rule" integer NOT NULL,
    "id_unit" integer NOT NULL,
    "id_conception" bigint NOT NULL
);


--
-- TOC entry 382 (class 1259 OID 172396)
-- Name: unit_conversion_rule_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."unit_conversion_rule_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    MAXVALUE 2147483647
    CACHE 1;


--
-- TOC entry 358 (class 1259 OID 96138)
-- Name: unit_conversion_rules; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."unit_conversion_rules" (
    "id" integer DEFAULT "nextval"('"bpd"."unit_conversion_rule_id_seq"'::"regclass") NOT NULL,
    "id_unit" integer NOT NULL,
    "cunit" character varying(100) NOT NULL,
    "mc" numeric NOT NULL,
    "on_base" boolean NOT NULL,
    "desc" character varying(100),
    "bunit" character varying(100) DEFAULT 'кг'::character varying NOT NULL,
    "on_single" boolean DEFAULT false NOT NULL,
    "on" boolean DEFAULT true NOT NULL,
    "round" integer DEFAULT 0,
    "not_fractional" boolean DEFAULT false NOT NULL,
    "timestamp" timestamp without time zone NOT NULL,
    "id_conception" bigint DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 445 (class 1259 OID 601011)
-- Name: vclass_unit_conversion_rules; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_unit_conversion_rules" AS
 SELECT "cr"."id_conception",
    "cr"."id_class",
    "cr"."id_unit",
    "cr"."id_unit_conversion_rule",
    true AS "is_create",
    ((EXISTS ( SELECT 1
           FROM "bpd"."class_unit_conversion_rules" "cur"
          WHERE ("cur"."id_unit_conversion_rule" = "cr"."id_unit_conversion_rule"))) OR (EXISTS ( SELECT 1
           FROM "bpd"."object" "o"
          WHERE ("o"."id_unit_conversion_rule" = "cr"."id_unit_conversion_rule")))) AS "is_use",
    ( SELECT "unit_conversion_rules"."on_base"
           FROM "bpd"."unit_conversion_rules"
          WHERE ("unit_conversion_rules"."id" = "cr"."id_unit_conversion_rule")) AS "on_base"
   FROM "bpd"."class_unit_conversion_rules" "cr";


--
-- TOC entry 576 (class 1259 OID 1295911)
-- Name: vconception; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vconception" AS
 SELECT "conception"."id",
    "conception"."name",
    "conception"."desc",
    "conception"."on",
    "conception"."on_root_create",
    "conception"."default",
    "conception"."pos_recycle",
    "conception"."group_recycle",
    "conception"."pos_temp_recycle",
    "conception"."actcatalog",
    "conception"."timestamp"
   FROM "bpd"."conception";

--
-- TOC entry 312 (class 1259 OID 25715)
-- Name: prop_data_type; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_data_type" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "clname" character varying(50),
    "desc" character varying(2044) DEFAULT ' '::character varying NOT NULL,
    "on" boolean DEFAULT true NOT NULL,
    "sort" integer DEFAULT 1 NOT NULL,
    "usrdesc" character varying(255) DEFAULT 'н/д'::character varying NOT NULL
);


--
-- TOC entry 408 (class 1259 OID 284543)
-- Name: prop_data_type_con_map; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_data_type_con_map" (
    "id_conception" bigint NOT NULL,
    "id_prop_data_type" integer NOT NULL,
    "alias" character varying(100) NOT NULL,
    "sort" integer DEFAULT 1 NOT NULL
);


--
-- TOC entry 409 (class 1259 OID 284667)
-- Name: vcon_prop_data_type; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vcon_prop_data_type" AS
 SELECT "dt"."id",
    "cm"."id_conception",
        CASE
            WHEN ("char_length"((COALESCE("cm"."alias", ''::character varying))::"text") > 0) THEN (COALESCE("cm"."alias", ''::character varying))::character varying(100)
            ELSE 'н/у'::character varying(100)
        END AS "alias",
    "dt"."name",
    "dt"."desc",
    "dt"."usrdesc",
    true AS "is_create",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_prop" "cp"
          WHERE (("cp"."id_data_type" = "dt"."id") AND ("cp"."id_conception" = "cm"."id_conception")))) AS "is_use",
    "cm"."sort"
   FROM ("bpd"."prop_data_type" "dt"
     JOIN "bpd"."prop_data_type_con_map" "cm" ON (("cm"."id_prop_data_type" = "dt"."id")))
  ORDER BY "cm"."sort";

--
-- TOC entry 514 (class 1259 OID 1031310)
-- Name: vdoc_category; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vdoc_category" AS
SELECT
    NULL::bigint AS "id",
    NULL::bigint AS "id_conception",
    NULL::character varying(100) AS "name",
    NULL::character varying(1000) AS "desc",
    NULL::boolean AS "on",
    NULL::boolean AS "on_grouping",
    NULL::bigint AS "doc_count",
    NULL::boolean AS "is_use",
    NULL::timestamp without time zone AS "timestamp";

--
-- TOC entry 587 (class 1259 OID 1343373)
-- Name: vdoc_file; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vdoc_file" AS
 SELECT "df"."id",
    "df"."uuid",
    "df"."md5",
    "df"."id_conception",
    "df"."catalog",
    "df"."id_document",
    "df"."name",
    "df"."extension",
    "df"."version",
    "df"."versiondate",
    "df"."fulltxtsrch_on",
    "df"."timestamp",
    "df"."data_length"
   FROM "bpd"."doc_file" "df";

--
-- TOC entry 519 (class 1259 OID 1054227)
-- Name: int_doc_category_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_doc_category_ext" AS
 SELECT "d"."id" AS "id_document",
    "array_agg"(("vdc".*)::"bpd"."cdoc_category") AS "doc_category_list"
   FROM ("bpd"."document" "d"
     JOIN "bpd"."vdoc_category" "vdc" ON (("vdc"."id" = "d"."id_category")))
  GROUP BY "d"."id";


--
-- TOC entry 588 (class 1259 OID 1343379)
-- Name: int_doc_file_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_doc_file_ext" AS
 SELECT "d"."id" AS "id_document",
    "array_agg"(("vdf".*)::"bpd"."cdoc_file") AS "doc_file_list"
   FROM ("bpd"."document" "d"
     JOIN "bpd"."vdoc_file" "vdf" ON (("vdf"."id_document" = "d"."id")))
  GROUP BY "d"."id";


--
-- TOC entry 508 (class 1259 OID 855722)
-- Name: int_doc_link_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_doc_link_ext" AS
 SELECT "d"."id" AS "id_document",
    "array_agg"(("vdl".*)::"bpd"."cdoc_link") AS "doc_link_list"
   FROM ("bpd"."document" "d"
     JOIN "bpd"."vdoc_link" "vdl" ON (("vdl"."id_document" = "d"."id")))
  GROUP BY "d"."id";


--
-- TOC entry 589 (class 1259 OID 1343384)
-- Name: vdocument_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vdocument_ext" AS
 SELECT "d"."id",
    "d"."id_conception",
    "d"."id_parent",
    "d"."id_category",
    "dc"."on_grouping",
    "d"."package_item",
    "d"."name",
    "d"."desc",
    "d"."regnum",
    "d"."regdate",
    (EXISTS ( SELECT 1
           FROM "bpd"."doc_link" "dl_1"
          WHERE ("dl_1"."id_document" = "d"."id"))) AS "has_link",
    (EXISTS ( SELECT 1
           FROM "bpd"."document" "doc_child"
          WHERE ("doc_child"."id_parent" = "d"."id"))) AS "has_doc",
    (EXISTS ( SELECT 1
           FROM "bpd"."doc_file" "df_1"
          WHERE ("df_1"."id_document" = "d"."id"))) AS "has_file",
    "d"."timestamp",
    "d"."is_inside",
    "df"."doc_file_list",
    "dl"."doc_link_list",
    "dc_e"."doc_category_list"
   FROM (((("bpd"."document" "d"
     LEFT JOIN "bpd"."doc_category" "dc" ON (("dc"."id" = "d"."id_category")))
     LEFT JOIN "bpd"."int_doc_file_ext" "df" ON (("df"."id_document" = "d"."id")))
     LEFT JOIN "bpd"."int_doc_link_ext" "dl" ON (("dl"."id_document" = "d"."id")))
     LEFT JOIN "bpd"."int_doc_category_ext" "dc_e" ON (("dc_e"."id_document" = "d"."id")));


--
-- TOC entry 1250 (class 1255 OID 1442083)
-- Name: document_ext_by_id(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."document_ext_by_id"("iid" bigint) RETURNS SETOF "bpd"."vdocument_ext"
    LANGUAGE "plpgsql" SECURITY DEFINER
    SET "search_path" TO 'bpd'
    AS $$

DECLARE
 --**************************************************************************
    --ДАТА: 29.01.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция возвращает расширенный документ по идентификатору документа
    --Ограничения: -
    --**************************************************************************
BEGIN
    RETURN QUERY  SELECT * FROM "bpd"."vdocument_ext" WHERE "id" = iid;
END;
$$;


--
-- TOC entry 1251 (class 1255 OID 1442277)
-- Name: document_ext_by_id_category(bigint); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."document_ext_by_id_category"("iid_category" bigint) RETURNS SETOF "bpd"."vdocument_ext"
    LANGUAGE "plpgsql" SECURITY DEFINER
    SET "search_path" TO 'bpd'
    AS $$

DECLARE
 --**************************************************************************
    --ДАТА: 13.03.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция возвращает расширенные документы категории без входа в пакеты документов по идентификатору категории
    --Ограничения: -
    --**************************************************************************
BEGIN
    RETURN QUERY  SELECT * FROM "bpd"."vdocument_ext"  WHERE ("id_category" = iid_category);
END;
$$;

CREATE TABLE "bpd"."entity" (
    "id" integer NOT NULL,
    "entity" character varying(50) NOT NULL,
    "desc" "text" NOT NULL,
    "name" character varying(2044) NOT NULL,
    "errid" integer DEFAULT 0 NOT NULL,
    "can_link" boolean DEFAULT false NOT NULL,
    "on_export" boolean DEFAULT false NOT NULL,
    "sec_point" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 385 (class 1259 OID 179583)
-- Name: ventity; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."ventity" AS
 SELECT "e"."id",
    "e"."entity",
    "e"."name",
    "e"."desc",
    "e"."errid",
    "e"."can_link",
    "e"."on_export",
    "e"."sec_point"
   FROM "bpd"."entity" "e";


--
-- TOC entry 471 (class 1259 OID 637731)
-- Name: global_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."global_prop" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_prop_type" integer NOT NULL,
    "id_data_type" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) NOT NULL,
    "timestamp" timestamp without time zone NOT NULL,
    "id_area_val" bigint,
    "timestamp_area_val" timestamp without time zone,
    "visible" boolean DEFAULT true NOT NULL
);


--
-- TOC entry 473 (class 1259 OID 637745)
-- Name: global_prop_link_pos_temp_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."global_prop_link_pos_temp_prop" (
    "id_conception" bigint NOT NULL,
    "id_global_prop" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL
);


--
-- TOC entry 479 (class 1259 OID 685159)
-- Name: vglobal_prop_area_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vglobal_prop_area_val" AS
 SELECT DISTINCT "gp"."id" AS "id_global_prop",
    "gp"."timestamp" AS "timestamp_global_prop",
    "gp"."id_conception",
    ((NOT ("lcp"."id_class_prop_definition" IS NULL)) OR (NOT ("lptp"."id_pos_temp_prop" IS NULL))) AS "is_use",
    "gp"."id_prop_type",
    "gp"."id_data_type",
        CASE "gp"."id_prop_type"
            WHEN 1 THEN ("gp"."id_data_type")::bigint
            ELSE COALESCE("gp"."id_area_val", (- (1)::bigint))
        END AS "id_area_val",
    COALESCE("gp"."timestamp_area_val", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_area_val",
    (("gp"."id_prop_type" = 1) OR (COALESCE("gp"."id_area_val", (- (1)::bigint)) > 0)) AS "on_val",
    (("gp"."id_prop_type" = 1) OR (COALESCE("gp"."id_area_val", (- (1)::bigint)) > 0)) AS "ready"
   FROM (("bpd"."global_prop" "gp"
     LEFT JOIN "bpd"."global_prop_link_class_prop" "lcp" ON (("lcp"."id_global_prop" = "gp"."id")))
     LEFT JOIN "bpd"."global_prop_link_pos_temp_prop" "lptp" ON (("lptp"."id_global_prop" = "gp"."id")));


--
-- TOC entry 474 (class 1259 OID 637907)
-- Name: vglobal_prop; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vglobal_prop" AS
 SELECT DISTINCT "gp"."id",
    "gp"."id_conception",
    "gp"."id_prop_type",
    "gp"."id_data_type",
    "gp"."name",
    "gp"."desc",
    ((NOT ("lcp"."id_class_prop_definition" IS NULL)) OR (NOT ("lptp"."id_pos_temp_prop" IS NULL))) AS "is_use",
    "gp"."timestamp",
    COALESCE("gp"."id_area_val", (- (1)::bigint)) AS "id_area_val",
    COALESCE("gp"."timestamp_area_val", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_area_val",
    (("gp"."id_prop_type" = 1) OR (COALESCE("gp"."id_area_val", (- (1)::bigint)) > 0)) AS "on_val",
    (("gp"."id_prop_type" = 1) OR (COALESCE("gp"."id_area_val", (- (1)::bigint)) > 0)) AS "ready",
    "gp"."visible"
   FROM (("bpd"."global_prop" "gp"
     LEFT JOIN "bpd"."global_prop_link_class_prop" "lcp" ON (("lcp"."id_global_prop" = "gp"."id")))
     LEFT JOIN "bpd"."global_prop_link_pos_temp_prop" "lptp" ON (("lptp"."id_global_prop" = "gp"."id")));

--
-- TOC entry 620 (class 1259 OID 1485933)
-- Name: int_group_path; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_group_path" AS
 WITH RECURSIVE "rgroup"("id_path", "id", "id_parent", "level", "path", "spath", "cycle") AS (
         SELECT "rg"."id",
            "rg"."id",
            "rg"."id_parent",
            0,
            ARRAY["rg"."id"] AS "array",
            "concat"("rg"."name") AS "concat",
            false AS "bool"
           FROM "bpd"."group" "rg"
        UNION ALL
         SELECT "rgroup_1"."id_path",
            "rgc"."id",
            "rgc"."id_parent",
            ("rgroup_1"."level" + 1),
            (ARRAY["rgc"."id"] || "rgroup_1"."path"),
            "concat"("rgc"."name", '\', "rgroup_1"."spath") AS "concat",
            ("rgc"."id" = ANY ("rgroup_1"."path"))
           FROM ("bpd"."group" "rgc"
             JOIN "rgroup" "rgroup_1" ON (("rgroup_1"."id_parent" = "rgc"."id")))
          WHERE (NOT "rgroup_1"."cycle")
        ), "grouppath"("id_path", "spath") AS (
         SELECT DISTINCT "rg"."id_path",
            "first_value"("rg"."spath") OVER (PARTITION BY "rg"."id_path" ORDER BY "rg"."level" DESC) AS "first_value"
           FROM "rgroup" "rg"
        )
 SELECT "g"."id",
    COALESCE("gp"."spath", ''::"text") AS "path"
   FROM ("bpd"."group" "g"
     LEFT JOIN "grouppath" "gp" ON (("gp"."id_path" = "g"."id")));


--
-- TOC entry 397 (class 1259 OID 230660)
-- Name: vgroup; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vgroup" AS
 SELECT "g"."id",
    "g"."id_parent",
    "g"."id_root",
    "g"."level",
    "g"."id_con",
    "g"."name",
    "g"."desc",
    ("c"."group_recycle" = "g"."id") AS "on_recycle",
    "g"."sort",
    "g"."timestamp",
    "g"."on_class",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "c_1"
          WHERE ("c_1"."id_group" = "g"."id"))) AS "include_act_class",
    "g"."timestamp_child_change",
    (("c"."group_recycle" = "g"."id_root") AND ("c"."group_recycle" <> "g"."id")) AS "in_recycle",
    (EXISTS ( SELECT 1
           FROM "bpd"."group" "cg"
          WHERE ("cg"."id_parent" = "g"."id"))) AS "include_child_group",
    "p"."path"
   FROM (("bpd"."group" "g"
     LEFT JOIN "bpd"."conception" "c" ON (("c"."id" = "g"."id_con")))
     LEFT JOIN "bpd"."int_group_path" "p" ON (("p"."id" = "g"."id")));


--
-- TOC entry 424 (class 1259 OID 462272)
-- Name: class_prop_enum_val_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_enum_val_snapshot" (
)
INHERITS ("bpd"."class_prop_enum_val");


--
-- TOC entry 435 (class 1259 OID 515576)
-- Name: class_prop_link_val_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_link_val_snapshot" (
)
INHERITS ("bpd"."class_prop_link_val");


--
-- TOC entry 391 (class 1259 OID 203177)
-- Name: class_prop_obj_val_class_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_obj_val_class_snapshot" (
)
INHERITS ("bpd"."class_prop_obj_val_class");


--
-- TOC entry 379 (class 1259 OID 159972)
-- Name: class_prop_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_snapshot" (
)
INHERITS ("bpd"."class_prop");


--
-- TOC entry 376 (class 1259 OID 159947)
-- Name: class_prop_user_big_val_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_user_big_val_snapshot" (
)
INHERITS ("bpd"."class_prop_user_big_val");


--
-- TOC entry 374 (class 1259 OID 159931)
-- Name: class_prop_user_small_val_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_prop_user_small_val_snapshot" (
)
INHERITS ("bpd"."class_prop_user_small_val");


--
-- TOC entry 361 (class 1259 OID 110216)
-- Name: class_snapshot; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_snapshot" (
)
INHERITS ("bpd"."class");


--
-- TOC entry 486 (class 1259 OID 791702)
-- Name: vclass_prop_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_snapshot" AS
 SELECT DISTINCT "cp"."id",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."on_inherit",
    "cp"."inheritance",
    "cp"."id_prop_inherit",
    COALESCE("cp"."timestamp_class_inherit", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_inherit",
    "cp"."id_prop_type",
    "cp"."id_data_type",
    "cp"."name",
    "cp"."desc",
    "cp"."sort",
    "cp"."on_override",
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END
            WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
            WHEN 4 THEN (COALESCE("lv"."id_entity_instance", (0)::bigint) > 0)
            ELSE false
        END AS "on_val",
    COALESCE(
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN "sv"."val_varchar"
                WHEN 2 THEN ("sv"."val_int")::character varying
                WHEN 3 THEN ("sv"."val_numeric")::character varying
                WHEN 4 THEN ("sv"."val_real")::character varying
                WHEN 5 THEN ("sv"."val_double")::character varying
                WHEN 6 THEN (("sv"."val_money")::numeric)::character varying
                WHEN 7 THEN 'Текст'::character varying
                WHEN 8 THEN 'Изображение'::character varying
                WHEN 9 THEN ("sv"."val_boolean")::character varying
                WHEN 10 THEN ("sv"."val_date")::character varying
                WHEN 11 THEN ("sv"."val_time")::character varying
                WHEN 12 THEN ("sv"."val_interval")::character varying
                WHEN 13 THEN ("sv"."val_timestamp")::character varying
                WHEN 14 THEN 'Json'::character varying
                WHEN 15 THEN ("sv"."val_bigint")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN "pev"."val_varchar"
                WHEN 3 THEN ("pev"."val_numeric")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 3 THEN 'Объект'::character varying
            WHEN 4 THEN 'Ссылка'::character varying
            ELSE 'н/д'::character varying
        END, 'н/д'::character varying) AS "string_val",
    (("cp"."tableoid")::"regclass")::character varying AS "tablename",
        CASE "cp"."id_prop_type"
            WHEN 1 THEN (
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END OR "cp"."on_override")
            WHEN 2 THEN (
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END OR ("cp"."on_override" AND (COALESCE("ev"."id_prop_enum", (0)::bigint) > 0)))
            WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
            WHEN 4 THEN ((COALESCE("lv"."id_entity_instance", (0)::bigint) > 0) OR ("cp"."on_override" AND ("lv"."id_entity" IS NOT NULL)))
            ELSE false
        END AS "ready",
    "cp"."id_conception",
    "cp"."id_class_definition",
    "cp"."timestamp_class_definition",
    "cp"."id_prop_definition",
        CASE "cp"."inheritance"
            WHEN true THEN COALESCE("cp_inherit"."on_override", false)
            WHEN false THEN "cp"."on_override"
            ELSE NULL::boolean
        END AS "on_override_prop_inherit",
    ("lgp"."id_global_prop" IS NOT NULL) AS "on_global",
    COALESCE("lgp"."id_global_prop", ('-1'::integer)::bigint) AS "id_global_prop",
    "cp"."tag"
   FROM ((((((((("bpd"."class_prop_snapshot" "cp"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp_inherit" ON ((("cp_inherit"."id" = "cp"."id_prop_inherit") AND ("cp_inherit"."timestamp_class" = "cp"."timestamp_class_inherit"))))
     LEFT JOIN "bpd"."class_prop_user_small_val_snapshot" "sv" ON ((("sv"."id_class_prop" = "cp"."id") AND ("sv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."class_prop_user_big_val_snapshot" "bv" ON ((("bv"."id_class_prop" = "cp"."id") AND ("bv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."class_prop_enum_val_snapshot" "ev" ON ((("ev"."id_class_prop" = "cp"."id") AND ("ev"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")))
     LEFT JOIN "bpd"."class_prop_link_val_snapshot" "lv" ON ((("lv"."id_class_prop" = "cp"."id") AND ("lv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."class_prop_obj_val_class_snapshot" "ov" ON ((("ov"."id_class_prop" = "cp"."id") AND ("ov"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."class_snapshot" "class_val" ON ((("class_val"."id" = "ov"."id_class_val") AND ("class_val"."timestamp" = "ov"."timestamp_class_val"))))
     LEFT JOIN "bpd"."global_prop_link_class_prop" "lgp" ON (("lgp"."id_class_prop_definition" = "cp"."id_prop_definition")));



--
-- TOC entry 434 (class 1259 OID 514865)
-- Name: object_prop_link_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_prop_link_val" (
    "id_object" bigint NOT NULL,
    "id_class_prop" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer
);


--
-- TOC entry 378 (class 1259 OID 159964)
-- Name: object_prop_user_big_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_prop_user_big_val" (
    "id_object" bigint NOT NULL,
    "id_class_prop" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "val_text" "text",
    "val_bytea" "bytea",
    "val_json" "json",
    "id_class" bigint NOT NULL,
    "id_data_type" integer NOT NULL
);


--
-- TOC entry 377 (class 1259 OID 159956)
-- Name: object_prop_user_small_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_prop_user_small_val" (
    "id_object" bigint NOT NULL,
    "id_class_prop" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_real" real,
    "val_numeric" numeric,
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_timestamp" timestamp without time zone,
    "val_money" "money",
    "val_double" double precision,
    "id_class" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "val_bigint" bigint NOT NULL
);


--
-- TOC entry 487 (class 1259 OID 791715)
-- Name: vobject_prop; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop" AS
 SELECT "cp"."id" AS "id_class_prop",
    "o"."id" AS "id_object_carrier",
    "o"."timestamp" AS "timestamp_object_carrier",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."on_inherit",
    true AS "inheritance",
    "cp"."id_prop_inherit",
    COALESCE("cp"."timestamp_class_inherit", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_inherit",
    "cp"."id_prop_type",
    "cp"."id_data_type",
    "cp"."name",
    "cp"."desc",
    "cp"."sort",
    "cp"."on_override",
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END
            WHEN 3 THEN (EXISTS ( SELECT 1
               FROM "bpd"."object" "ov"
              WHERE (("ov"."id_object_carrier" = "o"."id") AND ("ov"."id_class_prop_object_carrier" = "cp"."id"))))
            WHEN 4 THEN ("lv"."id_entity_instance" IS NOT NULL)
            ELSE false
        END AS "on_val_object",
    "cp"."on_val" AS "on_val_class",
    "cp"."id_conception",
    "cp"."id_class_definition",
    "cp"."timestamp_class_definition",
    "cp"."id_prop_definition",
    COALESCE(
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN COALESCE("sv"."val_varchar", "cp"."string_val")
                WHEN 2 THEN COALESCE(("sv"."val_int")::character varying, "cp"."string_val")
                WHEN 3 THEN COALESCE(("sv"."val_numeric")::character varying, "cp"."string_val")
                WHEN 4 THEN COALESCE(("sv"."val_real")::character varying, "cp"."string_val")
                WHEN 5 THEN COALESCE(("sv"."val_double")::character varying, "cp"."string_val")
                WHEN 6 THEN COALESCE((("sv"."val_money")::numeric)::character varying, "cp"."string_val")
                WHEN 7 THEN 'Текст'::character varying
                WHEN 8 THEN 'Изображение'::character varying
                WHEN 9 THEN COALESCE(("sv"."val_boolean")::character varying, "cp"."string_val")
                WHEN 10 THEN COALESCE(("sv"."val_date")::character varying, "cp"."string_val")
                WHEN 11 THEN COALESCE(("sv"."val_time")::character varying, "cp"."string_val")
                WHEN 12 THEN COALESCE(("sv"."val_interval")::character varying, "cp"."string_val")
                WHEN 13 THEN COALESCE(("sv"."val_timestamp")::character varying, "cp"."string_val")
                WHEN 14 THEN 'Json'::character varying
                WHEN 15 THEN COALESCE(("sv"."val_bigint")::character varying, "cp"."string_val")
                ELSE 'н/д'::character varying
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN COALESCE("pev"."val_varchar", "cp"."string_val")
                WHEN 3 THEN COALESCE(("pev"."val_numeric")::character varying, "cp"."string_val")
                ELSE 'н/д'::character varying
            END
            WHEN 3 THEN 'Объект'::character varying
            WHEN 4 THEN 'Ссылка'::character varying
            ELSE 'н/д'::character varying
        END, 'н/д'::character varying) AS "string_val",
    "cp"."id_global_prop",
    "cp"."on_global",
    "cp"."tag"
   FROM (((((("bpd"."object" "o"
     JOIN "bpd"."vclass_prop_snapshot" "cp" ON ((("cp"."id_class" = "o"."id_class") AND ("cp"."timestamp_class" = "o"."timestamp_class"))))
     LEFT JOIN "bpd"."object_prop_user_small_val" "sv" ON ((("sv"."id_object" = "o"."id") AND ("sv"."id_class_prop" = "cp"."id") AND ("sv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."object_prop_user_big_val" "bv" ON ((("bv"."id_object" = "o"."id") AND ("bv"."id_class_prop" = "cp"."id") AND ("bv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."object_prop_link_val" "lv" ON ((("lv"."id_object" = "o"."id") AND ("lv"."id_class_prop" = "cp"."id") AND ("lv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."object_prop_enum_val" "ev" ON ((("ev"."id_object" = "o"."id") AND ("ev"."id_class_prop" = "cp"."id") AND ("ev"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")));

--
-- TOC entry 1056 (class 1255 OID 1437214)
-- Name: int_class_ext_prop_by_id_class_array(bigint[]); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_class_ext_prop_by_id_class_array"("class_array" bigint[]) RETURNS SETOF "bpd"."int_class_ext"
    LANGUAGE "sql" STABLE PARALLEL SAFE
    AS $$
    --**************************************************************************
    --ДАТА: 17.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 2.0
    --Описание: Функция упреждающей выборки свойств, используется для ограничения группировки свойств для расширенных представлений классов
    --**************************************************************************
    SELECT cp.id_class AS id,
    array_agg((cp.*)::bpd.cclass_prop ORDER BY cp.sort) AS property_list
    FROM bpd.vclass_prop cp
    WHERE (cp.id_class = ANY(class_array))
    GROUP BY cp.id_class;
$$;


--
-- TOC entry 1055 (class 1255 OID 1437212)
-- Name: int_class_path_by_id_class_array(bigint[]); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_class_path_by_id_class_array"("class_array" bigint[]) RETURNS SETOF "bpd"."int_class_path"
    LANGUAGE "plpgsql" STABLE PARALLEL SAFE
    SET "search_path" TO 'bpd'
    AS $_$
DECLARE
    --**************************************************************************
    --ДАТА: 25.05.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция упреждающей выборки данных пути классов в группе, используется для ограничения группировки
    --**************************************************************************
BEGIN
    RETURN QUERY WITH RECURSIVE rgroup(id_path, id, id_parent, level, path, spath, cycle) AS (
         SELECT rg.id,
            rg.id,
            rg.id_parent,
            0,
            ARRAY[rg.id] AS "array",
            concat(rg.name) AS concat,
            false AS bool
           FROM bpd."group" rg
           WHERE rg.id IN (SELECT ac.id_group FROM ONLY bpd.class ac WHERE ac.id = ANY(class_array))
        UNION ALL
         SELECT rgroup_1.id_path,
            rgc.id,
            rgc.id_parent,
            (rgroup_1.level + 1),
            (ARRAY[rgc.id] || rgroup_1.path),
            concat(rgc.name, $$\$$, rgroup_1.spath) AS concat,
            (rgc.id = ANY (rgroup_1.path))
           FROM (bpd."group" rgc
             JOIN rgroup rgroup_1 ON ((rgroup_1.id_parent = rgc.id)))
          WHERE (NOT rgroup_1.cycle)
        ), 
        grouppath(id_path, spath) AS (
         SELECT DISTINCT rg.id_path,
            first_value(rg.spath) OVER (PARTITION BY rg.id_path ORDER BY rg.level DESC) AS first_value
           FROM rgroup rg
        ), 
        rclass(id_path, id, id_parent, level, path, spath, cycle) AS (
         SELECT rc.id,
            rc.id,
            rc.id_parent,
            0,
            ARRAY[rc.id] AS "array",
            concat(rc.name) AS concat,
            false AS bool
           FROM ONLY bpd.class rc
           WHERE  (rc.id = ANY(class_array))
        UNION ALL
         SELECT rclass_1.id_path,
            rcc.id,
            rcc.id_parent,
            (rclass_1.level + 1),
            (ARRAY[rcc.id] || rclass_1.path),
            concat(rcc.name, $$\$$, rclass_1.spath) AS concat,
            (rcc.id = ANY (rclass_1.path))
           FROM (ONLY bpd.class rcc
             JOIN rclass rclass_1 ON ((rclass_1.id_parent = rcc.id)))
          WHERE (NOT rclass_1.cycle)
        ), classpath(id_path, spath) AS (
         SELECT DISTINCT rc.id_path,
            first_value(rc.spath) OVER (PARTITION BY rc.id_path ORDER BY rc.level DESC) AS first_value
           FROM rclass rc
        )
 SELECT c.id,
    concat(COALESCE(gp.spath, ''::text), '\\', COALESCE(cp.spath, ''::text)) AS path
   FROM ((ONLY bpd.class c
     LEFT JOIN grouppath gp ON ((gp.id_path = c.id_group)))
     LEFT JOIN classpath cp ON ((cp.id_path = c.id)))
   WHERE  (c.id = ANY(class_array));  
END;
$_$;

--
-- TOC entry 743 (class 1255 OID 1252283)
-- Name: int_class_ready_by_id_class_array(bigint[]); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_class_ready_by_id_class_array"("class_array" bigint[]) RETURNS SETOF "bpd"."int_class_ready"
    LANGUAGE "sql" STABLE PARALLEL SAFE
    AS $$
    --**************************************************************************
    --ДАТА: 25.05.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция упреждающей выборки данных готовности классов, используется для ограничения группировки
    --**************************************************************************
	SELECT
        c.id,
        CASE c.on_abstraction
            WHEN false THEN
            CASE bpd.int_class_format_check(c.id)
                WHEN true THEN
                CASE (count(cp.id) > 0)
                    WHEN true THEN bool_and(
                    CASE cp.id_prop_type
                        WHEN 1 THEN (
                        CASE cp.id_data_type
                            WHEN 1 THEN (sv.val_varchar IS NOT NULL)
                            WHEN 2 THEN (sv.val_int IS NOT NULL)
                            WHEN 3 THEN (sv.val_numeric IS NOT NULL)
                            WHEN 4 THEN (sv.val_real IS NOT NULL)
                            WHEN 5 THEN (sv.val_double IS NOT NULL)
                            WHEN 6 THEN (sv.val_money IS NOT NULL)
                            WHEN 7 THEN (bv.val_text IS NOT NULL)
                            WHEN 8 THEN (bv.val_bytea IS NOT NULL)
                            WHEN 9 THEN (sv.val_boolean IS NOT NULL)
                            WHEN 10 THEN (sv.val_date IS NOT NULL)
                            WHEN 11 THEN (sv.val_time IS NOT NULL)
                            WHEN 12 THEN (sv.val_interval IS NOT NULL)
                            WHEN 13 THEN (sv.val_timestamp IS NOT NULL)
                            WHEN 14 THEN (bv.val_json IS NOT NULL)
                            WHEN 15 THEN (sv.val_bigint IS NOT NULL)
                            ELSE false
                        END OR cp.on_override)
                        WHEN 2 THEN (
                        CASE cp.id_data_type
                            WHEN 1 THEN (pev.val_varchar IS NOT NULL)
                            WHEN 3 THEN (pev.val_numeric IS NOT NULL)
                            ELSE false
                        END OR (cp.on_override AND (COALESCE(ev.id_prop_enum, (0)::bigint) > 0)))
                        WHEN 3 THEN (COALESCE(class_val.id, (0)::bigint) > 0)
                        WHEN 4 THEN ((COALESCE(lv.id_entity_instance, (0)::bigint) > 0) OR (cp.on_override AND (lv.id_entity IS NOT NULL)))
                        ELSE false
                    END)
                    ELSE true
                END
                ELSE false
            END
            ELSE false
        END AS ready
   FROM ONLY bpd.class c
     LEFT JOIN ONLY bpd.class_prop cp ON (c.id = cp.id_class)
     LEFT JOIN ONLY bpd.class_prop_user_small_val sv ON (sv.id_class_prop = cp.id)
     LEFT JOIN ONLY bpd.class_prop_user_big_val bv ON (bv.id_class_prop = cp.id)
     LEFT JOIN ONLY bpd.class_prop_enum_val ev ON (ev.id_class_prop = cp.id)
     LEFT JOIN ONLY bpd.prop_enum_val pev ON (pev.id = ev.id_prop_enum_val)
     LEFT JOIN ONLY bpd.class_prop_link_val lv ON (lv.id_class_prop = cp.id)
     LEFT JOIN ONLY bpd.class_prop_obj_val_class ov ON (ov.id_class_prop = cp.id)
     LEFT JOIN ONLY bpd.class class_val ON (class_val.id = ov.id_class_val)
    WHERE  (c.id = ANY(class_array))
  GROUP BY c.id;
$$;


--
-- TOC entry 525 (class 1259 OID 1082680)
-- Name: int_object_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_object_ext" AS
 SELECT "op"."id_object_carrier" AS "id",
    "array_agg"(("op".*)::"bpd"."cobject_prop" ORDER BY "op"."sort") AS "property_list"
   FROM "bpd"."vobject_prop" "op"
  GROUP BY "op"."id_object_carrier";


--
-- TOC entry 742 (class 1255 OID 1241759)
-- Name: int_object_ext_prop_by_id_object_array(bigint[]); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_object_ext_prop_by_id_object_array"("object_array" bigint[]) RETURNS SETOF "bpd"."int_object_ext"
    LANGUAGE "sql" STABLE PARALLEL SAFE
    AS $$
    --**************************************************************************
    --ДАТА: 13.05.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция упреждающей выборки свойств, используется для ограничения группировки свойств для расширенных представлений объектов
    --**************************************************************************

    SELECT 
    op.id_object_carrier AS id,
    array_agg((op.*)::bpd.cobject_prop  ORDER BY op.sort) AS property_list
    FROM bpd.vobject_prop op
    WHERE (op.id_object_carrier = ANY(object_array))
    GROUP BY op.id_object_carrier;
$$;



--
-- TOC entry 311 (class 1259 OID 25705)
-- Name: position; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."position" (
    "id" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_parent" bigint NOT NULL,
    "id_root" bigint NOT NULL,
    "level" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT 'н/д'::"text" NOT NULL,
    "id_con" bigint NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL,
    "lockdel" boolean DEFAULT false NOT NULL,
    "on_service" boolean DEFAULT false NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP NOT NULL,
    "id_prototype" integer DEFAULT '-1'::integer NOT NULL,
    "timestamp_child_change" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "path_array" bigint[] DEFAULT ARRAY[0] NOT NULL
);


--
-- TOC entry 570 (class 1259 OID 1288837)
-- Name: int_object_path; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_object_path" AS
 WITH RECURSIVE "rpos"("id_path", "id", "id_parent", "level", "path", "spath", "cycle") AS MATERIALIZED (
         SELECT "rp"."id",
            "rp"."id",
            "rp"."id_parent",
            0,
            ARRAY["rp"."id"] AS "array",
            "concat"("rp"."name") AS "concat",
            false AS "bool"
           FROM "bpd"."position" "rp"
        UNION ALL
         SELECT "rpos_1"."id_path",
            "rpc"."id",
            "rpc"."id_parent",
            ("rpos_1"."level" + 1),
            (ARRAY["rpc"."id"] || "rpos_1"."path"),
            "concat"("rpc"."name", '\', "rpos_1"."spath") AS "concat",
            ("rpc"."id" = ANY ("rpos_1"."path"))
           FROM ("bpd"."position" "rpc"
             JOIN "rpos" "rpos_1" ON (("rpos_1"."id_parent" = "rpc"."id")))
          WHERE (NOT "rpos_1"."cycle")
        ), "pospath"("id_path", "spath") AS MATERIALIZED (
         SELECT DISTINCT "rg"."id_path",
            "first_value"("rg"."spath") OVER (PARTITION BY "rg"."id_path" ORDER BY "rg"."level" DESC) AS "first_value"
           FROM "rpos" "rg"
        ), "robject"("id_path", "id", "id_parent", "level", "path", "spath", "cycle") AS MATERIALIZED (
         SELECT "ro"."id",
            "ro"."id",
            "ro"."id_object_carrier",
            0,
            ARRAY["ro"."id"] AS "array",
            "concat"("ro"."name") AS "concat",
            false AS "bool"
           FROM "bpd"."object" "ro"
        UNION ALL
         SELECT "rob"."id_path",
            "roc"."id",
            "roc"."id_object_carrier",
            ("rob"."level" + 1),
            (ARRAY["roc"."id"] || "rob"."path"),
            "concat"("roc"."name", '\', "rob"."spath") AS "concat",
            ("roc"."id" = ANY ("rob"."path"))
           FROM ("bpd"."object" "roc"
             JOIN "robject" "rob" ON (("rob"."id_parent" = "roc"."id")))
          WHERE (NOT "rob"."cycle")
        ), "objectpath"("id_path", "spath") AS (
         SELECT DISTINCT "rg"."id_path",
            "first_value"("rg"."spath") OVER (PARTITION BY "rg"."id_path" ORDER BY "rg"."level" DESC) AS "first_value"
           FROM "robject" "rg"
        )
 SELECT "o"."id",
    "concat"(COALESCE("pp"."spath", ''::"text"), '\\', COALESCE("op"."spath", ''::"text")) AS "path"
   FROM (("bpd"."object" "o"
     LEFT JOIN "pospath" "pp" ON (("pp"."id_path" = "o"."id_position")))
     LEFT JOIN "objectpath" "op" ON (("op"."id_path" = "o"."id")));


--
-- TOC entry 746 (class 1255 OID 1289118)
-- Name: int_object_path_by_id_object_array(bigint[]); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_object_path_by_id_object_array"("object_array" bigint[]) RETURNS SETOF "bpd"."int_object_path"
    LANGUAGE "sql" STABLE PARALLEL SAFE
    AS $$
    --**************************************************************************
    --ДАТА: 28.06.2021
    --Автор: Иванов Д.Ю.
    --Версия: 1.0
    --Описание: Функция упреждающей выборки свойств, используется для ограничения выборки путей объектов
    --**************************************************************************
SELECT 
    op.id,
    op.path
    FROM "bpd"."int_object_path" op
    WHERE (op.id = ANY(object_array));
$$;



--
-- TOC entry 736 (class 1255 OID 1166915)
-- Name: int_week_day_name("date", character varying); Type: FUNCTION; Schema: bpd; Owner: -
--

CREATE FUNCTION "bpd"."int_week_day_name"("idate" "date", "iformat" character varying) RETURNS character varying
    LANGUAGE "plpgsql" IMMUTABLE PARALLEL SAFE
    AS $$
DECLARE
  result VARCHAR DEFAULT 'понедельник';
BEGIN
   IF (iformat = 'short') THEN
        CASE (date_part('dow'::text, idate))
            WHEN 0 THEN
                result := 'ВС';
            WHEN 1 THEN
                result := 'ПН';
            WHEN 2 THEN
                result := 'ВТ';
            WHEN 3 THEN
                result := 'СР';
            WHEN 4 THEN
                result := 'ЧТ';
            WHEN 5 THEN
                result := 'ПН';
            WHEN 6 THEN
                result := 'СБ';                        
            ELSE
                result := 'ПН';
        END CASE;    
   ELSE
        CASE (date_part('dow'::text, idate))
            WHEN 0 THEN
                result := 'Воскресенье';
            WHEN 1 THEN
                result := 'Понедельник';
            WHEN 2 THEN
                result := 'Вторник';
            WHEN 3 THEN
                result := 'Среда';
            WHEN 4 THEN
                result := 'Четверг';
            WHEN 5 THEN
                result := 'Пятница';
            WHEN 6 THEN
                result := 'Суббота';                        
            ELSE
                result := 'Понедельник';
        END CASE;    
   END IF;   
   RETURN result;
END;
$$;


--
-- TOC entry 531 (class 1259 OID 1152435)
-- Name: int_position_path; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_position_path" AS
 WITH RECURSIVE "rpos"("id_path", "id", "id_parent", "level", "cur_level", "path", "spath", "cycle") AS MATERIALIZED (
         SELECT "rp"."id",
            "rp"."id",
            "rp"."id_parent",
            0,
            "rp"."level",
            ARRAY["rp"."id"] AS "array",
            "concat"("rp"."name") AS "concat",
            false AS "bool"
           FROM "bpd"."position" "rp"
        UNION ALL
         SELECT "rpos_1"."id_path",
            "rpc"."id",
            "rpc"."id_parent",
            ("rpos_1"."level" + 1),
            "rpos_1"."cur_level",
            (ARRAY["rpc"."id"] || "rpos_1"."path"),
            "concat"("rpc"."name", '\', "rpos_1"."spath") AS "concat",
            ("rpc"."id" = ANY ("rpos_1"."path"))
           FROM ("bpd"."position" "rpc"
             JOIN "rpos" "rpos_1" ON (("rpos_1"."id_parent" = "rpc"."id")))
          WHERE (NOT "rpos_1"."cycle")
        ), "pospath"("id_path", "spath") AS (
         SELECT DISTINCT "rg"."id_path",
            "first_value"("rg"."spath") OVER (PARTITION BY "rg"."id_path" ORDER BY "rg"."level" DESC) AS "first_value"
           FROM "rpos" "rg"
        )
 SELECT "p"."id_path" AS "id",
    COALESCE("p"."spath", ''::"text") AS "path"
   FROM "pospath" "p";


--
-- TOC entry 369 (class 1259 OID 121191)
-- Name: object_accounting; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_accounting" (
    "id_object" bigint NOT NULL,
    "inventory_number" character varying(100),
    "parents_inventory_number" character varying(100),
    "accounting_name" character varying(100),
    "year_registration" integer
);


--
-- TOC entry 370 (class 1259 OID 121196)
-- Name: object_commercial; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_commercial" (
    "id_object" bigint NOT NULL,
    "cunit_price" numeric NOT NULL
);


--
-- TOC entry 371 (class 1259 OID 121204)
-- Name: object_technical; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_technical" (
    "id_object" bigint NOT NULL,
    "technical_number" character varying(100),
    "dispatch_name" character varying(100),
    "technical_position" character varying(100),
    "serial_number" character varying(100)
);


--
-- TOC entry 444 (class 1259 OID 599495)
-- Name: vobject_general; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_general" AS
 SELECT "o"."id",
    "o"."name",
    "o"."id_conception",
    "o"."id_position",
    "o"."id_position_root",
    "o"."id_group",
    "o"."id_group_root",
    "o"."id_class",
    "o"."id_class_root",
    "o"."timestamp_class",
    "o"."barcode_unit",
    "o"."id_unit_conversion_rule",
    "o"."bquantity",
    "cr"."bunit",
    "cr"."mc",
    "round"(("o"."bquantity" / "cr"."mc"), "scale"("o"."bquantity")) AS "cquantity",
    "cr"."cunit",
    (EXISTS ( SELECT 1
           FROM "bpd"."object_technical" "t"
          WHERE ("t"."id_object" = "o"."id"))) AS "on_technical",
    (EXISTS ( SELECT 1
           FROM "bpd"."object_commercial" "c_1"
          WHERE ("c_1"."id_object" = "o"."id"))) AS "on_commercial",
    (EXISTS ( SELECT 1
           FROM "bpd"."object_accounting" "a"
          WHERE ("a"."id_object" = "o"."id"))) AS "on_accounting",
    "o"."timestamp",
    "o"."on_freeze",
    "o"."id_object_carrier",
    "o"."is_inside",
    "o"."desc",
    "o"."id_class_prop_object_carrier",
    "cr"."id_unit",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_prop_snapshot" "cps"
          WHERE (("cps"."id_class" = "o"."id_class") AND ("cps"."timestamp_class" = "o"."timestamp_class") AND ("cps"."id_prop_type" = 1)))) AS "has_user_property",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_prop_snapshot" "cps"
          WHERE (("cps"."id_class" = "o"."id_class") AND ("cps"."timestamp_class" = "o"."timestamp_class") AND ("cps"."id_prop_type" = 2)))) AS "has_enum_property",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_prop_snapshot" "cps"
          WHERE (("cps"."id_class" = "o"."id_class") AND ("cps"."timestamp_class" = "o"."timestamp_class") AND ("cps"."id_prop_type" = 3)))) AS "has_object_property",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_prop_snapshot" "cps"
          WHERE (("cps"."id_class" = "o"."id_class") AND ("cps"."timestamp_class" = "o"."timestamp_class") AND ("cps"."id_prop_type" = 4)))) AS "has_link_property",
    ("con"."pos_recycle" = "o"."id_position_root") AS "in_recycle",
    "cp"."quantity_show",
    "cp"."name_format",
    "o"."id_pos_temp_prop",
    "p_path"."path",
    "cr"."round"
   FROM (((("bpd"."object" "o"
     LEFT JOIN "bpd"."class_snapshot" "cp" ON ((("cp"."id" = "o"."id_class") AND ("cp"."timestamp" = "o"."timestamp_class"))))
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "o"."id_conception")))
     LEFT JOIN "bpd"."unit_conversion_rules" "cr" ON (("cr"."id" = "o"."id_unit_conversion_rule")))
     LEFT JOIN "bpd"."int_position_path" "p_path" ON (("p_path"."id" = "o"."id_position")));


--
-- TOC entry 483 (class 1259 OID 735555)
-- Name: object_prop_create_emded_mode; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."object_prop_create_emded_mode" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT ' '::character varying NOT NULL,
    "on" boolean DEFAULT true NOT NULL,
    "sort" integer DEFAULT 1 NOT NULL
);


--
-- TOC entry 484 (class 1259 OID 735566)
-- Name: vobject_prop_create_emded_mode; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_create_emded_mode" AS
 SELECT "object_prop_create_emded_mode"."id",
    "object_prop_create_emded_mode"."name",
    "object_prop_create_emded_mode"."desc",
    "object_prop_create_emded_mode"."on",
    "object_prop_create_emded_mode"."sort"
   FROM "bpd"."object_prop_create_emded_mode"
  ORDER BY "object_prop_create_emded_mode"."sort";

--
-- TOC entry 431 (class 1259 OID 509959)
-- Name: vobject_prop_enum_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_enum_val" AS
 SELECT "o"."id_conception",
    "o"."id" AS "id_object",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    ("ov"."id_object" IS NULL) AS "inheritance",
    COALESCE(COALESCE("ov"."id_prop_enum", "cv"."id_prop_enum"), ('-1'::integer)::bigint) AS "id_prop_enum",
    COALESCE(COALESCE("ov"."id_prop_enum_val", "cv"."id_prop_enum_val"), ('-1'::integer)::bigint) AS "id_prop_enum_val",
    COALESCE(COALESCE("ov_pev"."val_numeric", "cv_pev"."val_numeric"), (0)::numeric) AS "val_numeric",
    COALESCE(COALESCE("ov_pev"."val_varchar", "cv_pev"."val_varchar"), ''::character varying(100)) AS "val_varchar",
    COALESCE(COALESCE("ov_pev"."is_use", "cv_pev"."is_use"), false) AS "is_use",
    COALESCE(COALESCE("ov_pev"."id_object_reference", "cv_pev"."id_object_reference"), ('-1'::integer)::bigint) AS "id_object_reference",
    COALESCE(COALESCE("ov_pev"."has_object_reference", "cv_pev"."has_object_reference"), false) AS "has_object_reference",
    COALESCE(COALESCE((("ov"."tableoid")::"regclass")::character varying, (("cv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 1 THEN ("ov_pev"."val_varchar" IS NOT NULL)
            WHEN 3 THEN ("ov_pev"."val_numeric" IS NOT NULL)
            ELSE false
        END AS "on_val",
    COALESCE("o"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val"
   FROM ((((("bpd"."object" "o"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp" ON ((("o"."id_class" = "cp"."id_class") AND ("o"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN ONLY "bpd"."class_prop_enum_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN ONLY "bpd"."vprop_enum_val" "cv_pev" ON (("cv_pev"."id_prop_enum_val" = "cv"."id_prop_enum_val")))
     LEFT JOIN ONLY "bpd"."object_prop_enum_val" "ov" ON ((("ov"."id_class_prop" = "cp"."id") AND ("ov"."timestamp_class" = "cp"."timestamp_class") AND ("ov"."id_object" = "o"."id"))))
     LEFT JOIN ONLY "bpd"."vprop_enum_val" "ov_pev" ON (("ov_pev"."id_prop_enum_val" = "ov"."id_prop_enum_val")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[1, 3])) AND ("cp"."id_prop_type" = 2));



--
-- TOC entry 438 (class 1259 OID 519101)
-- Name: vobject_prop_link_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_link_val" AS
 SELECT "o"."id_conception",
    "o"."id" AS "id_object",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    ("ov"."id_object" IS NULL) AS "inheritance",
    COALESCE(COALESCE("ov"."id_entity", "cv"."id_entity"), 0) AS "id_entity",
    COALESCE(COALESCE("ov"."id_entity_instance", "cv"."id_entity_instance"), ('-1'::integer)::bigint) AS "id_entity_instance",
    COALESCE(COALESCE((("ov"."tableoid")::"regclass")::character varying, (("cv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
    ("ov"."id_entity_instance" IS NOT NULL) AS "on_val",
    COALESCE("o"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val",
    COALESCE(COALESCE("ov"."id_sub_entity_instance", "cv"."id_sub_entity_instance"), ('-1'::integer)::bigint) AS "id_sub_entity_instance"
   FROM ((("bpd"."object" "o"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp" ON ((("o"."id_class" = "cp"."id_class") AND ("o"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN ONLY "bpd"."class_prop_link_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN ONLY "bpd"."object_prop_link_val" "ov" ON ((("ov"."id_class_prop" = "cp"."id") AND ("ov"."timestamp_class" = "cp"."timestamp_class") AND ("ov"."id_object" = "o"."id"))))
  WHERE (("cp"."id_data_type" = 15) AND ("cp"."id_prop_type" = 4));


--
-- TOC entry 488 (class 1259 OID 791724)
-- Name: vobject_prop_object_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_object_val" AS
 SELECT "object_carrier"."id" AS "id_object_carrier",
    "object_carrier"."id_class" AS "id_class_object_carrier",
    "object_carrier"."timestamp_class" AS "timestamp_class_object_carrier",
    "cps"."id" AS "id_class_prop_object_carrier",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "object_val"
          WHERE (("object_val"."id_object_carrier" = "object_carrier"."id") AND ("cps"."id" = "object_val"."id_class_prop_object_carrier")))) AS "on_val",
    COALESCE(( SELECT "sum"("object_val"."bquantity") AS "sum"
           FROM "bpd"."object" "object_val"
          WHERE (("object_val"."id_object_carrier" = "object_carrier"."id") AND ("cps"."id" = "object_val"."id_class_prop_object_carrier"))), (0)::numeric) AS "bquantity",
    COALESCE("cpvs"."bquantity_max", ('-1'::integer)::numeric) AS "bquantity_max",
    COALESCE("cpvs"."bquantity_min", ('-1'::integer)::numeric) AS "bquantity_min",
    COALESCE("cpvs"."id_class_val", (0)::bigint) AS "id_class_val",
    COALESCE("cpvs"."timestamp_class_val", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_val",
    ("cpvs"."id_class_val" IS NULL) AS "not_set",
    COALESCE("object_carrier"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val",
    COALESCE((("cpvs"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
    "cpvs"."embed_mode",
    "cpvs"."embed_single",
    "cpvs"."embed_class_real_id",
    "cpvs"."id_unit_conversion_rule"
   FROM (("bpd"."object" "object_carrier"
     LEFT JOIN "bpd"."class_prop_snapshot" "cps" ON ((("object_carrier"."id_class" = "cps"."id_class") AND ("object_carrier"."timestamp_class" = "cps"."timestamp_class"))))
     LEFT JOIN "bpd"."class_prop_obj_val_class_snapshot" "cpvs" ON ((("cpvs"."id_class_prop" = "cps"."id") AND ("cpvs"."timestamp_class" = "cps"."timestamp_class"))))
  WHERE (("object_carrier"."id" IS NOT NULL) AND ("cps"."id_prop_type" = 3));


--
-- TOC entry 461 (class 1259 OID 620785)
-- Name: vobject_prop_user_big_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_user_big_val" AS
 SELECT "o"."id" AS "id_object",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    ("ov"."id_object" IS NULL) AS "inheritance",
    "cv"."min_val",
    "cv"."min_on",
    "cv"."max_val",
    "cv"."max_on",
    COALESCE("ov"."val_text", "cv"."val_text") AS "val_text",
    COALESCE("ov"."val_bytea", "cv"."val_bytea") AS "val_bytea",
    COALESCE("ov"."val_json", "cv"."val_json") AS "val_json",
    COALESCE(COALESCE((("ov"."tableoid")::"regclass")::character varying, (("cv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 7 THEN (("cv"."val_text" IS NOT NULL) OR ("ov"."val_text" IS NOT NULL))
            WHEN 8 THEN (("cv"."val_bytea" IS NOT NULL) OR ("ov"."val_bytea" IS NOT NULL))
            WHEN 14 THEN (("cv"."val_json" IS NOT NULL) OR ("ov"."val_json" IS NOT NULL))
            ELSE NULL::boolean
        END AS "on_val",
    COALESCE("o"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val",
    "sl"."max_used",
    "sl"."min_used"
   FROM (((("bpd"."object" "o"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp" ON ((("o"."id_class" = "cp"."id_class") AND ("o"."timestamp_class" = "cp"."timestamp_class") AND ("cp"."id_data_type" = ANY (ARRAY[7, 8, 14])) AND ("cp"."id_prop_type" = 1))))
     LEFT JOIN "bpd"."class_prop_user_big_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."object_prop_user_big_val" "ov" ON ((("ov"."id_class_prop" = "cp"."id") AND ("ov"."timestamp_class" = "cp"."timestamp_class") AND ("ov"."id_object" = "o"."id"))))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "cp"."id_data_type")));


--
-- TOC entry 416 (class 1259 OID 410976)
-- Name: vobject_prop_user_small_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_user_small_val" AS
 SELECT "o"."id" AS "id_object",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    ("ov"."id_object" IS NULL) AS "inheritance",
    "cv"."min_val",
    "cv"."min_on",
    "cv"."max_val",
    "cv"."max_on",
    "cv"."round",
    "cv"."round_on",
    COALESCE("ov"."val_varchar", "cv"."val_varchar") AS "val_varchar",
    COALESCE("ov"."val_int", "cv"."val_int") AS "val_int",
    COALESCE("ov"."val_numeric", "cv"."val_numeric") AS "val_numeric",
    COALESCE("ov"."val_real", "cv"."val_real") AS "val_real",
    COALESCE("ov"."val_double", "cv"."val_double") AS "val_double",
    COALESCE("ov"."val_money", "cv"."val_money") AS "val_money",
    COALESCE("ov"."val_boolean", "cv"."val_boolean") AS "val_boolean",
    COALESCE("ov"."val_date", "cv"."val_date") AS "val_date",
    COALESCE("ov"."val_time", "cv"."val_time") AS "val_time",
    COALESCE("ov"."val_interval", "cv"."val_interval") AS "val_interval",
    COALESCE("ov"."val_timestamp", "cv"."val_timestamp") AS "val_timestamp",
    COALESCE("ov"."val_bigint", "cv"."val_bigint") AS "val_bigint",
    COALESCE(COALESCE((("ov"."tableoid")::"regclass")::character varying, (("cv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 1 THEN (("cv"."val_varchar" IS NOT NULL) OR ("ov"."val_varchar" IS NOT NULL))
            WHEN 2 THEN (("cv"."val_int" IS NOT NULL) OR ("ov"."val_int" IS NOT NULL))
            WHEN 3 THEN (("cv"."val_numeric" IS NOT NULL) OR ("ov"."val_numeric" IS NOT NULL))
            WHEN 4 THEN (("cv"."val_real" IS NOT NULL) OR ("ov"."val_real" IS NOT NULL))
            WHEN 5 THEN (("cv"."val_double" IS NOT NULL) OR ("ov"."val_double" IS NOT NULL))
            WHEN 6 THEN (("cv"."val_money" IS NOT NULL) OR ("ov"."val_money" IS NOT NULL))
            WHEN 9 THEN (("cv"."val_boolean" IS NOT NULL) OR ("ov"."val_boolean" IS NOT NULL))
            WHEN 10 THEN (("cv"."val_date" IS NOT NULL) OR ("ov"."val_date" IS NOT NULL))
            WHEN 11 THEN (("cv"."val_time" IS NOT NULL) OR ("ov"."val_time" IS NOT NULL))
            WHEN 12 THEN (("cv"."val_interval" IS NOT NULL) OR ("ov"."val_interval" IS NOT NULL))
            WHEN 13 THEN (("cv"."val_timestamp" IS NOT NULL) OR ("ov"."val_timestamp" IS NOT NULL))
            WHEN 15 THEN (("cv"."val_bigint" IS NOT NULL) OR ("ov"."val_bigint" IS NOT NULL))
            ELSE NULL::boolean
        END AS "on_val",
    COALESCE("o"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val",
    "sl"."max_used",
    "sl"."min_used",
    "sl"."round_used"
   FROM (((("bpd"."object" "o"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp" ON ((("o"."id_class" = "cp"."id_class") AND ("o"."timestamp_class" = "cp"."timestamp_class") AND ("cp"."id_data_type" = ANY (ARRAY[1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 15])) AND ("cp"."id_prop_type" = 1))))
     LEFT JOIN "bpd"."class_prop_user_small_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."object_prop_user_small_val" "ov" ON ((("ov"."id_object" = "o"."id") AND ("ov"."id_class_prop" = "cp"."id") AND ("ov"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "cp"."id_data_type")));


--
-- TOC entry 543 (class 1259 OID 1160706)
-- Name: work_time_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_time_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 534 (class 1259 OID 1158706)
-- Name: plan_range; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_range" (
    "id" bigint DEFAULT "nextval"('"bpd"."work_time_id_seq"'::"regclass") NOT NULL,
    "id_plan" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "range_plan" "tsrange" NOT NULL,
    "on" boolean NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL,
    "range_plan_upper" timestamp without time zone GENERATED ALWAYS AS ("upper"("range_plan")) STORED,
    "range_plan_lower" timestamp without time zone GENERATED ALWAYS AS ("lower"("range_plan")) STORED,
    "range_plan_upper_inc" boolean GENERATED ALWAYS AS ("upper_inc"("range_plan")) STORED,
    "range_plan_lower_inc" boolean GENERATED ALWAYS AS ("lower_inc"("range_plan")) STORED,
    "range_plan_type" "bpd"."range_work_type" NOT NULL
);

--
-- TOC entry 337 (class 1259 OID 40770)
-- Name: cfg_prototype_desc; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_prototype_desc" (
    "prop" character varying(2044) NOT NULL,
    "val" boolean NOT NULL,
    "desc" character varying(2044) NOT NULL
);


--
-- TOC entry 317 (class 1259 OID 25774)
-- Name: pos_prototype; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_prototype" (
    "id" integer NOT NULL,
    "on_pos" boolean NOT NULL,
    "on_obj" boolean NOT NULL,
    "on_this" boolean DEFAULT false NOT NULL,
    "sort" integer DEFAULT 1 NOT NULL,
    "on_root" boolean DEFAULT false NOT NULL,
    "on_service" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 393 (class 1259 OID 229609)
-- Name: vpos_prototype; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_prototype" AS
 SELECT "pos_prototype"."id",
    "pos_prototype"."on_root",
    "pos_prototype"."on_this",
    "pos_prototype"."on_pos",
    "pos_prototype"."on_obj",
    (((((((
        CASE
            WHEN "pos_prototype"."on_root" THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_root'::"text") AND "cfg_prototype_desc"."val"))
            WHEN (NOT "pos_prototype"."on_root") THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_root'::"text") AND (NOT "cfg_prototype_desc"."val")))
            ELSE NULL::character varying
        END)::"text" || '; '::"text") || (
        CASE
            WHEN "pos_prototype"."on_this" THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_this'::"text") AND "cfg_prototype_desc"."val"))
            WHEN (NOT "pos_prototype"."on_this") THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_this'::"text") AND (NOT "cfg_prototype_desc"."val")))
            ELSE NULL::character varying
        END)::"text") || '; '::"text") || (
        CASE
            WHEN "pos_prototype"."on_pos" THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_pos'::"text") AND "cfg_prototype_desc"."val"))
            WHEN (NOT "pos_prototype"."on_pos") THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_pos'::"text") AND (NOT "cfg_prototype_desc"."val")))
            ELSE NULL::character varying
        END)::"text") || '; '::"text") || (
        CASE
            WHEN "pos_prototype"."on_obj" THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_obj'::"text") AND "cfg_prototype_desc"."val"))
            WHEN (NOT "pos_prototype"."on_obj") THEN ( SELECT "cfg_prototype_desc"."desc"
               FROM "bpd"."cfg_prototype_desc"
              WHERE ((("cfg_prototype_desc"."prop")::"text" = 'on_obj'::"text") AND (NOT "cfg_prototype_desc"."val")))
            ELSE NULL::character varying
        END)::"text") AS "desc",
    "pos_prototype"."sort",
    "pos_prototype"."on_service"
   FROM "bpd"."pos_prototype"
  ORDER BY "pos_prototype"."sort";



--
-- TOC entry 566 (class 1259 OID 1209575)
-- Name: vpos_temp; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp" AS
 SELECT "pt"."id",
    "pt"."id_con",
    "pt"."id_prototype",
    "pt"."name",
    "pt"."desc",
    "pt"."on_nested_limit",
    "pt"."on",
    "ppt"."on_root",
    "ppt"."on_this",
    "ppt"."on_pos",
    "ppt"."on_obj",
    "ppt"."on_service",
    "pt"."timestamp"
   FROM ("bpd"."pos_temp" "pt"
     LEFT JOIN "bpd"."pos_prototype" "ppt" ON (("ppt"."id" = "pt"."id_prototype")));

--
-- TOC entry 324 (class 1259 OID 28782)
-- Name: pos_temp_nested_limit; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_nested_limit" (
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_nested" bigint NOT NULL,
    "pos_temp_nested_limit" integer DEFAULT 0 NOT NULL,
    "id_con" bigint DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 383 (class 1259 OID 175411)
-- Name: vpos_temp_nested_rule; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_nested_rule" AS
 SELECT "r"."id_con",
    "r"."id_pos_temp",
    "r"."id_pos_temp_nested",
    ("r"."pos_temp_nested_limit" > 0) AS "on_limit",
    "r"."pos_temp_nested_limit" AS "limit_max",
    COALESCE(( SELECT ("max"("x"."res"))::integer AS "max"
           FROM ( SELECT "count"("tpos_nested"."id_pos_temp") AS "res"
                   FROM ("bpd"."position" "tpos_nested"
                     JOIN "bpd"."position" "tpos" ON (("tpos"."id" = "tpos_nested"."id_parent")))
                  WHERE (("tpos"."id_pos_temp" = "r"."id_pos_temp") AND ("tpos_nested"."id_pos_temp" = "r"."id_pos_temp_nested"))
                  GROUP BY "tpos_nested"."id_pos_temp", "tpos"."id") "x"), 0) AS "limit_min",
    true AS "is_create",
    (EXISTS ( SELECT 1
           FROM ("bpd"."position" "tpos_nested"
             JOIN "bpd"."position" "tpos" ON (("tpos"."id" = "tpos_nested"."id_parent")))
          WHERE (("tpos"."id_pos_temp" = "r"."id_pos_temp") AND ("tpos_nested"."id_pos_temp" = "r"."id_pos_temp_nested")))) AS "is_use"
   FROM "bpd"."pos_temp_nested_limit" "r";




--
-- TOC entry 447 (class 1259 OID 611713)
-- Name: pos_temp_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_prop" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_prop_type" integer NOT NULL,
    "id_data_type" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) NOT NULL,
    "on_override" boolean NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL
);


--
-- TOC entry 453 (class 1259 OID 611840)
-- Name: pos_temp_prop_link_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_prop_link_val" (
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer
);


--
-- TOC entry 455 (class 1259 OID 611849)
-- Name: pos_temp_prop_obj_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_prop_obj_val" (
    "id" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_class_val" bigint,
    "timestamp_class_val" timestamp without time zone,
    "bquantity_max" numeric DEFAULT '-1'::integer NOT NULL,
    "bquantity_min" numeric DEFAULT '-1'::integer NOT NULL,
    "embed_mode" integer DEFAULT 0 NOT NULL,
    "embed_single" boolean DEFAULT true NOT NULL,
    "embed_class_real_id" bigint DEFAULT '-1'::integer NOT NULL,
    "id_unit_conversion_rule" integer DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 456 (class 1259 OID 611862)
-- Name: pos_temp_prop_user_big_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_prop_user_big_val" (
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "max_on" boolean DEFAULT false NOT NULL,
    "max_val" numeric DEFAULT 500 NOT NULL,
    "min_on" boolean DEFAULT false NOT NULL,
    "min_val" numeric DEFAULT 1 NOT NULL,
    "val_text" "text",
    "val_bytea" "bytea",
    "val_json" "json"
);


--
-- TOC entry 457 (class 1259 OID 611882)
-- Name: pos_temp_prop_user_small_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."pos_temp_prop_user_small_val" (
    "id_pos_temp" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "max_on" boolean DEFAULT false NOT NULL,
    "max_val" numeric NOT NULL,
    "min_on" boolean DEFAULT false NOT NULL,
    "min_val" numeric DEFAULT 0 NOT NULL,
    "round_on" boolean DEFAULT false NOT NULL,
    "round" integer NOT NULL,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_real" real,
    "val_numeric" numeric,
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_timestamp" timestamp without time zone,
    "val_money" "money",
    "val_double" double precision,
    "val_bigint" bigint
);


--
-- TOC entry 581 (class 1259 OID 1302072)
-- Name: vpos_temp_prop; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_prop" AS
 SELECT "ptp"."id",
    "ptp"."id_conception",
    "ptp"."id_pos_temp",
    "ptp"."id_prop_type",
    "ptp"."id_data_type",
    "ptp"."name",
    "ptp"."desc",
    "ptp"."sort",
    "ptp"."on_override",
        CASE "ptp"."id_prop_type"
            WHEN 1 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END
            WHEN 2 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END
            WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
            WHEN 4 THEN (COALESCE("lv"."id_entity_instance", (0)::bigint) > 0)
            ELSE false
        END AS "on_val",
        CASE "ptp"."id_prop_type"
            WHEN 1 THEN (
            CASE "ptp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END OR "ptp"."on_override")
            WHEN 2 THEN (
            CASE "ptp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END OR ("ptp"."on_override" AND ("ev"."id_prop_enum" IS NOT NULL)))
            WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
            WHEN 4 THEN ((COALESCE("lv"."id_entity_instance", (0)::bigint) > 0) OR ("ptp"."on_override" AND ("lv"."id_entity" IS NOT NULL)))
            ELSE false
        END AS "ready",
    ("lpt"."id_global_prop" IS NOT NULL) AS "on_global",
    COALESCE("lpt"."id_global_prop", ('-1'::integer)::bigint) AS "id_global_prop",
    "ptp"."timestamp",
    COALESCE(
        CASE "ptp"."id_prop_type"
            WHEN 1 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN "sv"."val_varchar"
                WHEN 2 THEN ("sv"."val_int")::character varying
                WHEN 3 THEN ("sv"."val_numeric")::character varying
                WHEN 4 THEN ("sv"."val_real")::character varying
                WHEN 5 THEN ("sv"."val_double")::character varying
                WHEN 6 THEN (("sv"."val_money")::numeric)::character varying
                WHEN 7 THEN 'Текст'::character varying
                WHEN 8 THEN 'Изображение'::character varying
                WHEN 9 THEN ("sv"."val_boolean")::character varying
                WHEN 10 THEN ("sv"."val_date")::character varying
                WHEN 11 THEN ("sv"."val_time")::character varying
                WHEN 12 THEN ("sv"."val_interval")::character varying
                WHEN 13 THEN ("sv"."val_timestamp")::character varying
                WHEN 14 THEN 'Json'::character varying
                WHEN 15 THEN ("sv"."val_bigint")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 2 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN "pev"."val_varchar"
                WHEN 3 THEN ("pev"."val_numeric")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 3 THEN 'Объект'::character varying
            WHEN 4 THEN 'Ссылка'::character varying
            ELSE 'н/д'::character varying
        END, 'н/д'::character varying) AS "string_val"
   FROM ((((((((("bpd"."pos_temp_prop" "ptp"
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_user_small_val" "sv" ON (("sv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."pos_temp_prop_user_big_val" "bv" ON (("bv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."pos_temp_prop_enum_val" "ev" ON (("ev"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")))
     LEFT JOIN "bpd"."pos_temp_prop_link_val" "lv" ON (("lv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."pos_temp_prop_obj_val" "ov" ON (("ov"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN ONLY "bpd"."class" "class_val" ON (("class_val"."id" = "ov"."id_class_val")))
     LEFT JOIN "bpd"."global_prop_link_pos_temp_prop" "lpt" ON (("lpt"."id_pos_temp_prop" = "ptp"."id")));


--
-- TOC entry 466 (class 1259 OID 636961)
-- Name: vpos_temp_prop_enum_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_prop_enum_val" AS
 SELECT "ptp"."id_conception",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    COALESCE("cv"."id_prop_enum", ('-1'::integer)::bigint) AS "id_prop_enum",
    COALESCE("cv"."id_prop_enum_val", ('-1'::integer)::bigint) AS "id_prop_enum_val",
    COALESCE("pev"."val_numeric", (0)::numeric) AS "val_numeric",
    COALESCE("pev"."val_varchar", ''::character varying(100)) AS "val_varchar",
    COALESCE("pev"."is_use", false) AS "is_use",
    COALESCE("pev"."id_object_reference", ('-1'::integer)::bigint) AS "id_object_reference",
    COALESCE("pev"."has_object_reference", false) AS "has_object_reference",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "ptp"."id_data_type"
            WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
            WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
            ELSE false
        END AS "on_val",
    "pt"."timestamp"
   FROM ((("bpd"."pos_temp_prop" "ptp"
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_enum_val" "cv" ON (("cv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."vprop_enum_val" "pev" ON (("pev"."id_prop_enum_val" = "cv"."id_prop_enum_val")))
  WHERE (("ptp"."id_data_type" = ANY (ARRAY[1, 3, 15])) AND ("ptp"."id_prop_type" = 2));

--
-- TOC entry 468 (class 1259 OID 636977)
-- Name: vpos_temp_prop_link_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_prop_link_val" AS
 SELECT "ptp"."id_conception",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    COALESCE("cv"."id_entity", 0) AS "id_entity",
    COALESCE("cv"."id_entity_instance", (0)::bigint) AS "id_entity_instance",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
    ("cv"."id_entity_instance" IS NOT NULL) AS "on_val",
    COALESCE("cv"."id_sub_entity_instance", (0)::bigint) AS "id_sub_entity_instance",
    "pt"."timestamp"
   FROM ((ONLY "bpd"."pos_temp_prop" "ptp"
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_link_val" "cv" ON (("cv"."id_pos_temp_prop" = "ptp"."id")))
  WHERE (("ptp"."id_data_type" = 15) AND ("ptp"."id_prop_type" = 4));


--
-- TOC entry 467 (class 1259 OID 636966)
-- Name: vpos_temp_prop_object_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_prop_object_val" AS
 SELECT "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_pos_temp",
    COALESCE("cv"."id", '-1'::bigint) AS "id",
    ("class_val"."id" IS NOT NULL) AS "on_val",
    COALESCE("cv"."id_class_val", '-1'::bigint) AS "id_class_val",
    COALESCE("cv"."timestamp_class_val", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_val",
    COALESCE("cv"."bquantity_max", '-1'::numeric) AS "bquantity_max",
    COALESCE("cv"."bquantity_min", ('-1'::integer)::numeric) AS "bquantity_min",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
    "pt"."timestamp",
        CASE
            WHEN ("cv"."embed_mode" = ANY (ARRAY[0, 1, 2])) THEN COALESCE("cv"."embed_mode", 0)
            ELSE 0
        END AS "embed_mode",
    COALESCE("cv"."embed_single", false) AS "embed_single",
    COALESCE("cv"."embed_class_real_id", ('-1'::integer)::bigint) AS "embed_class_real_id",
    COALESCE("cv"."id_unit_conversion_rule", '-1'::integer) AS "id_unit_conversion_rule"
   FROM (((ONLY "bpd"."pos_temp_prop" "ptp"
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_obj_val" "cv" ON (("cv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN ONLY "bpd"."class" "class_val" ON (("class_val"."id" = "cv"."id_class_val")))
  WHERE ("ptp"."id_prop_type" = 3);

--
-- TOC entry 465 (class 1259 OID 636925)
-- Name: vpos_temp_prop_user_big_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_prop_user_big_val" AS
 SELECT "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    COALESCE("cv"."min_val", ('-1'::integer)::numeric) AS "min_val",
    COALESCE("cv"."min_on", false) AS "min_on",
    COALESCE("cv"."max_val", ('-1'::integer)::numeric) AS "max_val",
    COALESCE("cv"."max_on", false) AS "max_on",
    "cv"."val_text",
    "cv"."val_bytea",
    "cv"."val_json",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "ptp"."id_data_type"
            WHEN 7 THEN ("cv"."val_text" IS NOT NULL)
            WHEN 8 THEN ("cv"."val_bytea" IS NOT NULL)
            WHEN 14 THEN ("cv"."val_json" IS NOT NULL)
            ELSE NULL::boolean
        END AS "on_val",
    "sl"."max_used",
    "sl"."min_used",
    "pt"."timestamp"
   FROM ((("bpd"."pos_temp_prop" "ptp"
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_user_big_val" "cv" ON (("cv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "ptp"."id_data_type")))
  WHERE (("ptp"."id_data_type" = ANY (ARRAY[7, 8, 14])) AND ("ptp"."id_prop_type" = 1));


--
-- TOC entry 464 (class 1259 OID 636902)
-- Name: vpos_temp_prop_user_small_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vpos_temp_prop_user_small_val" AS
 SELECT "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    COALESCE("cv"."min_val", ('-1'::integer)::numeric) AS "min_val",
    COALESCE("cv"."min_on", false) AS "min_on",
    COALESCE("cv"."max_val", ('-1'::integer)::numeric) AS "max_val",
    COALESCE("cv"."max_on", false) AS "max_on",
    COALESCE("cv"."round", 3) AS "round",
    COALESCE("cv"."round_on", false) AS "round_on",
    "cv"."val_varchar",
    "cv"."val_int",
    "cv"."val_numeric",
    "cv"."val_real",
    "cv"."val_double",
    "cv"."val_money",
    "cv"."val_boolean",
    "cv"."val_date",
    "cv"."val_time",
    "cv"."val_interval",
    "cv"."val_timestamp",
    "cv"."val_bigint",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "ptp"."id_data_type"
            WHEN 1 THEN ("cv"."val_varchar" IS NOT NULL)
            WHEN 2 THEN ("cv"."val_int" IS NOT NULL)
            WHEN 3 THEN ("cv"."val_numeric" IS NOT NULL)
            WHEN 4 THEN ("cv"."val_real" IS NOT NULL)
            WHEN 5 THEN ("cv"."val_double" IS NOT NULL)
            WHEN 6 THEN ("cv"."val_money" IS NOT NULL)
            WHEN 9 THEN ("cv"."val_boolean" IS NOT NULL)
            WHEN 10 THEN ("cv"."val_date" IS NOT NULL)
            WHEN 11 THEN ("cv"."val_time" IS NOT NULL)
            WHEN 12 THEN ("cv"."val_interval" IS NOT NULL)
            WHEN 13 THEN ("cv"."val_timestamp" IS NOT NULL)
            WHEN 15 THEN ("cv"."val_bigint" IS NOT NULL)
            ELSE NULL::boolean
        END AS "on_val",
    "sl"."max_used",
    "sl"."min_used",
    "sl"."round_used",
    "pt"."timestamp"
   FROM ((("bpd"."pos_temp_prop" "ptp"
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_user_small_val" "cv" ON (("cv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "ptp"."id_data_type")))
  WHERE (("ptp"."id_data_type" = ANY (ARRAY[1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 15])) AND ("ptp"."id_prop_type" = 1));


--
-- TOC entry 395 (class 1259 OID 230614)
-- Name: rulel2_class_on_position; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."rulel2_class_on_position" (
    "id_position" bigint NOT NULL,
    "id_class" bigint NOT NULL
);


--
-- TOC entry 443 (class 1259 OID 555031)
-- Name: vposition; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition" AS
 SELECT "p"."id",
    "p"."id_parent",
    "p"."id_root",
    "p"."level",
    "p"."id_con",
    "p"."id_pos_temp",
    "p"."name",
    "p"."desc",
    "p"."lockdel",
    "p"."on_service",
    ("con"."pos_recycle" = "p"."id") AS "on_recycle",
    (("con"."pos_recycle" = "p"."id_root") AND ("con"."pos_recycle" <> "p"."id")) AS "in_recycle",
    "p"."sort",
    "p"."timestamp",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."object" "o"
          WHERE ("o"."id_position" = "p"."id"))) AS "include_object",
    "p"."id_prototype",
    "p"."timestamp_child_change",
    ("p"."level" = 0) AS "is_root",
    "ppt"."on_obj" AS "on_object",
    (EXISTS ( SELECT 1
           FROM "bpd"."rulel2_class_on_position" "rl2"
          WHERE ("rl2"."id_position" = "p"."id"))) AS "on_rulel2_class_on_position",
    "pt"."name" AS "pos_temp_name",
    "p_path"."path"
   FROM (((("bpd"."position" "p"
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "p"."id_con")))
     LEFT JOIN "bpd"."pos_prototype" "ppt" ON (("ppt"."id" = "p"."id_prototype")))
     LEFT JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "p"."id_pos_temp")))
     LEFT JOIN "bpd"."int_position_path" "p_path" ON (("p_path"."id" = "p"."id")));


--
-- TOC entry 449 (class 1259 OID 611737)
-- Name: position_prop_link_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."position_prop_link_val" (
    "id_position" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer
);


--
-- TOC entry 450 (class 1259 OID 611742)
-- Name: position_prop_user_big_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."position_prop_user_big_val" (
    "id_position" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "val_text" "text",
    "val_bytea" "bytea",
    "val_json" "json"
);


--
-- TOC entry 451 (class 1259 OID 611750)
-- Name: position_prop_user_small_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."position_prop_user_small_val" (
    "id_position" bigint NOT NULL,
    "id_pos_temp_prop" bigint NOT NULL,
    "id_pos_temp" bigint NOT NULL,
    "id_data_type" integer NOT NULL,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_real" real,
    "val_numeric" numeric,
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_timestamp" timestamp without time zone,
    "val_money" "money",
    "val_double" double precision,
    "val_bigint" bigint NOT NULL
);


--
-- TOC entry 582 (class 1259 OID 1302080)
-- Name: vposition_prop; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition_prop" AS
 SELECT DISTINCT "ptp"."id_conception",
    "p"."id" AS "id_position_carrier",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_prop_type",
    "ptp"."id_data_type",
    "ptp"."name",
    "ptp"."desc",
    "ptp"."sort",
    "ptp"."on_override",
        CASE "ptp"."id_prop_type"
            WHEN 1 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END
            WHEN 2 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END
            WHEN 3 THEN (EXISTS ( SELECT 1
               FROM "bpd"."object" "ov"
              WHERE (("ov"."id_position" = "p"."id") AND ("ov"."id_pos_temp_prop" = "ptp"."id"))))
            WHEN 4 THEN ("lv"."id_entity_instance" IS NOT NULL)
            ELSE false
        END AS "on_val_position",
    "ptp"."on_val" AS "on_val_pos_temp",
    ("lpt"."id_global_prop" IS NOT NULL) AS "on_global",
    COALESCE("lpt"."id_global_prop", ('-1'::integer)::bigint) AS "id_global_prop",
    "p"."timestamp" AS "timestamp_position_carrier",
    "p"."id_root" AS "id_position_root",
    COALESCE(
        CASE "ptp"."id_prop_type"
            WHEN 1 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN COALESCE("sv"."val_varchar", "ptp"."string_val")
                WHEN 2 THEN COALESCE(("sv"."val_int")::character varying, "ptp"."string_val")
                WHEN 3 THEN COALESCE(("sv"."val_numeric")::character varying, "ptp"."string_val")
                WHEN 4 THEN COALESCE(("sv"."val_real")::character varying, "ptp"."string_val")
                WHEN 5 THEN COALESCE(("sv"."val_double")::character varying, "ptp"."string_val")
                WHEN 6 THEN COALESCE((("sv"."val_money")::numeric)::character varying, "ptp"."string_val")
                WHEN 7 THEN 'Текст'::character varying
                WHEN 8 THEN 'Изображение'::character varying
                WHEN 9 THEN COALESCE(("sv"."val_boolean")::character varying, "ptp"."string_val")
                WHEN 10 THEN COALESCE(("sv"."val_date")::character varying, "ptp"."string_val")
                WHEN 11 THEN COALESCE(("sv"."val_time")::character varying, "ptp"."string_val")
                WHEN 12 THEN COALESCE(("sv"."val_interval")::character varying, "ptp"."string_val")
                WHEN 13 THEN COALESCE(("sv"."val_timestamp")::character varying, "ptp"."string_val")
                WHEN 14 THEN 'Json'::character varying
                WHEN 15 THEN COALESCE(("sv"."val_bigint")::character varying, "ptp"."string_val")
                ELSE 'н/д'::character varying
            END
            WHEN 2 THEN
            CASE "ptp"."id_data_type"
                WHEN 1 THEN COALESCE("pev"."val_varchar", "ptp"."string_val")
                WHEN 3 THEN COALESCE(("pev"."val_numeric")::character varying, "ptp"."string_val")
                ELSE 'н/д'::character varying
            END
            WHEN 3 THEN 'Объект'::character varying
            WHEN 4 THEN 'Ссылка'::character varying
            ELSE 'н/д'::character varying
        END, 'н/д'::character varying) AS "string_val"
   FROM ((((((("bpd"."position" "p"
     JOIN "bpd"."vpos_temp_prop" "ptp" ON (("ptp"."id_pos_temp" = "p"."id_pos_temp")))
     LEFT JOIN "bpd"."position_prop_user_small_val" "sv" ON ((("sv"."id_pos_temp_prop" = "ptp"."id") AND ("sv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."position_prop_user_big_val" "bv" ON ((("bv"."id_pos_temp_prop" = "ptp"."id") AND ("bv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."position_prop_enum_val" "ev" ON ((("ev"."id_pos_temp_prop" = "ptp"."id") AND ("ev"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")))
     LEFT JOIN "bpd"."position_prop_link_val" "lv" ON ((("lv"."id_pos_temp_prop" = "ptp"."id") AND ("lv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."global_prop_link_pos_temp_prop" "lpt" ON (("lpt"."id_pos_temp_prop" = "ptp"."id")));


--
-- TOC entry 482 (class 1259 OID 703447)
-- Name: vposition_prop_enum_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition_prop_enum_val" AS
 SELECT "p"."id_con" AS "id_conception",
    "p"."id" AS "id_position",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    true AS "inheritance",
    COALESCE(COALESCE("pv"."id_prop_enum", "ptv"."id_prop_enum"), ('-1'::integer)::bigint) AS "id_prop_enum",
    COALESCE(COALESCE("pv"."id_prop_enum_val", "ptv"."id_prop_enum_val"), ('-1'::integer)::bigint) AS "id_prop_enum_val",
    COALESCE(COALESCE("ov_pev"."val_numeric", "pv_pev"."val_numeric"), (0)::numeric) AS "val_numeric",
    COALESCE(COALESCE("ov_pev"."val_varchar", "pv_pev"."val_varchar"), ''::character varying(100)) AS "val_varchar",
    COALESCE(COALESCE("ov_pev"."is_use", "pv_pev"."is_use"), false) AS "is_use",
    COALESCE(COALESCE("ov_pev"."id_object_reference", "pv_pev"."id_object_reference"), ('-1'::integer)::bigint) AS "id_object_reference",
    COALESCE(COALESCE("ov_pev"."has_object_reference", "pv_pev"."has_object_reference"), false) AS "has_object_reference",
    COALESCE(COALESCE((("pv"."tableoid")::"regclass")::character varying, (("pv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
        CASE "ptp"."id_data_type"
            WHEN 1 THEN ("ov_pev"."val_varchar" IS NOT NULL)
            WHEN 3 THEN ("ov_pev"."val_numeric" IS NOT NULL)
            ELSE false
        END AS "on_val",
    COALESCE("p"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val"
   FROM ((((("bpd"."position" "p"
     LEFT JOIN "bpd"."pos_temp_prop" "ptp" ON (("p"."id_pos_temp" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_enum_val" "ptv" ON (("ptv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."vprop_enum_val" "pv_pev" ON (("pv_pev"."id_prop_enum_val" = "ptv"."id_prop_enum_val")))
     LEFT JOIN "bpd"."position_prop_enum_val" "pv" ON ((("pv"."id_pos_temp_prop" = "ptp"."id") AND ("pv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."vprop_enum_val" "ov_pev" ON (("ov_pev"."id_prop_enum_val" = "pv"."id_prop_enum_val")))
  WHERE (("ptp"."id_data_type" = ANY (ARRAY[1, 3])) AND ("ptp"."id_prop_type" = 2));


--
-- TOC entry 469 (class 1259 OID 637034)
-- Name: vposition_prop_link_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition_prop_link_val" AS
 SELECT "p"."id_con" AS "id_conception",
    "p"."id" AS "id_position",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    ("pv"."id_position" IS NULL) AS "inheritance",
    COALESCE(COALESCE("pv"."id_entity", "ptv"."id_entity"), 0) AS "id_entity",
    COALESCE(COALESCE("pv"."id_entity_instance", "ptv"."id_entity_instance"), ('-1'::integer)::bigint) AS "id_entity_instance",
    COALESCE(COALESCE((("pv"."tableoid")::"regclass")::character varying, (("ptv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
    ("pv"."id_entity_instance" IS NOT NULL) AS "on_val",
    COALESCE("p"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val",
    COALESCE(COALESCE("pv"."id_sub_entity_instance", "ptv"."id_sub_entity_instance"), ('-1'::integer)::bigint) AS "id_sub_entity_instance"
   FROM ((("bpd"."position" "p"
     LEFT JOIN "bpd"."pos_temp_prop" "ptp" ON (("p"."id_pos_temp" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_link_val" "ptv" ON (("ptv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."position_prop_link_val" "pv" ON ((("pv"."id_pos_temp_prop" = "ptp"."id") AND ("pv"."id_position" = "p"."id"))))
  WHERE (("ptp"."id_data_type" = 15) AND ("ptp"."id_prop_type" = 4));


--
-- TOC entry 583 (class 1259 OID 1302088)
-- Name: vposition_prop_object_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition_prop_object_val" AS
 SELECT "position_carrier"."id" AS "id_position_carrier",
    "position_carrier"."id_root" AS "id_position_root_carrier",
    "position_carrier"."id_pos_temp" AS "id_pos_temp_position_carrier",
    "ptp"."id" AS "id_pos_temp_prop_position_carrier",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "object_val"
          WHERE (("object_val"."id_position" = "position_carrier"."id") AND ("ptp"."id" = "object_val"."id_pos_temp_prop")))) AS "on_val",
    COALESCE(( SELECT "sum"("object_val"."bquantity") AS "sum"
           FROM "bpd"."object" "object_val"
          WHERE (("object_val"."id_position" = "position_carrier"."id") AND ("ptp"."id" = "object_val"."id_pos_temp_prop"))), (0)::numeric) AS "bquantity",
    COALESCE("ptpv"."bquantity_max", ('-1'::integer)::numeric) AS "bquantity_max",
    COALESCE("ptpv"."bquantity_min", ('-1'::integer)::numeric) AS "bquantity_min",
    COALESCE("ptpv"."id_class_val", ('-1'::integer)::bigint) AS "id_class_val",
    COALESCE("ptpv"."timestamp_class_val", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_val",
    ("ptpv"."id_class_val" IS NULL) AS "not_set",
    COALESCE("position_carrier"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val",
    COALESCE("ptpv"."tablename", 'notsaved'::character varying) AS "tablename",
    "ptpv"."embed_mode",
    "ptpv"."embed_single",
    "ptpv"."embed_class_real_id",
    "ptpv"."id_unit_conversion_rule"
   FROM (("bpd"."position" "position_carrier"
     LEFT JOIN "bpd"."vpos_temp_prop" "ptp" ON (("ptp"."id_pos_temp" = "position_carrier"."id_pos_temp")))
     LEFT JOIN "bpd"."vpos_temp_prop_object_val" "ptpv" ON (("ptpv"."id_pos_temp_prop" = "ptp"."id")))
  WHERE (("position_carrier"."id" IS NOT NULL) AND ("ptp"."id_prop_type" = 3));


--
-- TOC entry 480 (class 1259 OID 703433)
-- Name: vposition_prop_user_big_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition_prop_user_big_val" AS
 SELECT "p"."id" AS "id_position",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    true AS "inheritance",
    "sl"."min_used",
    "ptv"."min_on",
    "ptv"."min_val",
    "ptv"."max_on",
    "ptv"."max_val",
    "sl"."max_used",
    COALESCE("pv"."val_text", "ptv"."val_text") AS "val_text",
    COALESCE("pv"."val_bytea", "ptv"."val_bytea") AS "val_bytea",
    COALESCE("pv"."val_json", "ptv"."val_json") AS "val_json",
    COALESCE(COALESCE((("pv"."tableoid")::"regclass")::character varying, (("ptv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
        CASE "ptp"."id_data_type"
            WHEN 7 THEN (("ptv"."val_text" IS NOT NULL) OR ("pv"."val_text" IS NOT NULL))
            WHEN 8 THEN (("ptv"."val_bytea" IS NOT NULL) OR ("pv"."val_bytea" IS NOT NULL))
            WHEN 14 THEN (("ptv"."val_json" IS NOT NULL) OR ("pv"."val_json" IS NOT NULL))
            ELSE NULL::boolean
        END AS "on_val",
    COALESCE("p"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val"
   FROM (((("bpd"."position" "p"
     LEFT JOIN "bpd"."pos_temp_prop" "ptp" ON (("p"."id_pos_temp" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_user_big_val" "ptv" ON (("ptv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."position_prop_user_big_val" "pv" ON ((("pv"."id_pos_temp_prop" = "ptp"."id") AND ("pv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "ptp"."id_data_type")))
  WHERE (("ptp"."id_data_type" = ANY (ARRAY[7, 8, 14])) AND ("ptp"."id_prop_type" = 1));



--
-- TOC entry 481 (class 1259 OID 703438)
-- Name: vposition_prop_user_small_val; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vposition_prop_user_small_val" AS
 SELECT "p"."id" AS "id_position",
    "ptp"."id_pos_temp",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_data_type",
    true AS "inheritance",
    "sl"."min_used",
    "ptv"."min_on",
    "ptv"."min_val",
    "sl"."max_used",
    "ptv"."max_on",
    "ptv"."max_val",
    "sl"."round_used",
    "ptv"."round_on",
    "ptv"."round",
    COALESCE("pv"."val_varchar", "ptv"."val_varchar") AS "val_varchar",
    COALESCE("pv"."val_int", "ptv"."val_int") AS "val_int",
    COALESCE("pv"."val_numeric", "ptv"."val_numeric") AS "val_numeric",
    COALESCE("pv"."val_real", "ptv"."val_real") AS "val_real",
    COALESCE("pv"."val_double", "ptv"."val_double") AS "val_double",
    COALESCE("pv"."val_money", "ptv"."val_money") AS "val_money",
    COALESCE("pv"."val_boolean", "ptv"."val_boolean") AS "val_boolean",
    COALESCE("pv"."val_date", "ptv"."val_date") AS "val_date",
    COALESCE("pv"."val_time", "ptv"."val_time") AS "val_time",
    COALESCE("pv"."val_interval", "ptv"."val_interval") AS "val_interval",
    COALESCE("pv"."val_timestamp", "ptv"."val_timestamp") AS "val_timestamp",
    COALESCE("pv"."val_bigint", "ptv"."val_bigint") AS "val_bigint",
    COALESCE(COALESCE((("pv"."tableoid")::"regclass")::character varying, (("ptv"."tableoid")::"regclass")::character varying), 'notsaved'::character varying) AS "tablename",
        CASE "ptp"."id_data_type"
            WHEN 1 THEN (("ptv"."val_varchar" IS NOT NULL) OR ("pv"."val_varchar" IS NOT NULL))
            WHEN 2 THEN (("ptv"."val_int" IS NOT NULL) OR ("pv"."val_int" IS NOT NULL))
            WHEN 3 THEN (("ptv"."val_numeric" IS NOT NULL) OR ("pv"."val_numeric" IS NOT NULL))
            WHEN 4 THEN (("ptv"."val_real" IS NOT NULL) OR ("pv"."val_real" IS NOT NULL))
            WHEN 5 THEN (("ptv"."val_double" IS NOT NULL) OR ("pv"."val_double" IS NOT NULL))
            WHEN 6 THEN (("ptv"."val_money" IS NOT NULL) OR ("pv"."val_money" IS NOT NULL))
            WHEN 9 THEN (("ptv"."val_boolean" IS NOT NULL) OR ("pv"."val_boolean" IS NOT NULL))
            WHEN 10 THEN (("ptv"."val_date" IS NOT NULL) OR ("pv"."val_date" IS NOT NULL))
            WHEN 11 THEN (("ptv"."val_time" IS NOT NULL) OR ("pv"."val_time" IS NOT NULL))
            WHEN 12 THEN (("ptv"."val_interval" IS NOT NULL) OR ("pv"."val_interval" IS NOT NULL))
            WHEN 13 THEN (("ptv"."val_timestamp" IS NOT NULL) OR ("pv"."val_timestamp" IS NOT NULL))
            WHEN 15 THEN (("ptv"."val_bigint" IS NOT NULL) OR ("pv"."val_bigint" IS NOT NULL))
            ELSE NULL::boolean
        END AS "on_val",
    COALESCE("p"."timestamp", '1900-01-01 00:00:00'::timestamp without time zone) AS "timestamp_val"
   FROM (((("bpd"."position" "p"
     LEFT JOIN "bpd"."pos_temp_prop" "ptp" ON (("p"."id_pos_temp" = "ptp"."id_pos_temp")))
     LEFT JOIN "bpd"."pos_temp_prop_user_small_val" "ptv" ON (("ptv"."id_pos_temp_prop" = "ptp"."id")))
     LEFT JOIN "bpd"."position_prop_user_small_val" "pv" ON ((("pv"."id_pos_temp_prop" = "ptp"."id") AND ("pv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "ptp"."id_data_type")))
  WHERE (("ptp"."id_data_type" = ANY (ARRAY[1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 15])) AND ("ptp"."id_prop_type" = 1));


--
-- TOC entry 333 (class 1259 OID 34628)
-- Name: prop_data_bin_ext; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_data_bin_ext" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL
);



--
-- TOC entry 338 (class 1259 OID 45080)
-- Name: vprop_data_type; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vprop_data_type" AS
 SELECT "prop_data_type"."id",
    "prop_data_type"."name",
    "prop_data_type"."desc",
    "prop_data_type"."usrdesc"
   FROM "bpd"."prop_data_type"
  ORDER BY "prop_data_type"."sort";


--
-- TOC entry 610 (class 1259 OID 1397222)
-- Name: vprop_enum; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vprop_enum" AS
 SELECT DISTINCT "pe"."id_conception",
    "pe"."id" AS "id_prop_enum",
    "pe"."id_prop_enum_use_area",
    "pe"."id_data_type",
    "pe"."name",
    "pe"."desc",
    ((EXISTS ( SELECT
           FROM "bpd"."class_prop_enum_val" "cpev"
          WHERE ("cpev"."id_prop_enum" = "pe"."id"))) OR (EXISTS ( SELECT
           FROM "bpd"."pos_temp_prop_enum_val" "cpev"
          WHERE ("cpev"."id_prop_enum" = "pe"."id")))) AS "is_use",
    (NOT ("pev"."id_prop_enum" IS NULL)) AS "has_items",
    "pe"."timestamp"
   FROM ("bpd"."prop_enum" "pe"
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id_prop_enum" = "pe"."id")));


--
-- TOC entry 426 (class 1259 OID 487635)
-- Name: prop_enum_use_area; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_enum_use_area" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(100) NOT NULL
);


--
-- TOC entry 427 (class 1259 OID 494509)
-- Name: vprop_enum_use_area; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vprop_enum_use_area" AS
 SELECT "prop_enum_use_area"."id",
    "prop_enum_use_area"."name",
    "prop_enum_use_area"."desc"
   FROM "bpd"."prop_enum_use_area";


--
-- TOC entry 380 (class 1259 OID 160026)
-- Name: prop_type; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prop_type" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT ' '::character varying NOT NULL,
    "on" boolean DEFAULT true NOT NULL,
    "sort" integer DEFAULT 1 NOT NULL
);


--
-- TOC entry 384 (class 1259 OID 178798)
-- Name: vprop_type; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vprop_type" AS
 SELECT "prop_type"."id",
    "prop_type"."name",
    "prop_type"."desc",
    "prop_type"."on",
    "prop_type"."sort"
   FROM "bpd"."prop_type"
  ORDER BY "prop_type"."sort";


--
-- TOC entry 477 (class 1259 OID 679746)
-- Name: vcfg_prop_spec_limit2; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vcfg_prop_spec_limit2" AS
 SELECT "cfg_prop_spec_limit2"."id_prop_data_type",
    "cfg_prop_spec_limit2"."max_name",
    "cfg_prop_spec_limit2"."max_used",
    "cfg_prop_spec_limit2"."max_limit_on",
    "cfg_prop_spec_limit2"."max_upper",
    "cfg_prop_spec_limit2"."max_lower",
    "cfg_prop_spec_limit2"."max_default",
    "cfg_prop_spec_limit2"."min_name",
    "cfg_prop_spec_limit2"."min_used",
    "cfg_prop_spec_limit2"."min_limit_on",
    "cfg_prop_spec_limit2"."min_upper",
    "cfg_prop_spec_limit2"."min_lower",
    "cfg_prop_spec_limit2"."min_default",
    "cfg_prop_spec_limit2"."round_name",
    "cfg_prop_spec_limit2"."round_used",
    "cfg_prop_spec_limit2"."round_limit_on",
    "cfg_prop_spec_limit2"."round_upper",
    "cfg_prop_spec_limit2"."round_lower",
    "cfg_prop_spec_limit2"."round_default"
   FROM "bpd"."cfg_prop_spec_limit2"
  ORDER BY "cfg_prop_spec_limit2"."id_prop_data_type";

--
-- TOC entry 600 (class 1259 OID 1377263)
-- Name: rulel1_class_on_pos_temp; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."rulel1_class_on_pos_temp" (
    "id_pos_temp" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "id_con" bigint DEFAULT '-1'::integer NOT NULL,
    "path_array" bigint[] DEFAULT ARRAY[0] NOT NULL,
    "id_group" bigint NOT NULL
);


--
-- TOC entry 394 (class 1259 OID 230609)
-- Name: rulel1_group_on_pos_temp; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."rulel1_group_on_pos_temp" (
    "id_pos_temp" bigint NOT NULL,
    "id_group" bigint NOT NULL,
    "id_con" bigint DEFAULT '-1'::integer NOT NULL,
    "path_array" bigint[] DEFAULT ARRAY[0] NOT NULL
);


--
-- TOC entry 603 (class 1259 OID 1381211)
-- Name: vrulel1_class_on_pos_temp_tbl_access; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrulel1_class_on_pos_temp_tbl_access" AS
( WITH RECURSIVE "rclass"("id", "level", "id_parent", "path", "cycle", "id_pos_temp", "name_pos_temp", "id_class_assigned", "on_assigned") AS (
         SELECT "rc"."id",
            "rc"."level",
            "rc"."id_parent",
            ARRAY["rc"."id"] AS "array",
            false AS "bool",
            "rl1_1"."id_pos_temp",
            "pt"."name",
            "rl1_1"."id_class",
            true AS "bool"
           FROM ((ONLY "bpd"."class" "rc"
             JOIN "bpd"."rulel1_class_on_pos_temp" "rl1_1" ON (("rc"."id" = "rl1_1"."id_class")))
             JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "rl1_1"."id_pos_temp")))
        UNION ALL
         SELECT "rcc"."id",
            "rcc"."level",
            "rcc"."id_parent",
            ("rclass"."path" || ARRAY["rcc"."id"]),
            ("rcc"."id" = ANY ("rclass"."path")),
            "rclass"."id_pos_temp",
            "rclass"."name_pos_temp",
            "rclass"."id_class_assigned",
            false AS "bool"
           FROM (ONLY "bpd"."class" "rcc"
             JOIN "rclass" ON (("rclass"."id" = "rcc"."id_parent")))
          WHERE (NOT "rclass"."cycle")
        )
 SELECT "c"."id_con",
    "c"."id_group",
    "rl1"."id_pos_temp",
    "c"."id" AS "id_class",
    "rl1"."on_assigned",
    "rl1"."id_class_assigned",
    "rl1"."level" AS "class_level",
    "concat"('Правило L1 класс: ', "c"."name", ' -> шаблон:', "rl1"."name_pos_temp") AS "name_rule"
   FROM ("rclass" "rl1"
     JOIN ONLY "bpd"."class" "c" ON (("c"."id" = "rl1"."id"))))
UNION
( WITH RECURSIVE "rgroup"("id", "id_pos_temp", "name_pos_temp", "level", "id_parent", "path", "cycle") AS (
         SELECT "rg"."id",
            "rl1_1"."id_pos_temp",
            "pt"."name",
            "rg"."level",
            "rg"."id_parent",
            ARRAY["rg"."id"] AS "array",
            false AS "bool"
           FROM (("bpd"."group" "rg"
             JOIN "bpd"."rulel1_group_on_pos_temp" "rl1_1" ON (("rg"."id" = "rl1_1"."id_group")))
             JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "rl1_1"."id_pos_temp")))
        UNION ALL
         SELECT "rgc"."id",
            "rgroup"."id_pos_temp",
            "rgroup"."name_pos_temp",
            "rgc"."level",
            "rgc"."id_parent",
            ("rgroup"."path" || ARRAY["rgc"."id"]),
            ("rgc"."id" = ANY ("rgroup"."path"))
           FROM ("bpd"."group" "rgc"
             JOIN "rgroup" ON (("rgroup"."id" = "rgc"."id_parent")))
          WHERE (NOT "rgroup"."cycle")
        ), "rclass"("id", "level", "id_parent", "path", "cycle", "id_pos_temp", "name_pos_temp", "id_class_assigned", "on_assigned") AS (
         SELECT "rc"."id",
            "rc"."level",
            "rc"."id_parent",
            ARRAY["rc"."id"] AS "array",
            false AS "bool",
            "rl1_1"."id_pos_temp",
            "pt"."name",
            '-1'::integer,
            false AS "bool"
           FROM ((ONLY "bpd"."class" "rc"
             JOIN "rgroup" "rl1_1" ON (("rl1_1"."id" = "rc"."id_group")))
             JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "rl1_1"."id_pos_temp")))
          WHERE ("rc"."level" = 0)
        UNION ALL
         SELECT "rcc"."id",
            "rcc"."level",
            "rcc"."id_parent",
            ("rclass"."path" || ARRAY["rcc"."id"]),
            ("rcc"."id" = ANY ("rclass"."path")),
            "rclass"."id_pos_temp",
            "rclass"."name_pos_temp",
            "rclass"."id_class_assigned",
            false AS "bool"
           FROM (ONLY "bpd"."class" "rcc"
             JOIN "rclass" ON (("rclass"."id" = "rcc"."id_parent")))
          WHERE (NOT "rclass"."cycle")
        )
 SELECT "c"."id_con",
    "c"."id_group",
    "rl1"."id_pos_temp",
    "c"."id" AS "id_class",
    "rl1"."on_assigned",
    "rl1"."id_class_assigned",
    "rl1"."level" AS "class_level",
    "concat"('Правило L1 класс: ', "c"."name", ' -> шаблон:', "rl1"."name_pos_temp") AS "name_rule"
   FROM ("rclass" "rl1"
     JOIN ONLY "bpd"."class" "c" ON (("c"."id" = "rl1"."id"))));

--
-- TOC entry 601 (class 1259 OID 1377285)
-- Name: vrulel1_class_on_pos_temp; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrulel1_class_on_pos_temp" AS
 SELECT "c"."id_group",
    "rl1"."id_class",
    "rl1"."id_pos_temp",
    "concat"('Правило L1 класс: ', "c"."name", ' -> шаблон: ', "pt"."name") AS "name_rule",
    true AS "is_create",
    (EXISTS ( SELECT
           FROM ( WITH RECURSIVE "rclass"("id", "id_parent", "patch", "cycle") AS (
                         SELECT "rg"."id",
                            "rg"."id_parent",
                            ARRAY["rg"."id"] AS "array",
                            false AS "bool"
                           FROM "bpd"."class" "rg"
                          WHERE ("rg"."id" = "rl1"."id_class")
                        UNION ALL
                         SELECT "rgc"."id",
                            "rgc"."id_parent",
                            ("rclass"."patch" || ARRAY["rgc"."id"]),
                            ("rgc"."id" = ANY ("rclass"."patch"))
                           FROM ("bpd"."class" "rgc"
                             JOIN "rclass" ON (("rclass"."id" = "rgc"."id_parent")))
                          WHERE (NOT "rclass"."cycle")
                        )
                 SELECT
                   FROM (("bpd"."object" "o"
                     JOIN "bpd"."class" "c_1" ON (("c_1"."id" = "o"."id_class")))
                     JOIN "bpd"."position" "p" ON (("p"."id" = "o"."id_position")))
                  WHERE ((EXISTS ( SELECT 1
                           FROM "rclass"
                          WHERE ((NOT "o"."is_inside") AND ("rclass"."id" = "c_1"."id")))) AND ("p"."id_pos_temp" = "rl1"."id_pos_temp"))) "grec")) AS "is_use"
   FROM (("bpd"."rulel1_class_on_pos_temp" "rl1"
     JOIN ONLY "bpd"."class" "c" ON (("c"."id" = "rl1"."id_class")))
     JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "rl1"."id_pos_temp")));

--
-- TOC entry 602 (class 1259 OID 1380997)
-- Name: vrulel1_group_on_pos_temp_tbl_access; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrulel1_group_on_pos_temp_tbl_access" AS
 WITH RECURSIVE "rgroup"("id", "level", "id_parent", "patch", "cycle", "id_pos_temp", "id_group_assigned", "on_assigned") AS (
         SELECT "rg"."id",
            "rg"."level",
            "rg"."id_parent",
            ARRAY["rg"."id"] AS "array",
            false AS "bool",
            "rl1"."id_pos_temp",
            "rl1"."id_group",
            true AS "bool"
           FROM ("bpd"."group" "rg"
             JOIN "bpd"."rulel1_group_on_pos_temp" "rl1" ON (("rg"."id" = "rl1"."id_group")))
        UNION ALL
         SELECT "rgc"."id",
            "rgc"."level",
            "rgc"."id_parent",
            ("rgroup"."patch" || ARRAY["rgc"."id"]),
            ("rgc"."id" = ANY ("rgroup"."patch")),
            "rgroup"."id_pos_temp",
            "rgroup"."id_group_assigned",
            false AS "bool"
           FROM ("bpd"."group" "rgc"
             JOIN "rgroup" ON (("rgroup"."id" = "rgc"."id_parent")))
          WHERE (NOT "rgroup"."cycle")
        )
 SELECT "g"."id_con",
    "r"."id_pos_temp",
    "r"."id" AS "id_group",
    "r"."on_assigned",
    "r"."id_group_assigned",
    "r"."level" AS "group_level",
    "concat"('Правило L1 группа: ', "g"."name", ' -> шаблон:', "pt"."name") AS "name_rule"
   FROM (("rgroup" "r"
     JOIN "bpd"."group" "g" ON (("g"."id" = "r"."id")))
     JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "r"."id_pos_temp")));


--
-- TOC entry 398 (class 1259 OID 230690)
-- Name: vrulel1_group_on_pos_temp; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrulel1_group_on_pos_temp" AS
 SELECT "rl1"."id_group",
    "rl1"."id_pos_temp",
    "concat"('Правило L1 группа: ', "g"."name", ' -> шаблон:', "pt"."name") AS "name_rule",
    true AS "is_create",
    (EXISTS ( SELECT 1
           FROM ( WITH RECURSIVE "rgroup"("id", "id_parent", "patch", "cycle") AS (
                         SELECT "rg"."id",
                            "rg"."id_parent",
                            ARRAY["rg"."id"] AS "array",
                            false AS "bool"
                           FROM "bpd"."group" "rg"
                          WHERE ("rg"."id" = "rl1"."id_group")
                        UNION ALL
                         SELECT "rgc"."id",
                            "rgc"."id_parent",
                            ("rgroup"."patch" || ARRAY["rgc"."id"]),
                            ("rgc"."id" = ANY ("rgroup"."patch"))
                           FROM ("bpd"."group" "rgc"
                             JOIN "rgroup" ON (("rgroup"."id" = "rgc"."id_parent")))
                          WHERE (NOT "rgroup"."cycle")
                        )
                 SELECT 1
                   FROM (("bpd"."object" "o"
                     JOIN "bpd"."class" "c" ON (("c"."id" = "o"."id_class")))
                     JOIN "bpd"."position" "p" ON (("p"."id" = "o"."id_position")))
                  WHERE ((EXISTS ( SELECT 1
                           FROM "rgroup"
                          WHERE ((NOT "o"."is_inside") AND ("rgroup"."id" = "c"."id_group")))) AND ("p"."id_pos_temp" = "rl1"."id_pos_temp"))) "grec")) AS "is_use"
   FROM (("bpd"."rulel1_group_on_pos_temp" "rl1"
     JOIN "bpd"."group" "g" ON (("g"."id" = "rl1"."id_group")))
     JOIN "bpd"."pos_temp" "pt" ON (("pt"."id" = "rl1"."id_pos_temp")));


--
-- TOC entry 399 (class 1259 OID 230913)
-- Name: vrulel2_class_on_position; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrulel2_class_on_position" AS
 SELECT "rl2"."id_class",
    "rl2"."id_position",
    "concat"('Правило L2: ', "c"."name", ' -> ', "p"."name") AS "name_rule",
    true AS "is_create",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "o"
          WHERE (("rl2"."id_class" = "o"."id_class") AND ("rl2"."id_position" = "o"."id_position") AND (NOT "o"."is_inside")))) AS "is_use"
   FROM (("bpd"."rulel2_class_on_position" "rl2"
     JOIN ONLY "bpd"."class" "c" ON (("c"."id" = "rl2"."id_class")))
     JOIN "bpd"."position" "p" ON (("p"."id" = "rl2"."id_position")));


--
-- TOC entry 396 (class 1259 OID 230644)
-- Name: rulel2_class_snapshot_on_position; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."rulel2_class_snapshot_on_position" (
    "id_position" bigint NOT NULL,
    "id_class" bigint NOT NULL,
    "timestamp_class" timestamp without time zone NOT NULL
);


--
-- TOC entry 400 (class 1259 OID 231359)
-- Name: vrulel2_class_snapshot_on_position; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrulel2_class_snapshot_on_position" AS
 SELECT "rl2"."id_class",
    "rl2"."timestamp_class",
    "rl2"."id_position",
    "concat"('Правило L2: ', "c"."name", ' -> ', "p"."name") AS "name_rule",
    true AS "is_create",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "o"
          WHERE (("rl2"."id_class" = "o"."id_class") AND ("rl2"."timestamp_class" = "o"."timestamp_class") AND ("rl2"."id_position" = "o"."id_position") AND ("o"."id_object_carrier" <= 0)))) AS "is_use"
   FROM (("bpd"."rulel2_class_snapshot_on_position" "rl2"
     JOIN ONLY "bpd"."class" "c" ON (("c"."id" = "rl2"."id_class")))
     JOIN "bpd"."position" "p" ON (("p"."id" = "rl2"."id_position")));


--
-- TOC entry 357 (class 1259 OID 96101)
-- Name: units; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."units" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT '255'::character varying NOT NULL,
    "not_fractional" boolean DEFAULT false NOT NULL,
    "bunit" character varying(100) DEFAULT 'н/д'::character varying NOT NULL,
    "is_entity" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 367 (class 1259 OID 117294)
-- Name: vunit_conversion_rules; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vunit_conversion_rules" AS
 SELECT "ucr"."id",
    "ucr"."id_unit",
    "ucr"."mc",
    "ucr"."bunit",
    "ucr"."cunit",
    "ucr"."desc",
    "ucr"."on_base",
    "ucr"."on_single",
    "ucr"."on",
    ((EXISTS ( SELECT 1
           FROM "bpd"."class_unit_conversion_rules" "cur"
          WHERE ("cur"."id_unit_conversion_rule" = "ucr"."id"))) OR (EXISTS ( SELECT 1
           FROM "bpd"."object" "o"
          WHERE ("o"."id_unit_conversion_rule" = "ucr"."id")))) AS "is_use",
    "ucr"."round",
    "ucr"."not_fractional",
    "ucr"."timestamp",
    "u"."is_entity",
    "ucr"."id_conception"
   FROM ("bpd"."unit_conversion_rules" "ucr"
     JOIN "bpd"."units" "u" ON (("u"."id" = "ucr"."id_unit")));


--
-- TOC entry 366 (class 1259 OID 117290)
-- Name: vunits; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vunits" AS
 SELECT "units"."id",
    "units"."name",
    "units"."desc",
    "units"."not_fractional",
    "units"."is_entity"
   FROM "bpd"."units";


--
-- TOC entry 320 (class 1259 OID 25850)
-- Name: cfg_procnamespace; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_procnamespace" (
    "name" character varying(50) NOT NULL,
    "id_entity" integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 402 (class 1259 OID 244925)
-- Name: cfg_v_initproc_base_desc; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_base_desc" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    "p"."prorettype",
    (((((('"'::"text" || ("n"."nspname")::"text") || '"."'::"text") || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((((('"'::"text" || ("n"."nspname")::"text") || '"."'::"text") || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access",
    "array_to_string"(ARRAY( SELECT "d"."description"
           FROM "pg_description" "d"
          WHERE ("d"."objoid" = "p"."oid")), ''::"text") AS "description"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE (("n"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
           FROM "bpd"."cfg_procnamespace"
          WHERE (("p"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))))
  ORDER BY "p"."proname";



--
-- TOC entry 594 (class 1259 OID 1359068)
-- Name: role_base_list; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."role_base_list" (
    "rolname" character varying NOT NULL,
    "sort" integer DEFAULT 1 NOT NULL
);


--
-- TOC entry 598 (class 1259 OID 1369728)
-- Name: vrole_base; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrole_base" AS
 SELECT "r"."oid",
    "r"."rolinherit",
    ("r"."rolname")::character varying AS "namesys",
    "d"."description"
   FROM (("pg_roles" "r"
     LEFT JOIN "pg_shdescription" "d" ON (("d"."objoid" = "r"."oid")))
     JOIN "bpd"."role_base_list" "br" ON ((("br"."rolname")::"text" = "r"."rolname")))
  ORDER BY "br"."sort", (("r"."rolname")::character varying);


--
-- TOC entry 590 (class 1259 OID 1348758)
-- Name: role_user; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."role_user" (
    "oid" "oid" NOT NULL,
    "name" character varying(100) NOT NULL,
    "description" character varying(100) NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "id" bigint NOT NULL,
    "namesys" character varying NOT NULL
);


--
-- TOC entry 604 (class 1259 OID 1385003)
-- Name: vrole_user; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vrole_user" AS
 SELECT "ur"."id",
    "ur"."oid",
    "ur"."name",
    "ur"."description",
    "ur"."namesys",
    "r"."rolsuper",
    "r"."rolinherit",
    "r"."rolcreaterole",
    "r"."rolcreatedb",
    "r"."rolcanlogin",
    "r"."rolbypassrls",
    "ur"."timestamp"
   FROM ("bpd"."role_user" "ur"
     JOIN "pg_roles" "r" ON (("r"."oid" = "ur"."oid")));



--
-- TOC entry 571 (class 1259 OID 1289004)
-- Name: _int_class_path2; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."_int_class_path2" AS
 SELECT "c"."id",
    "concat"(COALESCE(( WITH RECURSIVE "rgroup"("id", "id_parent", "level", "path", "spath", "cycle") AS (
                 SELECT "rg"."id",
                    "rg"."id_parent",
                    0,
                    ARRAY["rg"."id"] AS "array",
                    "concat"("rg"."name") AS "concat",
                    false AS "bool"
                   FROM "bpd"."group" "rg"
                  WHERE ("rg"."id" = "c"."id_group")
                UNION ALL
                 SELECT "rgc"."id",
                    "rgc"."id_parent",
                    ("rgroup_1"."level" + 1),
                    (ARRAY["rgc"."id"] || "rgroup_1"."path"),
                    "concat"("rgc"."name", '\', "rgroup_1"."spath") AS "concat",
                    ("rgc"."id" = ANY ("rgroup_1"."path"))
                   FROM ("bpd"."group" "rgc"
                     JOIN "rgroup" "rgroup_1" ON (("rgroup_1"."id_parent" = "rgc"."id")))
                  WHERE (NOT "rgroup_1"."cycle")
                )
         SELECT "rgroup"."spath"
           FROM "rgroup"
          ORDER BY "rgroup"."level" DESC
         LIMIT 1), ''::"text"), '\\', COALESCE(( WITH RECURSIVE "rclass"("id", "id_parent", "level", "path", "spath", "cycle") AS (
                 SELECT "rc"."id",
                    "rc"."id_parent",
                    0,
                    ARRAY["rc"."id"] AS "array",
                    "concat"("rc"."name") AS "concat",
                    false AS "bool"
                   FROM ONLY "bpd"."class" "rc"
                  WHERE ("rc"."id" = "c"."id")
                UNION ALL
                 SELECT "rcc"."id",
                    "rcc"."id_parent",
                    ("rclass_1"."level" + 1),
                    (ARRAY["rcc"."id"] || "rclass_1"."path"),
                    "concat"("rcc"."name", '\', "rclass_1"."spath") AS "concat",
                    ("rcc"."id" = ANY ("rclass_1"."path"))
                   FROM (ONLY "bpd"."class" "rcc"
                     JOIN "rclass" "rclass_1" ON (("rclass_1"."id_parent" = "rcc"."id")))
                  WHERE (NOT "rclass_1"."cycle")
                )
         SELECT "rclass"."spath"
           FROM "rclass"
          ORDER BY "rclass"."level" DESC
         LIMIT 1), ''::"text")) AS "path"
   FROM ONLY "bpd"."class" "c";


--
-- TOC entry 528 (class 1259 OID 1097796)
-- Name: _int_object_ext2; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."_int_object_ext2" AS
SELECT
    NULL::bigint AS "id",
    NULL::"bpd"."cobject_prop"[] AS "property_list",
    NULL::"text" AS "path";


--
-- TOC entry 529 (class 1259 OID 1133246)
-- Name: _int_position_tree; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."_int_position_tree" AS
 SELECT "pt"."id" AS "id_pos_temp",
    COALESCE("ptp"."id", ('-1'::integer)::bigint) AS "id_pos_temp_prop",
    "p_parent"."id" AS "id_position_parent",
    COALESCE("p"."id", ('-1'::integer)::bigint) AS "id_position",
    "o_carrier"."id" AS "id_object_carrier"
   FROM (((((("bpd"."pos_temp" "pt"
     LEFT JOIN "bpd"."pos_temp_prop" "ptp" ON (("ptp"."id_pos_temp" = "pt"."id")))
     LEFT JOIN "bpd"."position" "p_parent" ON (("p_parent"."id_pos_temp" = "pt"."id")))
     LEFT JOIN "bpd"."position" "p" ON (("p_parent"."id" = "p"."id_parent")))
     LEFT JOIN "bpd"."object" "o_carrier" ON ((("o_carrier"."id_position" = "p"."id") AND ("o_carrier"."id_object_carrier" <= 0) AND ("o_carrier"."id_pos_temp_prop" < 0))))
     LEFT JOIN "bpd"."object" "o_inside_object_prop" ON ((("o_inside_object_prop"."id_position" = "p"."id") AND ("o_inside_object_prop"."id_object_carrier" > 0))))
     LEFT JOIN "bpd"."object" "o_inside_pos_prop" ON ((("o_inside_pos_prop"."id_position" = "p"."id") AND ("o_inside_pos_prop"."id_pos_temp_prop" > 0))));


--
-- TOC entry 392 (class 1259 OID 217897)
-- Name: cfg_action; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_action" (
    "id" "bpd"."action" NOT NULL,
    "actid" integer NOT NULL,
    "name" character varying(2044) NOT NULL,
    "desc" character varying(2044) NOT NULL
);


--
-- TOC entry 356 (class 1259 OID 94982)
-- Name: cfg_con; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_con" (
    "name" character varying(2044) NOT NULL,
    "id_prototype" bigint NOT NULL,
    "rule" character varying(100) DEFAULT 't'::character varying NOT NULL,
    "desc" character varying(100) DEFAULT 'e'::character varying NOT NULL
);


--
-- TOC entry 334 (class 1259 OID 39456)
-- Name: cfg_err_id; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_err_id" (
    "id" integer NOT NULL,
    "desc1" character varying(2044) NOT NULL,
    "desc2" character varying(2044) NOT NULL
);


--
-- TOC entry 359 (class 1259 OID 108891)
-- Name: cfg_map_proname_entity; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."cfg_map_proname_entity" (
    "id_entity" integer NOT NULL,
    "proname" character varying(2044) NOT NULL
);


--
-- TOC entry 599 (class 1259 OID 1374199)
-- Name: cfg_v_initproc_all; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_all" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    ARRAY( SELECT "bpd"."cfg_procargs"("p"."oid") AS "cfg_procargs") AS "proargslist",
    "p"."prorettype",
    (((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access",
    "p"."proacl"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE ("n"."nspname" = 'bpd'::"name")
  ORDER BY "p"."proname";


--
-- TOC entry 615 (class 1259 OID 1414234)
-- Name: cfg_v_initproc_base; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_base" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    ARRAY( SELECT "bpd"."cfg_procargs"("p"."oid") AS "cfg_procargs") AS "proargslist",
    "p"."prorettype",
    (((((('"'::"text" || ("n"."nspname")::"text") || '"."'::"text") || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((((('"'::"text" || ("n"."nspname")::"text") || '"."'::"text") || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE (("n"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
           FROM "bpd"."cfg_procnamespace"
          WHERE (("p"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))))
  ORDER BY "p"."proname";


--
-- TOC entry 612 (class 1259 OID 1398926)
-- Name: prm_grant_external_func; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."prm_grant_external_func" (
    "oid" "oid",
    "proname" "name" NOT NULL,
    "rolname" "name"
);


--
-- TOC entry 617 (class 1259 OID 1429163)
-- Name: cfg_v_initproc_base_access_not_set; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_base_access_not_set" AS
 SELECT "p"."oid",
    "p"."proname",
    "p"."proargs",
    "p"."proargslist",
    "p"."prorettype",
    "p"."argsignature",
    "p"."access"
   FROM "bpd"."cfg_v_initproc_base" "p"
  WHERE (NOT (EXISTS ( SELECT
           FROM "bpd"."prm_grant_external_func" "prm"
          WHERE ("prm"."proname" = "p"."proname"))))
  ORDER BY "p"."proname";


--
-- TOC entry 405 (class 1259 OID 244986)
-- Name: cfg_v_initproc_base_desc_on_entity; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_base_desc_on_entity" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    "p"."prorettype",
    (((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access",
    "array_to_string"(ARRAY( SELECT "d"."description"
           FROM "pg_description" "d"
          WHERE ("d"."objoid" = "p"."oid")), ''::"text") AS "description",
    "e"."entity",
    "e"."name" AS "entityname"
   FROM ((("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
     JOIN "bpd"."cfg_map_proname_entity" "m" ON ((("m"."proname")::"name" = "p"."proname")))
     JOIN "bpd"."entity" "e" ON (("e"."id" = "m"."id_entity")))
  WHERE (("n"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
           FROM "bpd"."cfg_procnamespace"
          WHERE (("p"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))))
  ORDER BY "p"."proname";


--
-- TOC entry 406 (class 1259 OID 244991)
-- Name: cfg_v_initproc_base_desc_no_entity; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_base_desc_no_entity" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    "p"."prorettype",
    (((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access",
    "array_to_string"(ARRAY( SELECT "d"."description"
           FROM "pg_description" "d"
          WHERE ("d"."objoid" = "p"."oid")), ''::"text") AS "description"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE (("n"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
           FROM "bpd"."cfg_procnamespace"
          WHERE (("p"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))) AND (NOT (EXISTS ( SELECT 1
           FROM "bpd"."cfg_v_initproc_base_desc_on_entity" "en"
          WHERE ("en"."oid" = "p"."oid")))))
  ORDER BY "p"."proname";


--
-- TOC entry 578 (class 1259 OID 1298693)
-- Name: cfg_v_initproc_base_prorettype_text; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_base_prorettype_text" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    ARRAY( SELECT "bpd"."cfg_procargs"("p"."oid") AS "cfg_procargs") AS "proargslist",
    (( SELECT "pt"."typname"
           FROM "pg_type" "pt"
          WHERE ("pt"."oid" = "p"."prorettype")))::character varying AS "prorettype",
    (((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE (("n"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
           FROM "bpd"."cfg_procnamespace"
          WHERE (("p"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))))
  ORDER BY "p"."proname";


--
-- TOC entry 611 (class 1259 OID 1397646)
-- Name: cfg_v_initproc_internal; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_internal" AS
 WITH "rpointernal"("procoid") AS MATERIALIZED (
         SELECT "p_1"."oid"
           FROM ("pg_proc" "p_1"
             JOIN "pg_namespace" "n_1" ON (("p_1"."pronamespace" = "n_1"."oid")))
          WHERE ("n_1"."nspname" = 'bpd'::"name")
        EXCEPT
         SELECT "p_1"."oid"
           FROM ("pg_proc" "p_1"
             JOIN "pg_namespace" "n_1" ON (("p_1"."pronamespace" = "n_1"."oid")))
          WHERE (("n_1"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
                   FROM "bpd"."cfg_procnamespace"
                  WHERE (("p_1"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))))
        )
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    ARRAY( SELECT "bpd"."cfg_procargs"("p"."oid") AS "cfg_procargs") AS "proargslist",
    "p"."prorettype",
    (((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access",
    "p"."proacl"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE ((EXISTS ( SELECT
           FROM "rpointernal" "pi"
          WHERE ("pi"."procoid" = "p"."oid"))) AND ("p"."proname" !~~ 'int_cast%'::"text") AND ("p"."proname" !~~ 'trg_%'::"text") AND ("p"."proname" !~~ 'prm_%'::"text") AND ("p"."proname" !~~ 'pga_job%'::"text"))
  ORDER BY "p"."proname";


--
-- TOC entry 403 (class 1259 OID 244966)
-- Name: cfg_v_initproc_old; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_initproc_old" AS
 SELECT "p"."oid",
    "p"."proname",
    COALESCE("array_length"("p"."proargnames", 1), 0) AS "proargs",
    "p"."prorettype",
    (((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT "t"."typname"
           FROM ("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text") AS "argsignature",
    "has_function_privilege"((((('"bpd"."'::"text" || ("p"."proname")::"text") || '"('::"text") || "array_to_string"(ARRAY( SELECT ((("ns"."nspname")::"text" || '.'::"text") || ("t"."typname")::"text")
           FROM (("pg_type" "t"
             JOIN ( SELECT "g"."i"
                   FROM ( SELECT "generate_series"("array_lower"("p"."proargtypes", 1), "array_upper"("p"."proargtypes", 1)) AS "generate_series") "g"("i")) "sub" ON (("p"."proargtypes"["sub"."i"] = "t"."oid")))
             JOIN ( SELECT "pg_namespace"."oid",
                    "pg_namespace"."nspname"
                   FROM "pg_namespace") "ns" ON (("ns"."oid" = "t"."typnamespace")))
          ORDER BY "sub"."i"), ', '::"text")) || ')'::"text"), 'execute'::"text") AS "access"
   FROM ("pg_proc" "p"
     JOIN "pg_namespace" "n" ON (("p"."pronamespace" = "n"."oid")))
  WHERE (("n"."nspname" = 'bpd'::"name") AND (EXISTS ( SELECT "cfg_procnamespace"."name"
           FROM "bpd"."cfg_procnamespace"
          WHERE (("p"."proname")::"text" ~~ (("cfg_procnamespace"."name")::"text" || '%'::"text")))))
  ORDER BY "p"."proname";


--
-- TOC entry 609 (class 1259 OID 1396053)
-- Name: cfg_v_inittable_all; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_inittable_all" AS
 SELECT "c"."oid",
    "c"."relname",
    "t"."typrelid",
    ARRAY( SELECT "bpd"."cfg_tblcol2"("c"."oid") AS "cfg_tablecol") AS "columnlist"
   FROM ("pg_class" "c"
     JOIN "pg_type" "t" ON (("t"."typrelid" = "c"."oid")))
  WHERE (("t"."typcategory" = 'C'::"char") AND ("t"."typnamespace" = (16443)::"oid"))
  GROUP BY "c"."oid", "c"."relname", "t"."typrelid"
  ORDER BY "c"."oid";


--
-- TOC entry 616 (class 1259 OID 1414240)
-- Name: cfg_v_inittable_base; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_inittable_base" AS
 SELECT "c"."oid",
    "c"."relname",
    ARRAY( SELECT "bpd"."cfg_tblcol2"("c"."oid") AS "cfg_tablecol") AS "columnlist"
   FROM (("pg_class" "c"
     JOIN "pg_type" "t" ON (("t"."typrelid" = "c"."oid")))
     JOIN "bpd"."cfg_v_initproc_base" "p" ON (("p"."prorettype" = "t"."oid")))
  WHERE ("t"."typtype" = 'c'::"char")
  GROUP BY "c"."oid", "c"."relname"
  ORDER BY "c"."oid";


--
-- TOC entry 619 (class 1259 OID 1473401)
-- Name: cfg_v_inittable_base_desc; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_inittable_base_desc" AS
 SELECT "c"."oid",
    "c"."relname",
    ARRAY( SELECT "bpd"."cfg_tblcol2"("c"."oid") AS "cfg_tablecol") AS "columnlist",
    "array_to_string"(ARRAY( SELECT "d"."description"
           FROM "pg_description" "d"
          WHERE ("d"."objoid" = "c"."oid")), ''::"text") AS "description"
   FROM (("pg_class" "c"
     JOIN "pg_type" "t" ON (("t"."typrelid" = "c"."oid")))
     JOIN "bpd"."cfg_v_initproc_base" "p" ON (("p"."prorettype" = "t"."oid")))
  WHERE ("t"."typtype" = 'c'::"char")
  GROUP BY "c"."oid", "c"."relname"
  ORDER BY "c"."oid";


--
-- TOC entry 404 (class 1259 OID 244971)
-- Name: cfg_v_inittable_old; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_inittable_old" AS
 SELECT "c"."oid",
    "c"."relname"
   FROM (("pg_class" "c"
     JOIN "pg_type" "t" ON (("t"."typrelid" = "c"."oid")))
     JOIN "bpd"."cfg_v_initproc_old" "p" ON (("p"."prorettype" = "t"."oid")))
  WHERE ("t"."typtype" = 'c'::"char")
  GROUP BY "c"."oid", "c"."relname"
  ORDER BY "c"."oid";


--
-- TOC entry 608 (class 1259 OID 1393295)
-- Name: cfg_v_proc_array_use; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_proc_array_use" AS
 SELECT "pg_proc"."proname"
   FROM "pg_proc"
  WHERE (("pg_proc"."prosrc" ~~ '%array%'::"text") AND ("pg_proc"."pronamespace" = (16443)::"oid"))
  ORDER BY "pg_proc"."proname";


--
-- TOC entry 592 (class 1259 OID 1349071)
-- Name: cfg_v_proc_depended; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_proc_depended" AS
 SELECT (("d"."dbid")::"regclass")::"text" AS "dbid",
    (("d"."classid")::"regclass")::"text" AS "classid",
    "p"."proname"
   FROM ("pg_shdepend" "d"
     JOIN "pg_proc" "p" ON (("p"."oid" = "d"."objid")))
  WHERE ((("d"."classid")::"regclass")::"text" = 'pg_proc'::"text");


--
-- TOC entry 512 (class 1259 OID 1013123)
-- Name: cfg_v_proc_deposited; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_proc_deposited" AS
 SELECT "p"."proname",
    "l"."lanname",
    "pg_get_functiondef"("p"."oid") AS "code",
    "pg_get_function_identity_arguments"("p"."oid") AS "args"
   FROM ((("pg_namespace" "n"
     JOIN "pg_proc" "p" ON (("p"."pronamespace" = "n"."oid")))
     JOIN "pg_language" "l" ON (("p"."prolang" = "l"."oid")))
     JOIN "pg_type" "t" ON (("p"."prorettype" = "t"."oid")))
  WHERE (("p"."prokind" = ANY (ARRAY['f'::"char", 'p'::"char"])) AND ("n"."nspname" = 'bpd'::"name") AND (NOT ("p"."proname" ~~ 'cfg_%'::"text")) AND (NOT ("p"."proname" ~~ 'int_%'::"text")));


--
-- TOC entry 362 (class 1259 OID 111974)
-- Name: cfg_v_session; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_session" AS
 SELECT "pg_stat_activity"."datid",
    "pg_stat_activity"."datname",
    "pg_stat_activity"."pid",
    "pg_stat_activity"."usesysid",
    "pg_stat_activity"."usename",
    "pg_stat_activity"."application_name",
    "pg_stat_activity"."client_addr",
    "pg_stat_activity"."client_hostname",
    "pg_stat_activity"."client_port",
    "pg_stat_activity"."backend_start",
    "pg_stat_activity"."xact_start",
    "pg_stat_activity"."query_start",
    "pg_stat_activity"."state_change",
    "pg_stat_activity"."wait_event_type",
    "pg_stat_activity"."wait_event",
    "pg_stat_activity"."state",
    "pg_stat_activity"."backend_xid",
    "pg_stat_activity"."backend_xmin",
    "pg_stat_activity"."query",
    "pg_stat_activity"."backend_type"
   FROM "pg_stat_activity"
  WHERE ((NOT ("pg_stat_activity"."usename" IS NULL)) AND (NOT ("pg_stat_activity"."datname" IS NULL)));


--
-- TOC entry 463 (class 1259 OID 628158)
-- Name: cfg_v_ssl; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_ssl" AS
 SELECT "pa"."pid",
    "pa"."datname" AS "DataBase",
    "pa"."usename",
    "pa"."application_name" AS "application name",
    "pa"."client_addr" AS "client addres",
    "pa"."client_port" AS "client port",
    "pssl"."ssl" AS "ssl on",
    COALESCE("pssl"."version", 'н/д'::"text") AS "ssl version",
    COALESCE("pssl"."cipher", 'н/д'::"text") AS "ssl mode",
    COALESCE("pssl"."bits", 0) AS "ssl bits",
    "pa"."state"
   FROM ("pg_stat_activity" "pa"
     JOIN "pg_stat_ssl" "pssl" ON (("pssl"."pid" = "pa"."pid")))
  WHERE (NOT ("pa"."client_addr" IS NULL));


--
-- TOC entry 572 (class 1259 OID 1289443)
-- Name: cfg_v_table_size; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_v_table_size" AS
 SELECT "tables"."table_name",
    "pg_size_pretty"("pg_total_relation_size"(("concat"("tables"."table_schema", '.', "tables"."table_name"))::"regclass")) AS "pg_size_pretty"
   FROM "information_schema"."tables"
  WHERE ((("tables"."table_schema")::"name" = 'bpd'::"name") AND (("tables"."table_catalog")::"name" = 'Uchet'::"name") AND (("tables"."table_type")::"text" = 'BASE TABLE'::"text"));


--
-- TOC entry 597 (class 1259 OID 1369592)
-- Name: cfg_vrole_base; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."cfg_vrole_base" AS
 SELECT "r"."oid",
    "r"."rolinherit",
    ("r"."rolname")::character varying AS "rolname",
    "d"."description"
   FROM (("pg_roles" "r"
     JOIN "pg_shdescription" "d" ON (("d"."objoid" = "r"."oid")))
     JOIN "bpd"."role_base_list" "br" ON ((("br"."rolname")::"text" = "r"."rolname")))
  ORDER BY "br"."sort", (("r"."rolname")::character varying);


--
-- TOC entry 351 (class 1259 OID 94754)
-- Name: class_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."class_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6432 (class 0 OID 0)
-- Dependencies: 351
-- Name: class_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."class_id_seq" OWNED BY "bpd"."class"."id";


--
-- TOC entry 364 (class 1259 OID 116111)
-- Name: class_prop_id_parent_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."class_prop_id_parent_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6433 (class 0 OID 0)
-- Dependencies: 364
-- Name: class_prop_id_parent_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."class_prop_id_parent_seq" OWNED BY "bpd"."class_prop"."id_prop_inherit";


--
-- TOC entry 363 (class 1259 OID 116109)
-- Name: class_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."class_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6434 (class 0 OID 0)
-- Dependencies: 363
-- Name: class_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."class_prop_id_seq" OWNED BY "bpd"."class_prop"."id";


--
-- TOC entry 389 (class 1259 OID 203157)
-- Name: class_prop_obj_val_class_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."class_prop_obj_val_class_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6435 (class 0 OID 0)
-- Dependencies: 389
-- Name: class_prop_obj_val_class_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."class_prop_obj_val_class_id_seq" OWNED BY "bpd"."class_prop_obj_val_class"."id";


--
-- TOC entry 386 (class 1259 OID 181571)
-- Name: class_real_uc_rules_list; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."class_real_uc_rules_list" (
    "id_class" bigint NOT NULL,
    "id_unit" integer NOT NULL,
    "id_unit_conversion_rules" integer NOT NULL
);


--
-- TOC entry 308 (class 1259 OID 25692)
-- Name: conception_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."conception_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6436 (class 0 OID 0)
-- Dependencies: 308
-- Name: conception_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."conception_id_seq" OWNED BY "bpd"."conception"."id";


--
-- TOC entry 515 (class 1259 OID 1031476)
-- Name: doc_file_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."doc_file_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6437 (class 0 OID 0)
-- Dependencies: 515
-- Name: doc_file_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."doc_file_id_seq" OWNED BY "bpd"."doc_file"."id";


--
-- TOC entry 491 (class 1259 OID 793611)
-- Name: doc_links_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."doc_links_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6438 (class 0 OID 0)
-- Dependencies: 491
-- Name: doc_links_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."doc_links_id_seq" OWNED BY "bpd"."doc_link"."id";


--
-- TOC entry 323 (class 1259 OID 27591)
-- Name: doc_setings; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."doc_setings" (
    "id" integer NOT NULL,
    "name" character varying(50) NOT NULL,
    "val" character varying(1000) NOT NULL
);


--
-- TOC entry 494 (class 1259 OID 799895)
-- Name: document_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."document_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6439 (class 0 OID 0)
-- Dependencies: 494
-- Name: document_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."document_id_seq" OWNED BY "bpd"."document"."id";


--
-- TOC entry 419 (class 1259 OID 461873)
-- Name: enum_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."enum_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6440 (class 0 OID 0)
-- Dependencies: 419
-- Name: enum_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."enum_prop_id_seq" OWNED BY "bpd"."prop_enum"."id";


--
-- TOC entry 421 (class 1259 OID 461881)
-- Name: enum_prop_val_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."enum_prop_val_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6441 (class 0 OID 0)
-- Dependencies: 421
-- Name: enum_prop_val_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."enum_prop_val_id_seq" OWNED BY "bpd"."prop_enum_val"."id";


--
-- TOC entry 401 (class 1259 OID 231665)
-- Name: filelib_cfg; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."filelib_cfg" (
    "id" integer NOT NULL,
    "param_name" character varying(2044) NOT NULL,
    "param_val" character varying(2044) NOT NULL
);


--
-- TOC entry 470 (class 1259 OID 637729)
-- Name: global_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."global_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6442 (class 0 OID 0)
-- Dependencies: 470
-- Name: global_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."global_prop_id_seq" OWNED BY "bpd"."global_prop"."id";


--
-- TOC entry 349 (class 1259 OID 94740)
-- Name: group_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."group_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6443 (class 0 OID 0)
-- Dependencies: 349
-- Name: group_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."group_id_seq" OWNED BY "bpd"."group"."id";


--
-- TOC entry 503 (class 1259 OID 833719)
-- Name: int_class; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class" AS
 SELECT "c"."id",
    "c"."name_format",
    "c"."on_abstraction",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND (NOT "cc"."on_abstraction")))) AS "include_child_real_class"
   FROM ONLY "bpd"."class" "c";


--
-- TOC entry 510 (class 1259 OID 890464)
-- Name: int_class_prop_double; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class_prop_double" AS
 SELECT "cp"."id_class",
    "cp"."id_prop_definition",
    "count"("cp"."id_class") AS "prop_double"
   FROM ONLY "bpd"."class_prop" "cp"
  GROUP BY "cp"."id_class", "cp"."id_prop_definition";


--
-- TOC entry 530 (class 1259 OID 1136592)
-- Name: int_class_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class_snapshot" AS
 SELECT "c"."id",
    "c"."timestamp",
    "c"."name_format",
    "c"."on_abstraction",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND (NOT "cc"."on_abstraction")))) AS "include_child_real_class"
   FROM ONLY "bpd"."class" "c";


--
-- TOC entry 524 (class 1259 OID 1082652)
-- Name: int_class_snapshot_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_class_snapshot_ext" AS
 SELECT "c"."id",
    "c"."timestamp",
    "array_agg"("bpd"."int_cast_vclass_prop_to_cclass_prop"("cp".*)) AS "property_list"
   FROM ((ONLY "bpd"."class_snapshot" "c"
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "c"."id_con")))
     LEFT JOIN "bpd"."vclass_prop_snapshot" "cp" ON ((("cp"."id_class" = "c"."id") AND ("cp"."timestamp_class" = "c"."timestamp"))))
  GROUP BY "c"."id", "c"."timestamp";


--
-- TOC entry 513 (class 1259 OID 1016469)
-- Name: int_pyw_export_class_act_real; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_pyw_export_class_act_real" AS
 SELECT "c"."id",
    "c"."id_parent",
    "c_parent"."name" AS "name_parent",
    "c"."name",
    "c"."desc",
    "u"."name" AS "name_unit"
   FROM ((ONLY "bpd"."class" "c"
     JOIN ONLY "bpd"."class" "c_parent" ON (("c_parent"."id" = "c"."id_parent")))
     JOIN "bpd"."units" "u" ON (("u"."id" = "c"."id_unit")));


--
-- TOC entry 527 (class 1259 OID 1087206)
-- Name: int_vobject_prop_constraint; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_vobject_prop_constraint" AS
 SELECT "cp"."id_conception",
    "o"."id" AS "id_object_carrier",
    "o"."timestamp" AS "timestamp_object_carrier",
    "cp"."id" AS "id_class_prop",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."on_inherit",
    "cp"."id_prop_inherit",
    COALESCE("cp"."timestamp_class_inherit", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_inherit",
    "cp"."sort",
    "cp"."id_class_definition",
    "cp"."timestamp_class_definition",
    "cp"."id_prop_definition",
    "lgp"."id_global_prop",
    ("lgp"."id_global_prop" IS NOT NULL) AS "on_global",
    "cp"."tag"
   FROM (("bpd"."object" "o"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp" ON ((("cp"."id_class" = "o"."id_class") AND ("cp"."timestamp_class" = "o"."timestamp_class"))))
     LEFT JOIN "bpd"."global_prop_link_class_prop" "lgp" ON (("lgp"."id_class_prop_definition" = "cp"."id_prop_definition")));


--
-- TOC entry 584 (class 1259 OID 1302094)
-- Name: int_vposition_prop_constraint; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."int_vposition_prop_constraint" AS
 SELECT "ptp"."id_conception",
    "p"."id" AS "id_position_carrier",
    "p"."timestamp" AS "timestamp_position_carrier",
    "ptp"."id" AS "id_pos_temp_prop",
    "ptp"."id_pos_temp",
    "ptp"."id_prop_type",
    "ptp"."id_data_type",
    "ptp"."sort",
    "ptp"."on_override",
    ("lpt"."id_global_prop" IS NOT NULL) AS "on_global",
    COALESCE("lpt"."id_global_prop", ('-1'::integer)::bigint) AS "id_global_prop",
    "p"."id_root" AS "id_position_root"
   FROM ((((((("bpd"."position" "p"
     JOIN "bpd"."vpos_temp_prop" "ptp" ON (("ptp"."id_pos_temp" = "p"."id_pos_temp")))
     LEFT JOIN "bpd"."position_prop_user_small_val" "sv" ON ((("sv"."id_pos_temp_prop" = "ptp"."id") AND ("sv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."position_prop_user_big_val" "bv" ON ((("bv"."id_pos_temp_prop" = "ptp"."id") AND ("bv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."position_prop_enum_val" "ev" ON ((("ev"."id_pos_temp_prop" = "ptp"."id") AND ("ev"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")))
     LEFT JOIN "bpd"."position_prop_link_val" "lv" ON ((("lv"."id_pos_temp_prop" = "ptp"."id") AND ("lv"."id_position" = "p"."id"))))
     LEFT JOIN "bpd"."global_prop_link_pos_temp_prop" "lpt" ON (("lpt"."id_pos_temp_prop" = "ptp"."id")));


--
-- TOC entry 319 (class 1259 OID 25790)
-- Name: link_pos_obj; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."link_pos_obj" (
    "id" bigint NOT NULL,
    "id_con" bigint NOT NULL,
    "id_link_type" integer NOT NULL,
    "id_pos" bigint NOT NULL,
    "id_obj" bigint NOT NULL,
    "datetime" timestamp without time zone NOT NULL,
    "login" character varying(100) NOT NULL,
    "procedure" character varying(255) NOT NULL
);


--
-- TOC entry 318 (class 1259 OID 25788)
-- Name: link_pos_obj_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."link_pos_obj_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6444 (class 0 OID 0)
-- Dependencies: 318
-- Name: link_pos_obj_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."link_pos_obj_id_seq" OWNED BY "bpd"."link_pos_obj"."id";


--
-- TOC entry 355 (class 1259 OID 94833)
-- Name: link_type; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."link_type" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" "text" DEFAULT 'н/д'::"text" NOT NULL
);


--
-- TOC entry 360 (class 1259 OID 110124)
-- Name: map_class_pos_root; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."map_class_pos_root" (
    "id" bigint NOT NULL,
    "id_class_root" bigint NOT NULL,
    "id_pos_root" bigint NOT NULL,
    "id_link_type" integer NOT NULL
);


--
-- TOC entry 343 (class 1259 OID 49057)
-- Name: message; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."message" (
    "id" bigint NOT NULL,
    "order" integer NOT NULL,
    "datetime" timestamp without time zone NOT NULL,
    "id_ticket" bigint NOT NULL,
    "id_parent_mes" bigint,
    "title" character varying(100) NOT NULL,
    "body" "text" NOT NULL,
    "login" character varying(100) NOT NULL,
    "positive_rating" integer DEFAULT 0 NOT NULL,
    "negative_rating" integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 342 (class 1259 OID 49055)
-- Name: message_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."message_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6445 (class 0 OID 0)
-- Dependencies: 342
-- Name: message_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."message_id_seq" OWNED BY "bpd"."message"."id";


--
-- TOC entry 347 (class 1259 OID 49094)
-- Name: message_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."message_prop" (
    "id" bigint NOT NULL,
    "id_message" bigint NOT NULL,
    "name" character varying(100) NOT NULL,
    "id_data_type" integer NOT NULL,
    "val_timestamp" timestamp without time zone,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_text" "text",
    "val_real" real,
    "val_numeric" numeric,
    "val_bytea" "bytea",
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_json" "json",
    "val_money" "money",
    "val_double" double precision,
    "val_on" boolean NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL,
    "id_data_bin_ext" integer DEFAULT 0
);


--
-- TOC entry 346 (class 1259 OID 49092)
-- Name: message_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."message_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6446 (class 0 OID 0)
-- Dependencies: 346
-- Name: message_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."message_prop_id_seq" OWNED BY "bpd"."message_prop"."id";


--
-- TOC entry 353 (class 1259 OID 94775)
-- Name: obj_representation; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."obj_representation" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "table_name" character varying(100) NOT NULL
);


--
-- TOC entry 533 (class 1259 OID 1158691)
-- Name: plan; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(2044) DEFAULT 'н/д'::"text" NOT NULL,
    "on" boolean NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL
);


--
-- TOC entry 540 (class 1259 OID 1158907)
-- Name: plan_calendar; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_calendar" (
    "id" bigint NOT NULL,
    "work_date" "date" NOT NULL,
    "work_year" integer GENERATED ALWAYS AS ("date_part"('year'::"text", "work_date")) STORED NOT NULL,
    "work_month" integer GENERATED ALWAYS AS ("date_part"('month'::"text", "work_date")) STORED NOT NULL,
    "work_month_day" integer GENERATED ALWAYS AS ("date_part"('day'::"text", "work_date")) STORED NOT NULL,
    "day_type" "bpd"."day_type" DEFAULT 'working'::"bpd"."day_type" NOT NULL,
    "work_year_day" integer GENERATED ALWAYS AS ("date_part"('doy'::"text", "work_date")) STORED,
    "week40_day" numeric,
    "week40_month" numeric,
    "week39_day" numeric,
    "week39_month" numeric,
    "week36_day" numeric,
    "week36_month" numeric,
    "week35_day" numeric,
    "week35_month" numeric,
    "week33_day" numeric,
    "week33_month" numeric,
    "week30_day" numeric,
    "week30_month" numeric,
    "week24_day" numeric,
    "week24_month" numeric,
    "week20_day" numeric,
    "week20_month" numeric,
    "week18_day" numeric,
    "week18_month" numeric,
    "range_night_part1" "tsrange" GENERATED ALWAYS AS ("tsrange"(("work_date")::timestamp without time zone, ("work_date" + '06:00:00'::interval), '[]'::"text")) STORED,
    "range_night_part2" "tsrange" GENERATED ALWAYS AS ("tsrange"(("work_date" + '22:00:00'::interval), ("work_date" + '24:00:00'::interval), '[)'::"text")) STORED,
    "work_week_day" integer GENERATED ALWAYS AS ("date_part"('isodow'::"text", "work_date")) STORED,
    "work_week_day_name" character varying GENERATED ALWAYS AS (
CASE "date_part"('isodow'::"text", "work_date")
    WHEN 1 THEN 'ПН'::character varying
    WHEN 2 THEN 'ВТ'::character varying
    WHEN 3 THEN 'СР'::character varying
    WHEN 4 THEN 'ЧТ'::character varying
    WHEN 5 THEN 'ПН'::character varying
    WHEN 6 THEN 'СБ'::character varying
    WHEN 7 THEN 'ВС'::character varying
    ELSE 'ПН'::character varying
END) STORED,
    "work_week_day_name_full" character varying GENERATED ALWAYS AS (
CASE "date_part"('isodow'::"text", "work_date")
    WHEN 1 THEN 'Понедельник'::character varying
    WHEN 2 THEN 'Вторник'::character varying
    WHEN 3 THEN 'Среда'::character varying
    WHEN 4 THEN 'Четверг'::character varying
    WHEN 5 THEN 'Пятница'::character varying
    WHEN 6 THEN 'Суббота'::character varying
    WHEN 7 THEN 'Воскресенье'::character varying
    ELSE 'Понедельник'::character varying
END) STORED,
    "work_year_week" integer GENERATED ALWAYS AS ("date_part"('week'::"text", "work_date")) STORED,
    "week40_week" numeric,
    "week39_week" numeric,
    "week36_week" numeric,
    "week35_week" numeric,
    "week33_week" numeric,
    "week30_week" numeric,
    "week24_week" numeric,
    "week20_week" numeric,
    "week18_week" numeric
);


--
-- TOC entry 553 (class 1259 OID 1166878)
-- Name: plan_holiday; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_holiday" (
    "holiday_date" "date" NOT NULL,
    "holiday_name" character varying(100) NOT NULL,
    "holiday_month" integer GENERATED ALWAYS AS ("date_part"('month'::"text", "holiday_date")) STORED NOT NULL,
    "holiday_month_day" integer GENERATED ALWAYS AS ("date_part"('day'::"text", "holiday_date")) STORED NOT NULL,
    "holiday_date_cancellation" "date",
    "holiday_tsrange" "tsrange" GENERATED ALWAYS AS (
CASE
    WHEN ("holiday_date_cancellation" IS NULL) THEN "tsrange"(("holiday_date")::timestamp without time zone, 'infinity'::timestamp without time zone, '[)'::"text")
    ELSE "tsrange"(("holiday_date")::timestamp without time zone, ("holiday_date_cancellation")::timestamp without time zone, '[]'::"text")
END) STORED
);


--
-- TOC entry 532 (class 1259 OID 1158689)
-- Name: plan_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."plan_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6447 (class 0 OID 0)
-- Dependencies: 532
-- Name: plan_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."plan_id_seq" OWNED BY "bpd"."plan"."id";


--
-- TOC entry 538 (class 1259 OID 1158734)
-- Name: plan_interval; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_interval" (
    "id" bigint NOT NULL,
    "id_plan" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "interval_duration" interval NOT NULL,
    "on" boolean NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL,
    "inteval_start" time without time zone NOT NULL,
    "name" character varying(100) NOT NULL,
    "desc" character varying(255) NOT NULL
);


--
-- TOC entry 537 (class 1259 OID 1158732)
-- Name: plan_intervals_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."plan_intervals_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6448 (class 0 OID 0)
-- Dependencies: 537
-- Name: plan_intervals_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."plan_intervals_id_seq" OWNED BY "bpd"."plan_interval"."id";


--
-- TOC entry 542 (class 1259 OID 1159696)
-- Name: plan_link; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_link" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_plan" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint NOT NULL,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 541 (class 1259 OID 1159694)
-- Name: plan_link_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."plan_link_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6449 (class 0 OID 0)
-- Dependencies: 541
-- Name: plan_link_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."plan_link_id_seq" OWNED BY "bpd"."plan_link"."id";


--
-- TOC entry 536 (class 1259 OID 1158720)
-- Name: plan_range_fact; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_range_fact" (
    "id" bigint NOT NULL,
    "id_plan" bigint NOT NULL,
    "id_plan_range" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "range_fact" "tsrange" NOT NULL,
    "on" boolean NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL,
    "id_range_plan" bigint NOT NULL,
    "range_fact_upper" timestamp without time zone GENERATED ALWAYS AS ("upper"("range_fact")) STORED,
    "range_fact_lower" timestamp without time zone GENERATED ALWAYS AS ("lower"("range_fact")) STORED,
    "range_fact_upper_inc" boolean GENERATED ALWAYS AS ("upper_inc"("range_fact")) STORED,
    "range_fact_lower_inc" boolean GENERATED ALWAYS AS ("lower_inc"("range_fact")) STORED,
    "range_fact_type" "bpd"."range_work_type" NOT NULL,
    "range_fact_state" "bpd"."range_work_state" NOT NULL,
    "id_plan_interval" bigint NOT NULL
);


--
-- TOC entry 547 (class 1259 OID 1160792)
-- Name: plan_range_fact_link; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_range_fact_link" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_plan_range_fact" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint NOT NULL,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 551 (class 1259 OID 1160814)
-- Name: plan_range_link; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_range_link" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_plan_range" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint NOT NULL,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 545 (class 1259 OID 1160711)
-- Name: plan_range_plan; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_range_plan" (
    "id" bigint NOT NULL,
    "id_plan" bigint NOT NULL,
    "id_plan_range" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "range_plan" "tsrange" NOT NULL,
    "on" boolean NOT NULL,
    "timestamp" timestamp without time zone DEFAULT LOCALTIMESTAMP(3) NOT NULL,
    "on_freeze" boolean DEFAULT false NOT NULL,
    "range_plan_upper" timestamp without time zone GENERATED ALWAYS AS ("upper"("range_plan")) STORED,
    "range_plan_lower" timestamp without time zone GENERATED ALWAYS AS ("lower"("range_plan")) STORED,
    "range_plan_upper_inc" boolean GENERATED ALWAYS AS ("upper_inc"("range_plan")) STORED,
    "range_plan_lower_inc" boolean GENERATED ALWAYS AS ("lower_inc"("range_plan")) STORED,
    "range_plan_type" "bpd"."range_work_type" NOT NULL,
    "range_plan_state" "bpd"."range_work_state" NOT NULL,
    "id_plan_interval" bigint NOT NULL,
    "id_rule_relationship" integer[] NOT NULL
);


--
-- TOC entry 549 (class 1259 OID 1160803)
-- Name: plan_range_plan_link; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_range_plan_link" (
    "id" bigint NOT NULL,
    "id_conception" bigint NOT NULL,
    "id_plan_range_plan" bigint NOT NULL,
    "id_entity" integer NOT NULL,
    "id_entity_instance" bigint NOT NULL,
    "id_sub_entity_instance" bigint DEFAULT '-1'::integer NOT NULL
);


--
-- TOC entry 554 (class 1259 OID 1203352)
-- Name: plan_transfer_day; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."plan_transfer_day" (
    "day_date" "date" NOT NULL,
    "day_type" "bpd"."day_type" DEFAULT 'working'::"bpd"."day_type" NOT NULL,
    "desc" character varying(255) DEFAULT 'н/д'::character varying NOT NULL
);


--
-- TOC entry 313 (class 1259 OID 25720)
-- Name: pos_temp_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."pos_temp_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6450 (class 0 OID 0)
-- Dependencies: 313
-- Name: pos_temp_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."pos_temp_id_seq" OWNED BY "bpd"."pos_temp"."id";


--
-- TOC entry 446 (class 1259 OID 611711)
-- Name: pos_temp_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."pos_temp_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6451 (class 0 OID 0)
-- Dependencies: 446
-- Name: pos_temp_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."pos_temp_prop_id_seq" OWNED BY "bpd"."pos_temp_prop"."id";


--
-- TOC entry 454 (class 1259 OID 611847)
-- Name: pos_temp_prop_obj_val_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."pos_temp_prop_obj_val_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6452 (class 0 OID 0)
-- Dependencies: 454
-- Name: pos_temp_prop_obj_val_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."pos_temp_prop_obj_val_id_seq" OWNED BY "bpd"."pos_temp_prop_obj_val"."id";


--
-- TOC entry 310 (class 1259 OID 25703)
-- Name: position_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."position_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6453 (class 0 OID 0)
-- Dependencies: 310
-- Name: position_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."position_id_seq" OWNED BY "bpd"."position"."id";


--
-- TOC entry 607 (class 1259 OID 1385223)
-- Name: sec_table_access; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."sec_table_access" (
    "id" bigint NOT NULL,
    "rolname" "name" NOT NULL,
    "action" "bpd"."action_sql" NOT NULL,
    "id_entity" bigint NOT NULL,
    "id_entity_instance" bigint NOT NULL
);


--
-- TOC entry 606 (class 1259 OID 1385221)
-- Name: sec_table_access_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."sec_table_access_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6454 (class 0 OID 0)
-- Dependencies: 606
-- Name: sec_table_access_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."sec_table_access_id_seq" OWNED BY "bpd"."sec_table_access"."id";


--
-- TOC entry 341 (class 1259 OID 49046)
-- Name: ticket; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."ticket" (
    "id" bigint NOT NULL,
    "name" character varying(100) NOT NULL,
    "body" "text" NOT NULL,
    "login" character varying(100) NOT NULL,
    "state" integer NOT NULL,
    "id_mes_finaly" bigint NOT NULL
);


--
-- TOC entry 340 (class 1259 OID 49044)
-- Name: ticket_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."ticket_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6455 (class 0 OID 0)
-- Dependencies: 340
-- Name: ticket_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."ticket_id_seq" OWNED BY "bpd"."ticket"."id";


--
-- TOC entry 345 (class 1259 OID 49077)
-- Name: ticket_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."ticket_prop" (
    "id" bigint NOT NULL,
    "id_ticket" bigint NOT NULL,
    "name" character varying(100) NOT NULL,
    "id_data_type" integer NOT NULL,
    "val_timestamp" timestamp without time zone,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_text" "text",
    "val_real" real,
    "val_numeric" numeric,
    "val_bytea" "bytea",
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_json" "json",
    "val_money" "money",
    "val_double" double precision,
    "val_on" boolean NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL,
    "id_data_bin_ext" integer DEFAULT 0
);


--
-- TOC entry 344 (class 1259 OID 49075)
-- Name: ticket_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."ticket_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6456 (class 0 OID 0)
-- Dependencies: 344
-- Name: ticket_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."ticket_prop_id_seq" OWNED BY "bpd"."ticket_prop"."id";


--
-- TOC entry 348 (class 1259 OID 49121)
-- Name: ticket_state; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."ticket_state" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL
);


--
-- TOC entry 516 (class 1259 OID 1041871)
-- Name: tpm_class_prop_act; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."tpm_class_prop_act" AS
 SELECT "cp"."id",
    "cp"."id_data_type",
    "cp"."name",
    "c"."name" AS "name_class",
    "c"."desc",
    "cpv"."val_varchar",
    "replace"(("cpv"."val_varchar")::"text", '10CFF01'::"text", 'CFF01'::"text") AS "new_val"
   FROM ((ONLY "bpd"."class_prop" "cp"
     JOIN ONLY "bpd"."class_prop_user_small_val" "cpv" ON (("cpv"."id_class_prop" = "cp"."id")))
     JOIN ONLY "bpd"."class" "c" ON (("c"."id" = "cp"."id_class")))
  WHERE ("cp"."id_prop_inherit" = ANY (ARRAY[11143, 11144, 15379]));


--
-- TOC entry 407 (class 1259 OID 282919)
-- Name: unit_conversion_base_rules; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."unit_conversion_base_rules" (
    "id" integer DEFAULT "nextval"('"bpd"."unit_conversion_rule_id_seq"'::"regclass") NOT NULL,
    "id_unit" integer NOT NULL,
    "cunit" character varying(100) NOT NULL,
    "mc" numeric NOT NULL,
    "on_base" boolean NOT NULL,
    "desc" character varying(100),
    "bunit" character varying(100) DEFAULT 'кг'::character varying NOT NULL,
    "on_single" boolean DEFAULT false NOT NULL,
    "on" boolean DEFAULT true NOT NULL,
    "round" integer DEFAULT 0,
    "not_fractional" boolean DEFAULT false NOT NULL,
    "timestamp" timestamp without time zone NOT NULL
);


--
-- TOC entry 327 (class 1259 OID 30418)
-- Name: user_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."user_prop" (
    "id" bigint NOT NULL,
    "name" character varying(100) NOT NULL,
    "id_data_type" integer NOT NULL,
    "id_temp_prop" integer DEFAULT '-1'::integer NOT NULL,
    "id_data_bin_ext" integer DEFAULT 0
);


--
-- TOC entry 326 (class 1259 OID 30416)
-- Name: user_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."user_prop_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6457 (class 0 OID 0)
-- Dependencies: 326
-- Name: user_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."user_prop_id_seq" OWNED BY "bpd"."user_prop"."id";


--
-- TOC entry 328 (class 1259 OID 30440)
-- Name: user_prop_val; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."user_prop_val" (
    "login" character varying(100) NOT NULL,
    "id_user_prop" bigint NOT NULL,
    "val_timestamp" timestamp without time zone,
    "val_int" integer,
    "val_boolean" boolean,
    "val_varchar" character varying(2044),
    "val_text" "text",
    "val_real" real,
    "val_numeric" numeric,
    "val_bytea" "bytea",
    "val_date" "date",
    "val_time" time without time zone,
    "val_interval" interval,
    "val_json" "json",
    "val_money" "money",
    "val_double" double precision,
    "val_on" boolean NOT NULL,
    "sort" integer DEFAULT 0 NOT NULL
);


--
-- TOC entry 596 (class 1259 OID 1359305)
-- Name: user_role_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."user_role_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6458 (class 0 OID 0)
-- Dependencies: 596
-- Name: user_role_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."user_role_id_seq" OWNED BY "bpd"."role_user"."id";


--
-- TOC entry 591 (class 1259 OID 1348766)
-- Name: user_role_mapping; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."user_role_mapping" (
    "oid_role" "oid" NOT NULL,
    "id_conception" bigint NOT NULL
);


--
-- TOC entry 332 (class 1259 OID 33923)
-- Name: user_temp_prop; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."user_temp_prop" (
    "id" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    "id_data_type" integer NOT NULL
);


--
-- TOC entry 331 (class 1259 OID 33921)
-- Name: user_temp_prop_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."user_temp_prop_id_seq"
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6459 (class 0 OID 0)
-- Dependencies: 331
-- Name: user_temp_prop_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."user_temp_prop_id_seq" OWNED BY "bpd"."user_temp_prop"."id";


--
-- TOC entry 568 (class 1259 OID 1244016)
-- Name: vcalendar; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vcalendar" AS
 SELECT "plan_calendar"."id",
    "plan_calendar"."work_date",
    "plan_calendar"."day_type",
    "plan_calendar"."work_year",
    "plan_calendar"."work_month",
    "plan_calendar"."work_month_day",
    "plan_calendar"."work_year_day",
    "plan_calendar"."work_year_week",
    "plan_calendar"."work_week_day_name",
    "plan_calendar"."work_week_day_name_full",
    "plan_calendar"."range_night_part1",
    "plan_calendar"."range_night_part2",
    "plan_calendar"."week40_day",
    "plan_calendar"."week40_week",
    "plan_calendar"."week40_month",
    "plan_calendar"."week39_day",
    "plan_calendar"."week39_week",
    "plan_calendar"."week39_month",
    "plan_calendar"."week36_day",
    "plan_calendar"."week36_week",
    "plan_calendar"."week36_month",
    "plan_calendar"."week35_day",
    "plan_calendar"."week35_week",
    "plan_calendar"."week35_month",
    "plan_calendar"."week33_day",
    "plan_calendar"."week33_week",
    "plan_calendar"."week33_month",
    "plan_calendar"."week30_day",
    "plan_calendar"."week30_week",
    "plan_calendar"."week30_month",
    "plan_calendar"."week24_day",
    "plan_calendar"."week24_week",
    "plan_calendar"."week24_month",
    "plan_calendar"."week20_day",
    "plan_calendar"."week20_week",
    "plan_calendar"."week20_month",
    "plan_calendar"."week18_day",
    "plan_calendar"."week18_week",
    "plan_calendar"."week18_month"
   FROM "bpd"."plan_calendar";


--
-- TOC entry 478 (class 1259 OID 679750)
-- Name: vcfg_prop_spec_limit_shem; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vcfg_prop_spec_limit_shem" AS
 SELECT "sl"."id_prop_data_type" AS "Тип",
    "dt"."desc" AS "Описание",
    "sl"."max_used",
    "sl"."max_limit_on",
    "sl"."max_upper",
    "sl"."max_lower",
    "sl"."max_default",
    "sl"."min_used",
    "sl"."min_limit_on",
    "sl"."min_upper",
    "sl"."min_lower",
    "sl"."min_default",
    "sl"."round_used",
    "sl"."round_limit_on",
    "sl"."round_upper",
    "sl"."round_lower",
    "sl"."round_default",
    "sl"."round_on_default"
   FROM ("bpd"."cfg_prop_spec_limit2" "sl"
     JOIN "bpd"."prop_data_type" "dt" ON (("dt"."id" = "sl"."id_prop_data_type")))
  ORDER BY "sl"."id_prop_data_type";


--
-- TOC entry 432 (class 1259 OID 509964)
-- Name: vclass_prop_enum_val_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_enum_val_snapshot" AS
 SELECT "cp"."id_conception",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."id_prop_enum", ('-1'::integer)::bigint) AS "id_prop_enum",
    COALESCE("cv"."id_prop_enum_val", ('-1'::integer)::bigint) AS "id_prop_enum_val",
    COALESCE("pev"."val_numeric", (0)::numeric) AS "val_numeric",
    COALESCE("pev"."val_varchar", ''::character varying(100)) AS "val_varchar",
    COALESCE("pev"."is_use", false) AS "is_use",
    COALESCE("pev"."id_object_reference", ('-1'::integer)::bigint) AS "id_object_reference",
    COALESCE("pev"."has_object_reference", false) AS "has_object_reference",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
            WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
            ELSE false
        END AS "on_val"
   FROM ((ONLY "bpd"."class_prop_snapshot" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_enum_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN ONLY "bpd"."vprop_enum_val" "pev" ON (("pev"."id_prop_enum_val" = "cv"."id_prop_enum_val")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[1, 3])) AND ("cp"."id_prop_type" = 2));


--
-- TOC entry 437 (class 1259 OID 519096)
-- Name: vclass_prop_link_val_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_link_val_snapshot" AS
 SELECT "cp"."id_conception",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."id_entity", 0) AS "id_entity",
    COALESCE("cv"."id_entity_instance", ('-1'::integer)::bigint) AS "id_entity_instance",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
    (COALESCE("cv"."id_entity_instance", (0)::bigint) > 0) AS "on_val",
    COALESCE("cv"."id_sub_entity_instance", ('-1'::integer)::bigint) AS "id_sub_entity_instance"
   FROM (ONLY "bpd"."class_prop_snapshot" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_link_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
  WHERE (("cp"."id_data_type" = 15) AND ("cp"."id_prop_type" = 4));


--
-- TOC entry 440 (class 1259 OID 533135)
-- Name: vclass_prop_object_val_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_object_val_snapshot" AS
 SELECT "cp"."id" AS "id_class_prop",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."id", ('-1'::integer)::bigint) AS "id",
    ("class_val"."id" IS NOT NULL) AS "on_val",
    COALESCE("cv"."id_class_val", ('-1'::integer)::bigint) AS "id_class_val",
    COALESCE("cv"."timestamp_class_val", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_val",
    COALESCE("cv"."bquantity_max", ('-1'::integer)::numeric) AS "bquantity_max",
    COALESCE("cv"."bquantity_min", ('-1'::integer)::numeric) AS "bquantity_min",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE
            WHEN ("cv"."embed_mode" = ANY (ARRAY[0, 1, 2])) THEN COALESCE("cv"."embed_mode", 0)
            ELSE 0
        END AS "embed_mode",
    COALESCE("cv"."embed_single", false) AS "embed_single",
    COALESCE("cv"."embed_class_real_id", ('-1'::integer)::bigint) AS "embed_class_real_id",
    COALESCE("cv"."id_unit_conversion_rule", '-1'::integer) AS "id_unit_conversion_rule"
   FROM ((ONLY "bpd"."class_prop_snapshot" "cp"
     LEFT JOIN "bpd"."class_prop_obj_val_class_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."class_snapshot" "class_val" ON ((("class_val"."id" = "cv"."id_class_val") AND ("class_val"."timestamp" = "cv"."timestamp_class_val"))))
  WHERE ("cp"."id_prop_type" = 3);


--
-- TOC entry 460 (class 1259 OID 620780)
-- Name: vclass_prop_user_big_val_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_user_big_val_snapshot" AS
 SELECT "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."min_val", ('-1'::integer)::numeric) AS "min_val",
    COALESCE("cv"."min_on", false) AS "min_on",
    COALESCE("cv"."max_val", ('-1'::integer)::numeric) AS "max_val",
    COALESCE("cv"."max_on", false) AS "max_on",
    "cv"."val_text",
    "cv"."val_bytea",
    "cv"."val_json",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 7 THEN ("cv"."val_text" IS NOT NULL)
            WHEN 8 THEN ("cv"."val_bytea" IS NOT NULL)
            WHEN 14 THEN ("cv"."val_json" IS NOT NULL)
            ELSE NULL::boolean
        END AS "on_val",
    "sl"."max_used",
    "sl"."min_used"
   FROM ((ONLY "bpd"."class_prop_snapshot" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_user_big_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "cp"."id_data_type")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[7, 8, 14])) AND ("cp"."id_prop_type" = 1));


--
-- TOC entry 418 (class 1259 OID 441758)
-- Name: vclass_prop_user_small_val_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_prop_user_small_val_snapshot" AS
 SELECT "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."id" AS "id_class_prop",
    "cp"."id_data_type",
    "cp"."id_class_definition",
    "cp"."id_prop_definition",
    "cp"."timestamp_class_definition",
    COALESCE("cv"."inheritance", false) AS "inheritance",
    COALESCE("cv"."min_val", ('-1'::integer)::numeric) AS "min_val",
    COALESCE("cv"."min_on", false) AS "min_on",
    COALESCE("cv"."max_val", ('-1'::integer)::numeric) AS "max_val",
    COALESCE("cv"."max_on", false) AS "max_on",
    COALESCE("cv"."round", "sl"."round_default") AS "round",
    COALESCE("cv"."round_on", "sl"."round_on_default") AS "round_on",
    "cv"."val_varchar",
    "cv"."val_int",
    "cv"."val_numeric",
    "cv"."val_real",
    "cv"."val_double",
    "cv"."val_money",
    "cv"."val_boolean",
    "cv"."val_date",
    "cv"."val_time",
    "cv"."val_interval",
    "cv"."val_timestamp",
    "cv"."val_bigint",
    COALESCE((("cv"."tableoid")::"regclass")::character varying, 'notsaved'::character varying) AS "tablename",
        CASE "cp"."id_data_type"
            WHEN 1 THEN ("cv"."val_varchar" IS NOT NULL)
            WHEN 2 THEN ("cv"."val_int" IS NOT NULL)
            WHEN 3 THEN ("cv"."val_numeric" IS NOT NULL)
            WHEN 4 THEN ("cv"."val_real" IS NOT NULL)
            WHEN 5 THEN ("cv"."val_double" IS NOT NULL)
            WHEN 6 THEN ("cv"."val_money" IS NOT NULL)
            WHEN 9 THEN ("cv"."val_boolean" IS NOT NULL)
            WHEN 10 THEN ("cv"."val_date" IS NOT NULL)
            WHEN 11 THEN ("cv"."val_time" IS NOT NULL)
            WHEN 12 THEN ("cv"."val_interval" IS NOT NULL)
            WHEN 13 THEN ("cv"."val_timestamp" IS NOT NULL)
            WHEN 15 THEN ("cv"."val_bigint" IS NOT NULL)
            ELSE NULL::boolean
        END AS "on_val",
    "sl"."max_used",
    "sl"."min_used",
    "sl"."round_used"
   FROM ((ONLY "bpd"."class_prop_snapshot" "cp"
     LEFT JOIN ONLY "bpd"."class_prop_user_small_val_snapshot" "cv" ON ((("cv"."id_class_prop" = "cp"."id") AND ("cv"."timestamp_class" = "cp"."timestamp_class"))))
     LEFT JOIN "bpd"."cfg_prop_spec_limit2" "sl" ON (("sl"."id_prop_data_type" = "cp"."id_data_type")))
  WHERE (("cp"."id_data_type" = ANY (ARRAY[1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 15])) AND ("cp"."id_prop_type" = 1));


--
-- TOC entry 564 (class 1259 OID 1209280)
-- Name: vclass_snapshot; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_snapshot" AS
 SELECT "c"."id",
    "c"."timestamp",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "ca"
          WHERE ("ca"."id" = "c"."id"))) AS "has_active",
    "c"."timestamp_child_change",
    "c"."id_con",
    "c"."id_group",
    "c"."id_group_root",
    "c"."id_parent",
    "c"."timestamp_parent",
    "c"."id_root",
    "c"."timestamp_root",
    "c"."level",
    ("c"."level" = 0) AS "is_root",
    (("c"."tableoid")::"regclass")::character varying AS "tablename",
    "c"."name",
    "c"."name_format",
    "c"."quantity_show",
    "c"."desc",
    "c"."on",
    "c"."on_extensible",
    "c"."on_abstraction",
    "c"."id_unit",
    "c"."id_unit_conversion_rule",
    "c"."barcode_manufacturer",
    "c"."barcode_local",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND ("cc"."timestamp_parent" = "c"."timestamp")))) AS "include_child_class",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "co"
          WHERE (("co"."id_class" = "c"."id") AND ("co"."timestamp_class" = "c"."timestamp")))) AS "include_child_object",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND ("cc"."timestamp_parent" = "c"."timestamp") AND (NOT "cc"."on_abstraction")))) AS "include_child_real_class",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND ("cc"."timestamp_parent" = "c"."timestamp") AND "cc"."on_abstraction"))) AS "include_child_abstract_class",
    ( SELECT "count"(1) AS "count"
           FROM ONLY "bpd"."class_snapshot" "cc"
          WHERE ("cc"."id_parent" = "c"."id")) AS "child_count",
    ("con"."group_recycle" = "c"."id_group_root") AS "in_recycle",
    "c"."on_freeze",
    true AS "ready",
    COALESCE("c_path"."path", 'н/д'::"text") AS "path"
   FROM ((ONLY "bpd"."class_snapshot" "c"
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "c"."id_con")))
     LEFT JOIN "bpd"."int_class_path" "c_path" ON (("c_path"."id" = "c"."id")));


--
-- TOC entry 565 (class 1259 OID 1209285)
-- Name: vclass_snapshot_ext; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vclass_snapshot_ext" AS
 SELECT "c"."id",
    "c"."timestamp",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class" "ca"
          WHERE ("ca"."id" = "c"."id"))) AS "has_active",
    "c"."timestamp_child_change",
    "c"."id_con",
    "c"."id_group",
    "c"."id_group_root",
    "c"."id_parent",
    "c"."timestamp_parent",
    "c"."id_root",
    "c"."timestamp_root",
    "c"."level",
    ("c"."level" = 0) AS "is_root",
    (("c"."tableoid")::"regclass")::character varying AS "tablename",
    "c"."name",
    "c"."name_format",
    "c"."quantity_show",
    "c"."desc",
    "c"."on",
    "c"."on_extensible",
    "c"."on_abstraction",
    "c"."id_unit",
    "c"."id_unit_conversion_rule",
    "c"."barcode_manufacturer",
    "c"."barcode_local",
    (EXISTS ( SELECT 1
           FROM "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND ("cc"."timestamp_parent" = "c"."timestamp")))) AS "include_child_class",
    (EXISTS ( SELECT 1
           FROM "bpd"."object" "co"
          WHERE (("co"."id_class" = "c"."id") AND ("co"."timestamp_class" = "c"."timestamp")))) AS "include_child_object",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND ("cc"."timestamp_parent" = "c"."timestamp") AND (NOT "cc"."on_abstraction")))) AS "include_child_real_class",
    (EXISTS ( SELECT 1
           FROM ONLY "bpd"."class_snapshot" "cc"
          WHERE (("cc"."id_parent" = "c"."id") AND ("cc"."timestamp_parent" = "c"."timestamp") AND "cc"."on_abstraction"))) AS "include_child_abstract_class",
    ( SELECT "count"(1) AS "count"
           FROM ONLY "bpd"."class_snapshot" "cc"
          WHERE ("cc"."id_parent" = "c"."id")) AS "child_count",
    ("con"."group_recycle" = "c"."id_group_root") AS "in_recycle",
    "c"."on_freeze",
    "c_ext"."property_list",
    true AS "ready",
    "c_path"."path"
   FROM ((("bpd"."class_snapshot" "c"
     LEFT JOIN "bpd"."conception" "con" ON (("con"."id" = "c"."id_con")))
     LEFT JOIN "bpd"."int_class_snapshot_ext" "c_ext" ON ((("c_ext"."id" = "c"."id") AND ("c_ext"."timestamp" = "c"."timestamp"))))
     LEFT JOIN "bpd"."int_class_path" "c_path" ON (("c_path"."id" = "c"."id")));


--
-- TOC entry 316 (class 1259 OID 25763)
-- Name: vector; Type: TABLE; Schema: bpd; Owner: -
--

CREATE TABLE "bpd"."vector" (
    "id" bigint NOT NULL,
    "name" "text" NOT NULL,
    "id_con_start" bigint NOT NULL,
    "id_pos_start" bigint NOT NULL,
    "id_con_stop" bigint NOT NULL,
    "id_pos_stop" bigint NOT NULL,
    "recursive" boolean NOT NULL
);


--
-- TOC entry 315 (class 1259 OID 25761)
-- Name: vector_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."vector_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6460 (class 0 OID 0)
-- Dependencies: 315
-- Name: vector_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."vector_id_seq" OWNED BY "bpd"."vector"."id";


--
-- TOC entry 555 (class 1259 OID 1207692)
-- Name: vholiday; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vholiday" AS
 SELECT "plan_holiday"."holiday_date",
    "plan_holiday"."holiday_name",
    "plan_holiday"."holiday_month",
    "plan_holiday"."holiday_month_day",
    "plan_holiday"."holiday_date_cancellation",
    "plan_holiday"."holiday_tsrange"
   FROM "bpd"."plan_holiday";


--
-- TOC entry 567 (class 1259 OID 1239544)
-- Name: vobject_prop_new; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vobject_prop_new" AS
 SELECT "cp"."id" AS "id_class_prop",
    "o"."id" AS "id_object_carrier",
    "o"."timestamp" AS "timestamp_object_carrier",
    "cp"."id_class",
    "cp"."timestamp_class",
    "cp"."on_inherit",
    true AS "inheritance",
    "cp"."id_prop_inherit",
    COALESCE("cp"."timestamp_class_inherit", '1990-01-01 00:00:00'::timestamp without time zone) AS "timestamp_class_inherit",
    "cp"."id_prop_type",
    "cp"."id_data_type",
    "cp"."name",
    "cp"."desc",
    "cp"."sort",
    "cp"."on_override",
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                ELSE false
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                ELSE false
            END
            WHEN 3 THEN (EXISTS ( SELECT 1
               FROM "bpd"."object" "ov"
              WHERE (("ov"."id_object_carrier" = "o"."id") AND ("ov"."id_class_prop_object_carrier" = "cp"."id"))))
            WHEN 4 THEN ("lv"."id_entity_instance" IS NOT NULL)
            ELSE false
        END AS "on_val_object",
    "cp"."id_conception",
    "cp"."id_class_definition",
    "cp"."timestamp_class_definition",
    "cp"."id_prop_definition",
    COALESCE(
        CASE "cp"."id_prop_type"
            WHEN 1 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN "sv"."val_varchar"
                WHEN 2 THEN ("sv"."val_int")::character varying
                WHEN 3 THEN ("sv"."val_numeric")::character varying
                WHEN 4 THEN ("sv"."val_real")::character varying
                WHEN 5 THEN ("sv"."val_double")::character varying
                WHEN 6 THEN (("sv"."val_money")::numeric)::character varying
                WHEN 7 THEN 'Текст'::character varying
                WHEN 8 THEN 'Изображение'::character varying
                WHEN 9 THEN ("sv"."val_boolean")::character varying
                WHEN 10 THEN ("sv"."val_date")::character varying
                WHEN 11 THEN ("sv"."val_time")::character varying
                WHEN 12 THEN ("sv"."val_interval")::character varying
                WHEN 13 THEN ("sv"."val_timestamp")::character varying
                WHEN 14 THEN 'Json'::character varying
                WHEN 15 THEN ("sv"."val_bigint")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 2 THEN
            CASE "cp"."id_data_type"
                WHEN 1 THEN "pev"."val_varchar"
                WHEN 3 THEN ("pev"."val_numeric")::character varying
                ELSE 'н/д'::character varying
            END
            WHEN 3 THEN 'Объект'::character varying
            WHEN 4 THEN 'Ссылка'::character varying
            ELSE 'н/д'::character varying
        END, 'н/д'::character varying) AS "string_val",
    ("lgp"."id_global_prop" IS NOT NULL) AS "on_global",
    COALESCE("lgp"."id_global_prop", (0)::bigint) AS "id_global_prop",
    "cp"."tag"
   FROM ((((((("bpd"."object" "o"
     LEFT JOIN "bpd"."class_prop_snapshot" "cp" ON ((("cp"."id_class" = "o"."id_class") AND ("cp"."timestamp_class" = "o"."timestamp_class"))))
     LEFT JOIN "bpd"."global_prop_link_class_prop" "lgp" ON (("lgp"."id_class_prop_definition" = "cp"."id_prop_definition")))
     LEFT JOIN "bpd"."object_prop_user_small_val" "sv" ON ((("sv"."id_class_prop" = "cp"."id") AND ("sv"."timestamp_class" = "cp"."timestamp_class") AND ("sv"."id_object" = "o"."id"))))
     LEFT JOIN "bpd"."object_prop_user_big_val" "bv" ON ((("bv"."id_class_prop" = "cp"."id") AND ("bv"."timestamp_class" = "cp"."timestamp_class") AND ("bv"."id_object" = "o"."id"))))
     LEFT JOIN "bpd"."object_prop_link_val" "lv" ON ((("lv"."id_class_prop" = "cp"."id") AND ("lv"."timestamp_class" = "cp"."timestamp_class") AND ("lv"."id_object" = "o"."id"))))
     LEFT JOIN "bpd"."object_prop_enum_val" "ev" ON ((("ev"."id_class_prop" = "cp"."id") AND ("ev"."timestamp_class" = "cp"."timestamp_class") AND ("ev"."id_object" = "o"."id"))))
     LEFT JOIN "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")));


--
-- TOC entry 557 (class 1259 OID 1208405)
-- Name: vschedule; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vschedule" AS
 SELECT "plan"."id",
    "plan"."id_conception",
    "plan"."name",
    "plan"."desc",
    "plan"."on",
    "plan"."timestamp",
    "plan"."on_freeze"
   FROM "bpd"."plan";


--
-- TOC entry 558 (class 1259 OID 1208409)
-- Name: vschedule_link; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vschedule_link" AS
 SELECT "plan_link"."id",
    "plan_link"."id_conception",
    "plan_link"."id_plan" AS "id_schedules",
    "plan_link"."id_entity",
    "plan_link"."id_entity_instance",
    "plan_link"."id_sub_entity_instance"
   FROM "bpd"."plan_link";


--
-- TOC entry 559 (class 1259 OID 1208493)
-- Name: vschedule_work_fact; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vschedule_work_fact" AS
 SELECT "plan_range_fact"."id",
    "plan_range_fact"."id_conception",
    "plan_range_fact"."id_plan" AS "id_schedule",
    "plan_range_fact"."id_plan_range" AS "id_work_time",
    "plan_range_fact"."id_range_plan" AS "id_work_plan",
    "plan_range_fact"."range_fact" AS "range_work",
    "plan_range_fact"."range_fact_type" AS "range_work_type",
    "plan_range_fact"."range_fact_state" AS "range_work_state",
    "plan_range_fact"."on",
    "plan_range_fact"."on_freeze",
    "plan_range_fact"."range_fact_upper" AS "range_work_upper",
    "plan_range_fact"."range_fact_lower" AS "range_work_lower",
    "plan_range_fact"."range_fact_upper_inc" AS "range_work_upper_inc",
    "plan_range_fact"."range_fact_lower_inc" AS "range_work_lower_inc",
    "plan_range_fact"."timestamp"
   FROM "bpd"."plan_range_fact";


--
-- TOC entry 560 (class 1259 OID 1208575)
-- Name: vschedule_work_plan; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vschedule_work_plan" AS
 SELECT "plan_range_plan"."id",
    "plan_range_plan"."id_conception",
    "plan_range_plan"."id_plan" AS "id_schedule",
    "plan_range_plan"."id_plan_range" AS "id_work_time",
    "plan_range_plan"."range_plan",
    "plan_range_plan"."range_plan_type",
    "plan_range_plan"."on",
    "plan_range_plan"."on_freeze",
    "plan_range_plan"."range_plan_upper",
    "plan_range_plan"."range_plan_lower",
    "plan_range_plan"."range_plan_upper_inc",
    "plan_range_plan"."range_plan_lower_inc",
    "plan_range_plan"."timestamp"
   FROM "bpd"."plan_range_plan";


--
-- TOC entry 561 (class 1259 OID 1208579)
-- Name: vschedule_work_time; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vschedule_work_time" AS
 SELECT "plan_range"."id",
    "plan_range"."id_conception",
    "plan_range"."id_plan" AS "id_schedule",
    "plan_range"."range_plan",
    "plan_range"."range_plan_type",
    "plan_range"."on",
    "plan_range"."on_freeze",
    "plan_range"."range_plan_upper",
    "plan_range"."range_plan_lower",
    "plan_range"."range_plan_upper_inc",
    "plan_range"."range_plan_lower_inc",
    "plan_range"."timestamp"
   FROM "bpd"."plan_range";


--
-- TOC entry 556 (class 1259 OID 1207702)
-- Name: vtransfer_day; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vtransfer_day" AS
 SELECT "plan_transfer_day"."day_date",
    "plan_transfer_day"."day_type",
    "plan_transfer_day"."desc"
   FROM "bpd"."plan_transfer_day";


--
-- TOC entry 593 (class 1259 OID 1349325)
-- Name: vuser_role_mapping; Type: VIEW; Schema: bpd; Owner: -
--

CREATE VIEW "bpd"."vuser_role_mapping" AS
 SELECT "m"."id_conception",
    "m"."oid_role",
    "r"."rolname"
   FROM ("bpd"."user_role_mapping" "m"
     JOIN "pg_roles" "r" ON (("r"."oid" = "m"."oid_role")));


--
-- TOC entry 539 (class 1259 OID 1158905)
-- Name: work_calendar_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_calendar_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6461 (class 0 OID 0)
-- Dependencies: 539
-- Name: work_calendar_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."work_calendar_id_seq" OWNED BY "bpd"."plan_calendar"."id";


--
-- TOC entry 535 (class 1259 OID 1158718)
-- Name: work_fact_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_fact_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6462 (class 0 OID 0)
-- Dependencies: 535
-- Name: work_fact_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."work_fact_id_seq" OWNED BY "bpd"."plan_range_fact"."id";


--
-- TOC entry 546 (class 1259 OID 1160790)
-- Name: work_fact_link_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_fact_link_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6463 (class 0 OID 0)
-- Dependencies: 546
-- Name: work_fact_link_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."work_fact_link_id_seq" OWNED BY "bpd"."plan_range_fact_link"."id";


--
-- TOC entry 544 (class 1259 OID 1160709)
-- Name: work_plan_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_plan_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6464 (class 0 OID 0)
-- Dependencies: 544
-- Name: work_plan_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."work_plan_id_seq" OWNED BY "bpd"."plan_range_plan"."id";


--
-- TOC entry 548 (class 1259 OID 1160801)
-- Name: work_plan_link_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_plan_link_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6465 (class 0 OID 0)
-- Dependencies: 548
-- Name: work_plan_link_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."work_plan_link_id_seq" OWNED BY "bpd"."plan_range_plan_link"."id";


--
-- TOC entry 550 (class 1259 OID 1160812)
-- Name: work_time_link_id_seq; Type: SEQUENCE; Schema: bpd; Owner: -
--

CREATE SEQUENCE "bpd"."work_time_link_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 6466 (class 0 OID 0)
-- Dependencies: 550
-- Name: work_time_link_id_seq; Type: SEQUENCE OWNED BY; Schema: bpd; Owner: -
--

ALTER SEQUENCE "bpd"."work_time_link_id_seq" OWNED BY "bpd"."plan_range_link"."id";


--
-- TOC entry 5272 (class 2604 OID 17261)
-- Name: class id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."class_id_seq"'::"regclass");


--
-- TOC entry 5333 (class 2604 OID 17262)
-- Name: class_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."class_prop_id_seq"'::"regclass");


--
-- TOC entry 5401 (class 2604 OID 703465)
-- Name: class_prop_link_val_snapshot id_sub_entity_instance; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val_snapshot" ALTER COLUMN "id_sub_entity_instance" SET DEFAULT '-1'::integer;


--
-- TOC entry 5368 (class 2604 OID 17263)
-- Name: class_prop_obj_val_class id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."class_prop_obj_val_class_id_seq"'::"regclass");


--
-- TOC entry 5375 (class 2604 OID 16851)
-- Name: class_prop_obj_val_class_snapshot id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."class_prop_obj_val_class_id_seq"'::"regclass");


--
-- TOC entry 5376 (class 2604 OID 16852)
-- Name: class_prop_obj_val_class_snapshot bquantity_max; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "bquantity_max" SET DEFAULT '-1'::integer;


--
-- TOC entry 5377 (class 2604 OID 16853)
-- Name: class_prop_obj_val_class_snapshot bquantity_min; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "bquantity_min" SET DEFAULT '-1'::integer;


--
-- TOC entry 5378 (class 2604 OID 735216)
-- Name: class_prop_obj_val_class_snapshot embed_mode; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "embed_mode" SET DEFAULT 0;


--
-- TOC entry 5379 (class 2604 OID 735218)
-- Name: class_prop_obj_val_class_snapshot embed_single; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "embed_single" SET DEFAULT true;


--
-- TOC entry 5380 (class 2604 OID 735220)
-- Name: class_prop_obj_val_class_snapshot embed_class_real_id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "embed_class_real_id" SET DEFAULT '-1'::integer;


--
-- TOC entry 5381 (class 2604 OID 738799)
-- Name: class_prop_obj_val_class_snapshot id_unit_conversion_rule; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot" ALTER COLUMN "id_unit_conversion_rule" SET DEFAULT '-1'::integer;


--
-- TOC entry 5356 (class 2604 OID 16799)
-- Name: class_prop_snapshot id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."class_prop_id_seq"'::"regclass");


--
-- TOC entry 5357 (class 2604 OID 16800)
-- Name: class_prop_snapshot id_prop_inherit; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "id_prop_inherit" SET DEFAULT '-1'::integer;


--
-- TOC entry 5358 (class 2604 OID 16801)
-- Name: class_prop_snapshot id_class; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "id_class" SET DEFAULT 0;


--
-- TOC entry 5359 (class 2604 OID 16802)
-- Name: class_prop_snapshot sort; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "sort" SET DEFAULT 0;


--
-- TOC entry 5360 (class 2604 OID 16803)
-- Name: class_prop_snapshot id_prop_definition; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "id_prop_definition" SET DEFAULT '-1'::integer;


--
-- TOC entry 5361 (class 2604 OID 16804)
-- Name: class_prop_snapshot id_class_definition; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "id_class_definition" SET DEFAULT '-1'::integer;


--
-- TOC entry 5362 (class 2604 OID 1082525)
-- Name: class_prop_snapshot tag; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot" ALTER COLUMN "tag" SET DEFAULT ''::character varying;


--
-- TOC entry 5352 (class 2604 OID 16854)
-- Name: class_prop_user_big_val_snapshot max_val; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val_snapshot" ALTER COLUMN "max_val" SET DEFAULT 500;


--
-- TOC entry 5353 (class 2604 OID 16855)
-- Name: class_prop_user_big_val_snapshot min_val; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val_snapshot" ALTER COLUMN "min_val" SET DEFAULT 1;


--
-- TOC entry 5354 (class 2604 OID 16856)
-- Name: class_prop_user_big_val_snapshot max_on; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val_snapshot" ALTER COLUMN "max_on" SET DEFAULT false;


--
-- TOC entry 5355 (class 2604 OID 16857)
-- Name: class_prop_user_big_val_snapshot min_on; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val_snapshot" ALTER COLUMN "min_on" SET DEFAULT false;


--
-- TOC entry 5344 (class 2604 OID 16858)
-- Name: class_prop_user_small_val_snapshot min_val; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val_snapshot" ALTER COLUMN "min_val" SET DEFAULT 0;


--
-- TOC entry 5345 (class 2604 OID 16859)
-- Name: class_prop_user_small_val_snapshot max_on; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val_snapshot" ALTER COLUMN "max_on" SET DEFAULT false;


--
-- TOC entry 5346 (class 2604 OID 16860)
-- Name: class_prop_user_small_val_snapshot min_on; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val_snapshot" ALTER COLUMN "min_on" SET DEFAULT false;


--
-- TOC entry 5347 (class 2604 OID 16861)
-- Name: class_prop_user_small_val_snapshot round_on; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val_snapshot" ALTER COLUMN "round_on" SET DEFAULT false;


--
-- TOC entry 5316 (class 2604 OID 16805)
-- Name: class_snapshot id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."class_id_seq"'::"regclass");


--
-- TOC entry 5317 (class 2604 OID 16806)
-- Name: class_snapshot desc; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "desc" SET DEFAULT 'н/д'::"text";


--
-- TOC entry 5318 (class 2604 OID 16807)
-- Name: class_snapshot on_extensible; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "on_extensible" SET DEFAULT true;


--
-- TOC entry 5319 (class 2604 OID 16808)
-- Name: class_snapshot on_abstraction; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "on_abstraction" SET DEFAULT true;


--
-- TOC entry 5320 (class 2604 OID 16810)
-- Name: class_snapshot barcode_manufacturer; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "barcode_manufacturer" SET DEFAULT 0;


--
-- TOC entry 5321 (class 2604 OID 16811)
-- Name: class_snapshot barcode_local; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "barcode_local" SET DEFAULT 0;


--
-- TOC entry 5322 (class 2604 OID 16812)
-- Name: class_snapshot timestamp; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "timestamp" SET DEFAULT LOCALTIMESTAMP;


--
-- TOC entry 5323 (class 2604 OID 16813)
-- Name: class_snapshot on_freeze; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "on_freeze" SET DEFAULT false;


--
-- TOC entry 5324 (class 2604 OID 16814)
-- Name: class_snapshot id_group_root; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "id_group_root" SET DEFAULT 0;


--
-- TOC entry 5325 (class 2604 OID 16815)
-- Name: class_snapshot timestamp_parent; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "timestamp_parent" SET DEFAULT LOCALTIMESTAMP(3);


--
-- TOC entry 5326 (class 2604 OID 16816)
-- Name: class_snapshot id_unit; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "id_unit" SET DEFAULT '-1'::integer;


--
-- TOC entry 5327 (class 2604 OID 16817)
-- Name: class_snapshot timestamp_child_change; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "timestamp_child_change" SET DEFAULT LOCALTIMESTAMP(3);


--
-- TOC entry 5328 (class 2604 OID 16818)
-- Name: class_snapshot name_format; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "name_format" SET DEFAULT 'none'::character varying;


--
-- TOC entry 5329 (class 2604 OID 16819)
-- Name: class_snapshot quantity_show; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "quantity_show" SET DEFAULT true;


--
-- TOC entry 5330 (class 2604 OID 1143807)
-- Name: class_snapshot path_array; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot" ALTER COLUMN "path_array" SET DEFAULT ARRAY[0];


--
-- TOC entry 5205 (class 2604 OID 17264)
-- Name: conception id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."conception" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."conception_id_seq"'::"regclass");


--
-- TOC entry 5434 (class 2604 OID 1031478)
-- Name: doc_file id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_file" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."doc_file_id_seq"'::"regclass");


--
-- TOC entry 5428 (class 2604 OID 793616)
-- Name: doc_link id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_link" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."doc_links_id_seq"'::"regclass");


--
-- TOC entry 5431 (class 2604 OID 799900)
-- Name: document id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."document" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."document_id_seq"'::"regclass");


--
-- TOC entry 5423 (class 2604 OID 637734)
-- Name: global_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."global_prop_id_seq"'::"regclass");


--
-- TOC entry 5265 (class 2604 OID 17265)
-- Name: group id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."group" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."group_id_seq"'::"regclass");


--
-- TOC entry 5237 (class 2604 OID 17266)
-- Name: link_pos_obj id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_pos_obj" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."link_pos_obj_id_seq"'::"regclass");


--
-- TOC entry 5256 (class 2604 OID 17267)
-- Name: message id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."message" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."message_id_seq"'::"regclass");


--
-- TOC entry 5262 (class 2604 OID 17268)
-- Name: message_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."message_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."message_prop_id_seq"'::"regclass");


--
-- TOC entry 5436 (class 2604 OID 1158694)
-- Name: plan id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."plan_id_seq"'::"regclass");


--
-- TOC entry 5457 (class 2604 OID 1158910)
-- Name: plan_calendar id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_calendar" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."work_calendar_id_seq"'::"regclass");


--
-- TOC entry 5454 (class 2604 OID 1158737)
-- Name: plan_interval id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_interval" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."plan_intervals_id_seq"'::"regclass");


--
-- TOC entry 5469 (class 2604 OID 1159699)
-- Name: plan_link id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_link" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."plan_link_id_seq"'::"regclass");


--
-- TOC entry 5447 (class 2604 OID 1161443)
-- Name: plan_range_fact id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."work_fact_id_seq"'::"regclass");


--
-- TOC entry 5478 (class 2604 OID 1160795)
-- Name: plan_range_fact_link id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact_link" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."work_fact_link_id_seq"'::"regclass");


--
-- TOC entry 5482 (class 2604 OID 1160817)
-- Name: plan_range_link id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_link" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."work_time_link_id_seq"'::"regclass");


--
-- TOC entry 5471 (class 2604 OID 1161445)
-- Name: plan_range_plan id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."work_plan_id_seq"'::"regclass");


--
-- TOC entry 5480 (class 2604 OID 1160806)
-- Name: plan_range_plan_link id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan_link" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."work_plan_link_id_seq"'::"regclass");


--
-- TOC entry 5226 (class 2604 OID 17269)
-- Name: pos_temp id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."pos_temp_id_seq"'::"regclass");


--
-- TOC entry 5403 (class 2604 OID 611716)
-- Name: pos_temp_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."pos_temp_prop_id_seq"'::"regclass");


--
-- TOC entry 5408 (class 2604 OID 611852)
-- Name: pos_temp_prop_obj_val id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_obj_val" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."pos_temp_prop_obj_val_id_seq"'::"regclass");


--
-- TOC entry 5213 (class 2604 OID 17271)
-- Name: position id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."position_id_seq"'::"regclass");


--
-- TOC entry 5395 (class 2604 OID 17272)
-- Name: prop_enum id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."enum_prop_id_seq"'::"regclass");


--
-- TOC entry 5396 (class 2604 OID 17273)
-- Name: prop_enum_val id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum_val" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."enum_prop_val_id_seq"'::"regclass");


--
-- TOC entry 5490 (class 2604 OID 1359307)
-- Name: role_user id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."role_user" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."user_role_id_seq"'::"regclass");


--
-- TOC entry 5494 (class 2604 OID 1385226)
-- Name: sec_table_access id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."sec_table_access" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."sec_table_access_id_seq"'::"regclass");


--
-- TOC entry 5255 (class 2604 OID 17274)
-- Name: ticket id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."ticket_id_seq"'::"regclass");


--
-- TOC entry 5259 (class 2604 OID 17275)
-- Name: ticket_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."ticket_prop_id_seq"'::"regclass");


--
-- TOC entry 5247 (class 2604 OID 17276)
-- Name: user_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."user_prop_id_seq"'::"regclass");


--
-- TOC entry 5251 (class 2604 OID 17277)
-- Name: user_temp_prop id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_temp_prop" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."user_temp_prop_id_seq"'::"regclass");


--
-- TOC entry 5232 (class 2604 OID 17278)
-- Name: vector id; Type: DEFAULT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."vector" ALTER COLUMN "id" SET DEFAULT "nextval"('"bpd"."vector_id_seq"'::"regclass");


--
-- TOC entry 5782 (class 2606 OID 1467236)
-- Name: cfg_action cfg_action_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_action"
    ADD CONSTRAINT "cfg_action_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5555 (class 2606 OID 17313)
-- Name: cfg_base_id cfg_base_id_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_base_id"
    ADD CONSTRAINT "cfg_base_id_pkey" PRIMARY KEY ("baseid");


--
-- TOC entry 5553 (class 2606 OID 17314)
-- Name: cfg_err_id cfg_err_id_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_err_id"
    ADD CONSTRAINT "cfg_err_id_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5634 (class 2606 OID 17315)
-- Name: cfg_map_proname_entity cfg_map_proname_entity_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_map_proname_entity"
    ADD CONSTRAINT "cfg_map_proname_entity_pkey" PRIMARY KEY ("id_entity", "proname");


--
-- TOC entry 5533 (class 2606 OID 939188)
-- Name: cfg_procnamespace cfg_procnamespace_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_procnamespace"
    ADD CONSTRAINT "cfg_procnamespace_pkey" PRIMARY KEY ("name");


--
-- TOC entry 5801 (class 2606 OID 17316)
-- Name: cfg_prop_spec_limit2 cfg_prop_spec_limit2_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_prop_spec_limit2"
    ADD CONSTRAINT "cfg_prop_spec_limit2_pkey" PRIMARY KEY ("id_prop_data_type");


--
-- TOC entry 5638 (class 2606 OID 17317)
-- Name: class_snapshot class_history_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot"
    ADD CONSTRAINT "class_history_pkey" PRIMARY KEY ("id", "timestamp");


--
-- TOC entry 5578 (class 2606 OID 17318)
-- Name: class class_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class"
    ADD CONSTRAINT "class_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5713 (class 2606 OID 17319)
-- Name: class_prop_user_big_val class_prop_big_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val"
    ADD CONSTRAINT "class_prop_big_val_pkey" PRIMARY KEY ("id_class_prop");


--
-- TOC entry 5717 (class 2606 OID 17320)
-- Name: class_prop_user_big_val_snapshot class_prop_big_val_snapshot_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val_snapshot"
    ADD CONSTRAINT "class_prop_big_val_snapshot_pkey" PRIMARY KEY ("id_class_prop", "timestamp_class");


--
-- TOC entry 5815 (class 2606 OID 17321)
-- Name: class_prop_enum_val class_prop_enum_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val"
    ADD CONSTRAINT "class_prop_enum_val_pkey" PRIMARY KEY ("id_class_prop");


--
-- TOC entry 5821 (class 2606 OID 17322)
-- Name: class_prop_enum_val_snapshot class_prop_enum_val_snapshot_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val_snapshot"
    ADD CONSTRAINT "class_prop_enum_val_snapshot_pkey" PRIMARY KEY ("id_class_prop", "timestamp_class");


--
-- TOC entry 5836 (class 2606 OID 17323)
-- Name: class_prop_link_val class_prop_link_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val"
    ADD CONSTRAINT "class_prop_link_val_pkey" PRIMARY KEY ("id_class_prop");


--
-- TOC entry 5858 (class 2606 OID 17324)
-- Name: class_prop_link_val_snapshot class_prop_link_val_snapshot_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val_snapshot"
    ADD CONSTRAINT "class_prop_link_val_snapshot_pkey" PRIMARY KEY ("id_class_prop", "timestamp_class");


--
-- TOC entry 5769 (class 2606 OID 17325)
-- Name: class_prop_obj_val_class class_prop_obj_val_class_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class"
    ADD CONSTRAINT "class_prop_obj_val_class_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5776 (class 2606 OID 17326)
-- Name: class_prop_obj_val_class_snapshot class_prop_obj_val_class_snapshot_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot"
    ADD CONSTRAINT "class_prop_obj_val_class_snapshot_pkey" PRIMARY KEY ("id", "timestamp_class");


--
-- TOC entry 5652 (class 2606 OID 17327)
-- Name: class_prop class_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "class_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5684 (class 2606 OID 17328)
-- Name: class_prop_user_small_val class_prop_small_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val"
    ADD CONSTRAINT "class_prop_small_val_pkey" PRIMARY KEY ("id_class_prop");


--
-- TOC entry 5700 (class 2606 OID 17329)
-- Name: class_prop_user_small_val_snapshot class_prop_small_val_snapshot_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val_snapshot"
    ADD CONSTRAINT "class_prop_small_val_snapshot_pkey" PRIMARY KEY ("id_class_prop", "timestamp_class");


--
-- TOC entry 5743 (class 2606 OID 17330)
-- Name: class_prop_snapshot class_prop_snapshot_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot"
    ADD CONSTRAINT "class_prop_snapshot_pkey" PRIMARY KEY ("id", "timestamp_class");


--
-- TOC entry 5765 (class 2606 OID 17331)
-- Name: class_real_uc_rules_list class_real_uc_rules_list_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_real_uc_rules_list"
    ADD CONSTRAINT "class_real_uc_rules_list_pkey" PRIMARY KEY ("id_class", "id_unit_conversion_rules");


--
-- TOC entry 5763 (class 2606 OID 17332)
-- Name: class_unit_conversion_rules class_unit_conversion_rules_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_unit_conversion_rules"
    ADD CONSTRAINT "class_unit_conversion_rules_pkey" PRIMARY KEY ("id_class", "id_unit_conversion_rule");


--
-- TOC entry 5496 (class 2606 OID 17333)
-- Name: conception conception_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."conception"
    ADD CONSTRAINT "conception_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5932 (class 2606 OID 854394)
-- Name: doc_category doc_category_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_category"
    ADD CONSTRAINT "doc_category_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5940 (class 2606 OID 1031503)
-- Name: doc_file doc_file_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_file"
    ADD CONSTRAINT "doc_file_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5925 (class 2606 OID 793619)
-- Name: doc_link doc_links_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_link"
    ADD CONSTRAINT "doc_links_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5537 (class 2606 OID 17334)
-- Name: doc_setings doc_setings_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_setings"
    ADD CONSTRAINT "doc_setings_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5935 (class 2606 OID 799905)
-- Name: document document_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."document"
    ADD CONSTRAINT "document_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5535 (class 2606 OID 17335)
-- Name: entity entities_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."entity"
    ADD CONSTRAINT "entities_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5804 (class 2606 OID 17336)
-- Name: prop_enum enum_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum"
    ADD CONSTRAINT "enum_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5949 (class 2606 OID 1450432)
-- Name: plan_range exclude_plan_range_overlap; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range"
    ADD CONSTRAINT "exclude_plan_range_overlap" EXCLUDE USING "gist" ("id_plan" WITH =, "range_plan" WITH &&);


--
-- TOC entry 5795 (class 2606 OID 17338)
-- Name: filelib_cfg filelib_cfg_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."filelib_cfg"
    ADD CONSTRAINT "filelib_cfg_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5916 (class 2606 OID 637744)
-- Name: global_prop_link_class_prop global_prop_link_class_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop_link_class_prop"
    ADD CONSTRAINT "global_prop_link_class_prop_pkey" PRIMARY KEY ("id_global_prop", "id_class", "id_class_prop_definition");


--
-- TOC entry 5921 (class 2606 OID 637749)
-- Name: global_prop_link_pos_temp_prop global_prop_link_pos_temp_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop_link_pos_temp_prop"
    ADD CONSTRAINT "global_prop_link_pos_temp_prop_pkey" PRIMARY KEY ("id_global_prop", "id_pos_temp", "id_pos_temp_prop");


--
-- TOC entry 5912 (class 2606 OID 637739)
-- Name: global_prop global_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop"
    ADD CONSTRAINT "global_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5569 (class 2606 OID 17339)
-- Name: group group_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."group"
    ADD CONSTRAINT "group_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5531 (class 2606 OID 17340)
-- Name: link_pos_obj link_pos_obj_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_pos_obj"
    ADD CONSTRAINT "link_pos_obj_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5624 (class 2606 OID 17341)
-- Name: link_type link_type_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_type"
    ADD CONSTRAINT "link_type_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5636 (class 2606 OID 17342)
-- Name: map_class_pos_root map_class_pos_root_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."map_class_pos_root"
    ADD CONSTRAINT "map_class_pos_root_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5561 (class 2606 OID 17343)
-- Name: message message_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."message"
    ADD CONSTRAINT "message_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5565 (class 2606 OID 17344)
-- Name: message_prop message_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."message_prop"
    ADD CONSTRAINT "message_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5598 (class 2606 OID 17345)
-- Name: obj_representation obj_representation_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."obj_representation"
    ADD CONSTRAINT "obj_representation_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5677 (class 2606 OID 17346)
-- Name: object_accounting object_accounting_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_accounting"
    ADD CONSTRAINT "object_accounting_pkey" PRIMARY KEY ("id_object");


--
-- TOC entry 5679 (class 2606 OID 17347)
-- Name: object_commercial object_commercial_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_commercial"
    ADD CONSTRAINT "object_commercial_pkey" PRIMARY KEY ("id_object");


--
-- TOC entry 5620 (class 2606 OID 17348)
-- Name: object object_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object"
    ADD CONSTRAINT "object_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5741 (class 2606 OID 1166227)
-- Name: object_prop_user_big_val object_prop_big_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_user_big_val"
    ADD CONSTRAINT "object_prop_big_val_pkey" PRIMARY KEY ("id_object", "id_class_prop", "timestamp_class");


--
-- TOC entry 5923 (class 2606 OID 735565)
-- Name: object_prop_create_emded_mode object_prop_create_emded_mode_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_create_emded_mode"
    ADD CONSTRAINT "object_prop_create_emded_mode_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5832 (class 2606 OID 1166223)
-- Name: object_prop_enum_val object_prop_enum_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_enum_val"
    ADD CONSTRAINT "object_prop_enum_val_pkey" PRIMARY KEY ("id_object", "id_class_prop", "timestamp_class");


--
-- TOC entry 5856 (class 2606 OID 1166225)
-- Name: object_prop_link_val object_prop_link_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_link_val"
    ADD CONSTRAINT "object_prop_link_val_pkey" PRIMARY KEY ("id_object", "id_class_prop", "timestamp_class");


--
-- TOC entry 5735 (class 2606 OID 1166229)
-- Name: object_prop_user_small_val object_prop_small_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_user_small_val"
    ADD CONSTRAINT "object_prop_small_val_pkey" PRIMARY KEY ("id_object", "id_class_prop", "timestamp_class");


--
-- TOC entry 5682 (class 2606 OID 17353)
-- Name: object_technical object_technical_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_technical"
    ADD CONSTRAINT "object_technical_pkey" PRIMARY KEY ("id_object");


--
-- TOC entry 5865 (class 2606 OID 17354)
-- Name: pattern_string pattern_string_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pattern_string"
    ADD CONSTRAINT "pattern_string_pkey" PRIMARY KEY ("pattern");


--
-- TOC entry 5964 (class 2606 OID 1158916)
-- Name: plan_calendar plan_calendar_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_calendar"
    ADD CONSTRAINT "plan_calendar_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5989 (class 2606 OID 1166884)
-- Name: plan_holiday plan_holiday_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_holiday"
    ADD CONSTRAINT "plan_holiday_pkey" PRIMARY KEY ("holiday_date");


--
-- TOC entry 5957 (class 2606 OID 1158742)
-- Name: plan_interval plan_interval_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_interval"
    ADD CONSTRAINT "plan_interval_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5968 (class 2606 OID 1159702)
-- Name: plan_link plan_link_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_link"
    ADD CONSTRAINT "plan_link_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5947 (class 2606 OID 1158703)
-- Name: plan plan_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan"
    ADD CONSTRAINT "plan_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5976 (class 2606 OID 1160798)
-- Name: plan_range_fact_link plan_range_fact_link_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact_link"
    ADD CONSTRAINT "plan_range_fact_link_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5955 (class 2606 OID 1158731)
-- Name: plan_range_fact plan_range_fact_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact"
    ADD CONSTRAINT "plan_range_fact_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5984 (class 2606 OID 1160820)
-- Name: plan_range_link plan_range_link_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_link"
    ADD CONSTRAINT "plan_range_link_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5951 (class 2606 OID 1158717)
-- Name: plan_range plan_range_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range"
    ADD CONSTRAINT "plan_range_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5980 (class 2606 OID 1160809)
-- Name: plan_range_plan_link plan_range_plan_link_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan_link"
    ADD CONSTRAINT "plan_range_plan_link_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5974 (class 2606 OID 1160723)
-- Name: plan_range_plan plan_range_plan_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan"
    ADD CONSTRAINT "plan_range_plan_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5991 (class 2606 OID 1203357)
-- Name: plan_transfer_day plan_transfer_day_off_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_transfer_day"
    ADD CONSTRAINT "plan_transfer_day_off_pkey" PRIMARY KEY ("day_date");


--
-- TOC entry 5900 (class 2606 OID 611859)
-- Name: pos_temp_prop_obj_val poa_temp_prop_obj_val_class_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_obj_val"
    ADD CONSTRAINT "poa_temp_prop_obj_val_class_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5527 (class 2606 OID 17355)
-- Name: pos_prototype pos_prototype_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_prototype"
    ADD CONSTRAINT "pos_prototype_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5539 (class 2606 OID 17356)
-- Name: pos_temp_nested_limit pos_temp_nested_limit_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_nested_limit"
    ADD CONSTRAINT "pos_temp_nested_limit_pkey" PRIMARY KEY ("id_pos_temp", "id_pos_temp_nested");


--
-- TOC entry 5518 (class 2606 OID 17357)
-- Name: pos_temp pos_temp_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp"
    ADD CONSTRAINT "pos_temp_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5889 (class 2606 OID 611837)
-- Name: pos_temp_prop_enum_val pos_temp_prop_enum_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_enum_val"
    ADD CONSTRAINT "pos_temp_prop_enum_val_pkey" PRIMARY KEY ("id_pos_temp_prop");


--
-- TOC entry 5895 (class 2606 OID 611844)
-- Name: pos_temp_prop_link_val pos_temp_prop_link_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_link_val"
    ADD CONSTRAINT "pos_temp_prop_link_val_pkey" PRIMARY KEY ("id_pos_temp_prop");


--
-- TOC entry 5873 (class 2606 OID 611722)
-- Name: pos_temp_prop pos_temp_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop"
    ADD CONSTRAINT "pos_temp_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5904 (class 2606 OID 611873)
-- Name: pos_temp_prop_user_big_val pos_temp_prop_user_big_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_user_big_val"
    ADD CONSTRAINT "pos_temp_prop_user_big_val_pkey" PRIMARY KEY ("id_pos_temp_prop");


--
-- TOC entry 5908 (class 2606 OID 611893)
-- Name: pos_temp_prop_user_small_val pos_temp_prop_user_small_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_user_small_val"
    ADD CONSTRAINT "pos_temp_prop_user_small_val_pkey" PRIMARY KEY ("id_pos_temp_prop");


--
-- TOC entry 5512 (class 2606 OID 17359)
-- Name: position position_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position"
    ADD CONSTRAINT "position_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5879 (class 2606 OID 611731)
-- Name: position_prop_enum_val position_prop_enum_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_enum_val"
    ADD CONSTRAINT "position_prop_enum_val_pkey" PRIMARY KEY ("id_position", "id_pos_temp_prop");


--
-- TOC entry 5883 (class 2606 OID 611741)
-- Name: position_prop_link_val position_prop_link_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_link_val"
    ADD CONSTRAINT "position_prop_link_val_pkey" PRIMARY KEY ("id_position", "id_pos_temp_prop");


--
-- TOC entry 5885 (class 2606 OID 611749)
-- Name: position_prop_user_big_val position_prop_user_big_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_user_big_val"
    ADD CONSTRAINT "position_prop_user_big_val_pkey" PRIMARY KEY ("id_position", "id_pos_temp_prop");


--
-- TOC entry 5887 (class 2606 OID 611757)
-- Name: position_prop_user_small_val position_prop_user_small_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_user_small_val"
    ADD CONSTRAINT "position_prop_user_small_val_pkey" PRIMARY KEY ("id_position", "id_pos_temp_prop");


--
-- TOC entry 6009 (class 2606 OID 1429168)
-- Name: prm_grant_external_func prm_grant_external_func_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prm_grant_external_func"
    ADD CONSTRAINT "prm_grant_external_func_pkey" PRIMARY KEY ("proname");


--
-- TOC entry 5551 (class 2606 OID 17360)
-- Name: prop_data_bin_ext prop_data_bin_ext_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_data_bin_ext"
    ADD CONSTRAINT "prop_data_bin_ext_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5799 (class 2606 OID 17361)
-- Name: prop_data_type_con_map prop_data_type_con_map_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_data_type_con_map"
    ADD CONSTRAINT "prop_data_type_con_map_pkey" PRIMARY KEY ("id_conception", "id_prop_data_type");


--
-- TOC entry 5514 (class 2606 OID 17362)
-- Name: prop_data_type prop_data_type_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_data_type"
    ADD CONSTRAINT "prop_data_type_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5834 (class 2606 OID 17363)
-- Name: prop_enum_use_area prop_enum_use_area_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum_use_area"
    ADD CONSTRAINT "prop_enum_use_area_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5813 (class 2606 OID 1287058)
-- Name: prop_enum_val prop_enum_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum_val"
    ADD CONSTRAINT "prop_enum_val_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5761 (class 2606 OID 17364)
-- Name: prop_type prop_type_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_type"
    ADD CONSTRAINT "prop_type_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5557 (class 2606 OID 17365)
-- Name: cfg_prototype_desc prototype_desc_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_prototype_desc"
    ADD CONSTRAINT "prototype_desc_pkey" PRIMARY KEY ("prop", "val");


--
-- TOC entry 6005 (class 2606 OID 1377272)
-- Name: rulel1_class_on_pos_temp rulel1_class_on_pos_temp_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel1_class_on_pos_temp"
    ADD CONSTRAINT "rulel1_class_on_pos_temp_pkey" PRIMARY KEY ("id_pos_temp", "id_class");


--
-- TOC entry 5786 (class 2606 OID 17366)
-- Name: rulel1_group_on_pos_temp rulel1_group_on_pos_temp_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel1_group_on_pos_temp"
    ADD CONSTRAINT "rulel1_group_on_pos_temp_pkey" PRIMARY KEY ("id_pos_temp", "id_group");


--
-- TOC entry 5788 (class 2606 OID 17367)
-- Name: rulel2_class_on_position rulel2_class_on_position_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel2_class_on_position"
    ADD CONSTRAINT "rulel2_class_on_position_pkey" PRIMARY KEY ("id_position", "id_class");


--
-- TOC entry 5793 (class 2606 OID 17368)
-- Name: rulel2_class_snapshot_on_position rulel2_class_snapshot_on_position_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel2_class_snapshot_on_position"
    ADD CONSTRAINT "rulel2_class_snapshot_on_position_pkey" PRIMARY KEY ("id_position", "id_class", "timestamp_class");


--
-- TOC entry 6007 (class 2606 OID 1385228)
-- Name: sec_table_access sec_table_access_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."sec_table_access"
    ADD CONSTRAINT "sec_table_access_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5559 (class 2606 OID 17369)
-- Name: ticket ticket_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket"
    ADD CONSTRAINT "ticket_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5563 (class 2606 OID 17370)
-- Name: ticket_prop ticket_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket_prop"
    ADD CONSTRAINT "ticket_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5567 (class 2606 OID 17371)
-- Name: ticket_state ticket_state_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket_state"
    ADD CONSTRAINT "ticket_state_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5906 (class 2606 OID 611875)
-- Name: pos_temp_prop_user_big_val unique_big_id_pos_temp_id_pos_temp_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_user_big_val"
    ADD CONSTRAINT "unique_big_id_pos_temp_id_pos_temp_prop" UNIQUE ("id_pos_temp", "id_pos_temp_prop");


--
-- TOC entry 5671 (class 2606 OID 17373)
-- Name: class_prop unique_class_prop_name; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "unique_class_prop_name" UNIQUE ("id_class", "name");


--
-- TOC entry 5780 (class 2606 OID 1450352)
-- Name: class_prop_obj_val_class_snapshot unique_class_prop_obj_val_class_val_snapshot; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot"
    ADD CONSTRAINT "unique_class_prop_obj_val_class_val_snapshot" UNIQUE ("id_class", "id_class_prop", "timestamp_class");


--
-- TOC entry 5757 (class 2606 OID 17375)
-- Name: class_prop_snapshot unique_class_prop_ts_name; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot"
    ADD CONSTRAINT "unique_class_prop_ts_name" UNIQUE ("id_class", "name", "timestamp_class");


--
-- TOC entry 5502 (class 2606 OID 17376)
-- Name: conception unique_con_name; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."conception"
    ADD CONSTRAINT "unique_con_name" UNIQUE ("name");


--
-- TOC entry 5945 (class 2606 OID 1041005)
-- Name: doc_file unique_doc_file_md5; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_file"
    ADD CONSTRAINT "unique_doc_file_md5" UNIQUE ("id_document", "md5");


--
-- TOC entry 5930 (class 2606 OID 938959)
-- Name: doc_link unique_document_link; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_link"
    ADD CONSTRAINT "unique_document_link" UNIQUE ("id_document", "id_entity", "id_entity_instance", "id_sub_entity_instance");


--
-- TOC entry 5819 (class 2606 OID 17377)
-- Name: class_prop_enum_val unique_enum_id_class_id_class_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val"
    ADD CONSTRAINT "unique_enum_id_class_id_class_prop" UNIQUE ("id_class", "id_class_prop");


--
-- TOC entry 5891 (class 2606 OID 611839)
-- Name: pos_temp_prop_enum_val unique_enum_id_pos_temp_id_pos_temp_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_enum_val"
    ADD CONSTRAINT "unique_enum_id_pos_temp_id_pos_temp_prop" UNIQUE ("id_pos_temp", "id_pos_temp_prop");


--
-- TOC entry 5825 (class 2606 OID 17378)
-- Name: class_prop_enum_val_snapshot unique_enum_ts_id_class_id_class_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val_snapshot"
    ADD CONSTRAINT "unique_enum_ts_id_class_id_class_prop" UNIQUE ("id_class", "id_class_prop", "timestamp_class");


--
-- TOC entry 5774 (class 2606 OID 17379)
-- Name: class_prop_obj_val_class unique_id_class_id_class_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class"
    ADD CONSTRAINT "unique_id_class_id_class_prop" UNIQUE ("id_class", "id_class_prop");


--
-- TOC entry 5673 (class 2606 OID 17380)
-- Name: class_prop unique_id_class_id_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "unique_id_class_id_prop" UNIQUE ("id", "id_class");


--
-- TOC entry 5675 (class 2606 OID 1150002)
-- Name: class_prop unique_id_class_id_prop_definition; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "unique_id_class_id_prop_definition" UNIQUE ("id", "id_prop_definition");


--
-- TOC entry 5759 (class 2606 OID 17381)
-- Name: class_prop_snapshot unique_id_class_ts_class_id_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot"
    ADD CONSTRAINT "unique_id_class_ts_class_id_prop" UNIQUE ("id", "id_class", "timestamp_class");


--
-- TOC entry 5622 (class 2606 OID 17382)
-- Name: object unique_id_object_id_object_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object"
    ADD CONSTRAINT "unique_id_object_id_object_prop" UNIQUE ("id", "id_class_prop_object_carrier");


--
-- TOC entry 5970 (class 2606 OID 1450430)
-- Name: plan_link unique_id_plan_link; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_link"
    ADD CONSTRAINT "unique_id_plan_link" UNIQUE ("id_plan", "id_entity", "id_entity_instance", "id_sub_entity_instance");


--
-- TOC entry 5986 (class 2606 OID 1160822)
-- Name: plan_range_link unique_id_plan_range_link_link; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_link"
    ADD CONSTRAINT "unique_id_plan_range_link_link" UNIQUE ("id_plan_range", "id_entity", "id_entity_instance", "id_sub_entity_instance");


--
-- TOC entry 5982 (class 2606 OID 1450439)
-- Name: plan_range_plan_link unique_id_plan_range_plan_link; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan_link"
    ADD CONSTRAINT "unique_id_plan_range_plan_link" UNIQUE ("id_plan_range_plan", "id_entity", "id_entity_instance", "id_sub_entity_instance");


--
-- TOC entry 5875 (class 2606 OID 611726)
-- Name: pos_temp_prop unique_id_pos_temp_id_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop"
    ADD CONSTRAINT "unique_id_pos_temp_id_prop" UNIQUE ("id", "id_pos_temp");


--
-- TOC entry 5843 (class 2606 OID 17383)
-- Name: class_prop_link_val unique_link_id_class_id_class_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val"
    ADD CONSTRAINT "unique_link_id_class_id_class_prop" UNIQUE ("id_class", "id_class_prop");


--
-- TOC entry 5897 (class 2606 OID 611846)
-- Name: pos_temp_prop_link_val unique_link_id_pos_temp_id_pos_temp_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_link_val"
    ADD CONSTRAINT "unique_link_id_pos_temp_id_pos_temp_prop" UNIQUE ("id_pos_temp", "id_pos_temp_prop");


--
-- TOC entry 5863 (class 2606 OID 17384)
-- Name: class_prop_link_val_snapshot unique_link_ts_id_class_id_class_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val_snapshot"
    ADD CONSTRAINT "unique_link_ts_id_class_id_class_prop" UNIQUE ("id_class", "id_class_prop", "timestamp_class");


--
-- TOC entry 5902 (class 2606 OID 611861)
-- Name: pos_temp_prop_obj_val unique_object_id_pos_temp_id_pos_temp_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_obj_val"
    ADD CONSTRAINT "unique_object_id_pos_temp_id_pos_temp_prop" UNIQUE ("id_pos_temp", "id_pos_temp_prop");


--
-- TOC entry 5966 (class 2606 OID 1167068)
-- Name: plan_calendar unique_plan_calendar; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_calendar"
    ADD CONSTRAINT "unique_plan_calendar" UNIQUE ("work_date");


--
-- TOC entry 5953 (class 2606 OID 1443636)
-- Name: plan_range unique_plan_range; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range"
    ADD CONSTRAINT "unique_plan_range" UNIQUE ("id_plan", "range_plan");


--
-- TOC entry 5978 (class 2606 OID 1443697)
-- Name: plan_range_fact_link unique_plan_range_fact_link; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact_link"
    ADD CONSTRAINT "unique_plan_range_fact_link" UNIQUE ("id_plan_range_fact", "id_entity", "id_entity_instance", "id_sub_entity_instance");


--
-- TOC entry 5877 (class 2606 OID 611724)
-- Name: pos_temp_prop unique_pos_temp_prop_name; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop"
    ADD CONSTRAINT "unique_pos_temp_prop_name" UNIQUE ("id_pos_temp", "name");


--
-- TOC entry 5809 (class 2606 OID 17386)
-- Name: prop_enum unique_prop_enum_name; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum"
    ADD CONSTRAINT "unique_prop_enum_name" UNIQUE ("id_conception", "name");


--
-- TOC entry 5993 (class 2606 OID 1348765)
-- Name: role_user unique_role_name; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."role_user"
    ADD CONSTRAINT "unique_role_name" UNIQUE ("name");


--
-- TOC entry 5995 (class 2606 OID 1367879)
-- Name: role_user unique_role_user_namesys; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."role_user"
    ADD CONSTRAINT "unique_role_user_namesys" UNIQUE ("namesys");


--
-- TOC entry 5529 (class 2606 OID 17387)
-- Name: pos_prototype unique_rule_combination; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_prototype"
    ADD CONSTRAINT "unique_rule_combination" UNIQUE ("on_root", "on_this", "on_pos", "on_obj", "on_service", "sort");


--
-- TOC entry 5910 (class 2606 OID 611895)
-- Name: pos_temp_prop_user_small_val unique_small_id_pos_temp_id_pos_temp_prop; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_user_small_val"
    ADD CONSTRAINT "unique_small_id_pos_temp_id_pos_temp_prop" UNIQUE ("id_pos_temp", "id_pos_temp_prop");


--
-- TOC entry 5626 (class 2606 OID 17388)
-- Name: units unique_units_ID; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."units"
    ADD CONSTRAINT "unique_units_ID" UNIQUE ("id");


--
-- TOC entry 5541 (class 2606 OID 614259)
-- Name: users unique_user_id; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."users"
    ADD CONSTRAINT "unique_user_id" UNIQUE ("id");


--
-- TOC entry 5797 (class 2606 OID 17389)
-- Name: unit_conversion_base_rules unit_conversion_base_rules_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."unit_conversion_base_rules"
    ADD CONSTRAINT "unit_conversion_base_rules_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5632 (class 2606 OID 17390)
-- Name: unit_conversion_rules unit_conversion_rules_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."unit_conversion_rules"
    ADD CONSTRAINT "unit_conversion_rules_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5628 (class 2606 OID 17391)
-- Name: units units_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."units"
    ADD CONSTRAINT "units_pkey" PRIMARY KEY ("id");


--
-- TOC entry 6001 (class 2606 OID 1359075)
-- Name: role_base_list user_base_role_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."role_base_list"
    ADD CONSTRAINT "user_base_role_pkey" PRIMARY KEY ("rolname");


--
-- TOC entry 5767 (class 2606 OID 17392)
-- Name: user_options user_options_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_options"
    ADD CONSTRAINT "user_options_pkey" PRIMARY KEY ("login");


--
-- TOC entry 5545 (class 2606 OID 17393)
-- Name: user_prop user_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_prop"
    ADD CONSTRAINT "user_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5547 (class 2606 OID 17394)
-- Name: user_prop_val user_prop_val_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_prop_val"
    ADD CONSTRAINT "user_prop_val_pkey" PRIMARY KEY ("login", "id_user_prop");


--
-- TOC entry 5999 (class 2606 OID 1349335)
-- Name: user_role_mapping user_role_mapping_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_role_mapping"
    ADD CONSTRAINT "user_role_mapping_pkey" PRIMARY KEY ("oid_role", "id_conception");


--
-- TOC entry 5997 (class 2606 OID 1348763)
-- Name: role_user user_roles_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."role_user"
    ADD CONSTRAINT "user_roles_pkey" PRIMARY KEY ("oid");


--
-- TOC entry 5549 (class 2606 OID 17395)
-- Name: user_temp_prop user_temp_prop_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_temp_prop"
    ADD CONSTRAINT "user_temp_prop_pkey" PRIMARY KEY ("id");


--
-- TOC entry 5543 (class 2606 OID 17396)
-- Name: users users_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."users"
    ADD CONSTRAINT "users_pkey" PRIMARY KEY ("login");


--
-- TOC entry 5520 (class 2606 OID 17397)
-- Name: vector vector_pkey; Type: CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."vector"
    ADD CONSTRAINT "vector_pkey" PRIMARY KEY ("id");



CREATE OR REPLACE VIEW "bpd"."int_class_ready" AS
 SELECT "c"."id",
        CASE "c"."on_abstraction"
            WHEN false THEN
            CASE "bpd"."int_class_name_format_check"("c"."id")
                WHEN true THEN
                CASE ("count"("cp"."id") > 0)
                    WHEN true THEN "bool_and"(
                    CASE "cp"."id_prop_type"
                        WHEN 1 THEN (
                        CASE "cp"."id_data_type"
                            WHEN 1 THEN ("sv"."val_varchar" IS NOT NULL)
                            WHEN 2 THEN ("sv"."val_int" IS NOT NULL)
                            WHEN 3 THEN ("sv"."val_numeric" IS NOT NULL)
                            WHEN 4 THEN ("sv"."val_real" IS NOT NULL)
                            WHEN 5 THEN ("sv"."val_double" IS NOT NULL)
                            WHEN 6 THEN ("sv"."val_money" IS NOT NULL)
                            WHEN 7 THEN ("bv"."val_text" IS NOT NULL)
                            WHEN 8 THEN ("bv"."val_bytea" IS NOT NULL)
                            WHEN 9 THEN ("sv"."val_boolean" IS NOT NULL)
                            WHEN 10 THEN ("sv"."val_date" IS NOT NULL)
                            WHEN 11 THEN ("sv"."val_time" IS NOT NULL)
                            WHEN 12 THEN ("sv"."val_interval" IS NOT NULL)
                            WHEN 13 THEN ("sv"."val_timestamp" IS NOT NULL)
                            WHEN 14 THEN ("bv"."val_json" IS NOT NULL)
                            WHEN 15 THEN ("sv"."val_bigint" IS NOT NULL)
                            ELSE false
                        END OR "cp"."on_override")
                        WHEN 2 THEN (
                        CASE "cp"."id_data_type"
                            WHEN 1 THEN ("pev"."val_varchar" IS NOT NULL)
                            WHEN 3 THEN ("pev"."val_numeric" IS NOT NULL)
                            ELSE false
                        END OR ("cp"."on_override" AND (COALESCE("ev"."id_prop_enum", (0)::bigint) > 0)))
                        WHEN 3 THEN (COALESCE("class_val"."id", (0)::bigint) > 0)
                        WHEN 4 THEN ((COALESCE("lv"."id_entity_instance", (0)::bigint) > 0) OR ("cp"."on_override" AND ("lv"."id_entity" IS NOT NULL)))
                        ELSE false
                    END)
                    ELSE true
                END
                ELSE false
            END
            ELSE false
        END AS "ready"
   FROM ((((((((ONLY "bpd"."class" "c"
     LEFT JOIN ONLY "bpd"."class_prop" "cp" ON (("c"."id" = "cp"."id_class")))
     LEFT JOIN ONLY "bpd"."class_prop_user_small_val" "sv" ON (("sv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class_prop_user_big_val" "bv" ON (("bv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class_prop_enum_val" "ev" ON (("ev"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."prop_enum_val" "pev" ON (("pev"."id" = "ev"."id_prop_enum_val")))
     LEFT JOIN ONLY "bpd"."class_prop_link_val" "lv" ON (("lv"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class_prop_obj_val_class" "ov" ON (("ov"."id_class_prop" = "cp"."id")))
     LEFT JOIN ONLY "bpd"."class" "class_val" ON (("class_val"."id" = "ov"."id_class_val")))
  GROUP BY "c"."id";


--
-- TOC entry 6365 (class 2618 OID 1031313)
-- Name: vdoc_category _RETURN; Type: RULE; Schema: bpd; Owner: -
--

CREATE OR REPLACE VIEW "bpd"."vdoc_category" AS
 SELECT "dc"."id",
    "dc"."id_conception",
    "dc"."name",
    "dc"."desc",
    "dc"."on",
    "dc"."on_grouping",
    "count"("d"."id") AS "doc_count",
    ("count"("d"."id") > 0) AS "is_use",
    "dc"."timestamp"
   FROM ("bpd"."doc_category" "dc"
     LEFT JOIN "bpd"."document" "d" ON (("d"."id_category" = "dc"."id")))
  GROUP BY "dc"."id", "dc"."id_conception", "dc"."name", "dc"."desc", "dc"."on", "dc"."on_grouping";


ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "lnk_class_class_prop" FOREIGN KEY ("id_class") REFERENCES "bpd"."class"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6079 (class 2606 OID 17508)
-- Name: class_unit_conversion_rules lnk_class_class_unit_conversion_rules; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_unit_conversion_rules"
    ADD CONSTRAINT "lnk_class_class_unit_conversion_rules" FOREIGN KEY ("id_class") REFERENCES "bpd"."class"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6054 (class 2606 OID 1140519)
-- Name: class lnk_class_group; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class"
    ADD CONSTRAINT "lnk_class_group" FOREIGN KEY ("id_group") REFERENCES "bpd"."group"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6070 (class 2606 OID 689854)
-- Name: class_prop_user_big_val lnk_class_prop_class_prop_big_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val"
    ADD CONSTRAINT "lnk_class_prop_class_prop_big_val" FOREIGN KEY ("id_class_prop") REFERENCES "bpd"."class_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6095 (class 2606 OID 17518)
-- Name: class_prop_enum_val lnk_class_prop_class_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val"
    ADD CONSTRAINT "lnk_class_prop_class_prop_enum_val" FOREIGN KEY ("id_class_prop") REFERENCES "bpd"."class_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6102 (class 2606 OID 17523)
-- Name: class_prop_link_val lnk_class_prop_class_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val"
    ADD CONSTRAINT "lnk_class_prop_class_prop_link_val" FOREIGN KEY ("id_class_prop") REFERENCES "bpd"."class_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6082 (class 2606 OID 17528)
-- Name: class_prop_obj_val_class lnk_class_prop_class_prop_obj_val_class; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class"
    ADD CONSTRAINT "lnk_class_prop_class_prop_obj_val_class" FOREIGN KEY ("id_class_prop") REFERENCES "bpd"."class_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6068 (class 2606 OID 689874)
-- Name: class_prop_user_small_val lnk_class_prop_class_prop_small_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val"
    ADD CONSTRAINT "lnk_class_prop_class_prop_small_val" FOREIGN KEY ("id_class_prop") REFERENCES "bpd"."class_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6071 (class 2606 OID 689859)
-- Name: class_prop_user_big_val_snapshot lnk_class_prop_snapshot_class_prop_big_val_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_big_val_snapshot"
    ADD CONSTRAINT "lnk_class_prop_snapshot_class_prop_big_val_snapshot" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6097 (class 2606 OID 17543)
-- Name: class_prop_enum_val_snapshot lnk_class_prop_snapshot_class_prop_enum_val_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val_snapshot"
    ADD CONSTRAINT "lnk_class_prop_snapshot_class_prop_enum_val_snapshot" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6107 (class 2606 OID 17548)
-- Name: class_prop_link_val_snapshot lnk_class_prop_snapshot_class_prop_link_val_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val_snapshot"
    ADD CONSTRAINT "lnk_class_prop_snapshot_class_prop_link_val_snapshot" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6084 (class 2606 OID 17553)
-- Name: class_prop_obj_val_class_snapshot lnk_class_prop_snapshot_class_prop_obj_val_class_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot"
    ADD CONSTRAINT "lnk_class_prop_snapshot_class_prop_obj_val_class_snapshot" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6069 (class 2606 OID 689879)
-- Name: class_prop_user_small_val_snapshot lnk_class_prop_snapshot_class_prop_small_val_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_user_small_val_snapshot"
    ADD CONSTRAINT "lnk_class_prop_snapshot_class_prop_small_val_snapshot" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6074 (class 2606 OID 17563)
-- Name: object_prop_user_big_val lnk_class_prop_snapshot_object_prop_big_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_user_big_val"
    ADD CONSTRAINT "lnk_class_prop_snapshot_object_prop_big_val" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6099 (class 2606 OID 17568)
-- Name: object_prop_enum_val lnk_class_prop_snapshot_object_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_enum_val"
    ADD CONSTRAINT "lnk_class_prop_snapshot_object_prop_enum_val" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6104 (class 2606 OID 17573)
-- Name: object_prop_link_val lnk_class_prop_snapshot_object_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_link_val"
    ADD CONSTRAINT "lnk_class_prop_snapshot_object_prop_link_val" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6072 (class 2606 OID 17578)
-- Name: object_prop_user_small_val lnk_class_prop_snapshot_object_prop_small_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_user_small_val"
    ADD CONSTRAINT "lnk_class_prop_snapshot_object_prop_small_val" FOREIGN KEY ("id_class_prop", "timestamp_class") REFERENCES "bpd"."class_prop_snapshot"("id", "timestamp_class") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6155 (class 2606 OID 1377280)
-- Name: rulel1_class_on_pos_temp lnk_class_rulel1_class_on_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel1_class_on_pos_temp"
    ADD CONSTRAINT "lnk_class_rulel1_class_on_pos_temp" FOREIGN KEY ("id_class") REFERENCES "bpd"."class"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6088 (class 2606 OID 17583)
-- Name: rulel2_class_on_position lnk_class_rulel2_class_on_position; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel2_class_on_position"
    ADD CONSTRAINT "lnk_class_rulel2_class_on_position" FOREIGN KEY ("id_class") REFERENCES "bpd"."class"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6085 (class 2606 OID 17588)
-- Name: class_prop_obj_val_class_snapshot lnk_class_snapshot_class_prop_obj_val_class_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class_snapshot"
    ADD CONSTRAINT "lnk_class_snapshot_class_prop_obj_val_class_snapshot" FOREIGN KEY ("id_class_val", "timestamp_class_val") REFERENCES "bpd"."class_snapshot"("id", "timestamp") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6076 (class 2606 OID 17593)
-- Name: class_prop_snapshot lnk_class_snapshot_class_prop_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot"
    ADD CONSTRAINT "lnk_class_snapshot_class_prop_snapshot" FOREIGN KEY ("id_class", "timestamp_class") REFERENCES "bpd"."class_snapshot"("id", "timestamp") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6056 (class 2606 OID 17598)
-- Name: object lnk_class_snapshot_object; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object"
    ADD CONSTRAINT "lnk_class_snapshot_object" FOREIGN KEY ("id_class", "timestamp_class") REFERENCES "bpd"."class_snapshot"("id", "timestamp") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6090 (class 2606 OID 17603)
-- Name: rulel2_class_snapshot_on_position lnk_class_snapshot_rulel2_class_snapshot_on_position; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel2_class_snapshot_on_position"
    ADD CONSTRAINT "lnk_class_snapshot_rulel2_class_snapshot_on_position" FOREIGN KEY ("id_class", "timestamp_class") REFERENCES "bpd"."class_snapshot"("id", "timestamp") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6055 (class 2606 OID 1159242)
-- Name: class lnk_conception_class; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class"
    ADD CONSTRAINT "lnk_conception_class" FOREIGN KEY ("id_con") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6061 (class 2606 OID 1159247)
-- Name: class_snapshot lnk_conception_class_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_snapshot"
    ADD CONSTRAINT "lnk_conception_class_snapshot" FOREIGN KEY ("id_con") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6131 (class 2606 OID 1159252)
-- Name: doc_category lnk_conception_doc_category; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_category"
    ADD CONSTRAINT "lnk_conception_doc_category" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6132 (class 2606 OID 799919)
-- Name: document lnk_conception_document; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."document"
    ADD CONSTRAINT "lnk_conception_document" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6125 (class 2606 OID 637764)
-- Name: global_prop lnk_conception_global_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop"
    ADD CONSTRAINT "lnk_conception_global_prop" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6053 (class 2606 OID 17613)
-- Name: group lnk_conception_group; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."group"
    ADD CONSTRAINT "lnk_conception_group" FOREIGN KEY ("id_con") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6040 (class 2606 OID 17618)
-- Name: link_pos_obj lnk_conception_link_pos_obj; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_pos_obj"
    ADD CONSTRAINT "lnk_conception_link_pos_obj" FOREIGN KEY ("id_con") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6057 (class 2606 OID 17623)
-- Name: object lnk_conception_object; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object"
    ADD CONSTRAINT "lnk_conception_object" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6135 (class 2606 OID 1450409)
-- Name: plan lnk_conception_plan; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan"
    ADD CONSTRAINT "lnk_conception_plan" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6143 (class 2606 OID 1450414)
-- Name: plan_interval lnk_conception_plan_interval; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_interval"
    ADD CONSTRAINT "lnk_conception_plan_interval" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6136 (class 2606 OID 1443625)
-- Name: plan_range lnk_conception_plan_range; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range"
    ADD CONSTRAINT "lnk_conception_plan_range" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6138 (class 2606 OID 1443657)
-- Name: plan_range_fact lnk_conception_plan_range_fact; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact"
    ADD CONSTRAINT "lnk_conception_plan_range_fact" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6146 (class 2606 OID 1443698)
-- Name: plan_range_plan lnk_conception_plan_range_plan; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan"
    ADD CONSTRAINT "lnk_conception_plan_range_plan" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6038 (class 2606 OID 17628)
-- Name: pos_temp lnk_conception_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp"
    ADD CONSTRAINT "lnk_conception_pos_temp" FOREIGN KEY ("id_con") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6035 (class 2606 OID 1159257)
-- Name: position lnk_conception_position; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position"
    ADD CONSTRAINT "lnk_conception_position" FOREIGN KEY ("id_con") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6153 (class 2606 OID 1349167)
-- Name: user_role_mapping lnk_conception_role_mapping; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_role_mapping"
    ADD CONSTRAINT "lnk_conception_role_mapping" FOREIGN KEY ("id_conception") REFERENCES "bpd"."conception"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6133 (class 2606 OID 855699)
-- Name: document lnk_doc_category_document; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."document"
    ADD CONSTRAINT "lnk_doc_category_document" FOREIGN KEY ("id_category") REFERENCES "bpd"."doc_category"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6134 (class 2606 OID 799935)
-- Name: doc_file lnk_document_doc_file; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_file"
    ADD CONSTRAINT "lnk_document_doc_file" FOREIGN KEY ("id_document") REFERENCES "bpd"."document"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6129 (class 2606 OID 799942)
-- Name: doc_link lnk_document_doc_links; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_link"
    ADD CONSTRAINT "lnk_document_doc_links" FOREIGN KEY ("id_document") REFERENCES "bpd"."document"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6044 (class 2606 OID 17638)
-- Name: cfg_procnamespace lnk_entity_cfg_procnamespace; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."cfg_procnamespace"
    ADD CONSTRAINT "lnk_entity_cfg_procnamespace" FOREIGN KEY ("id_entity") REFERENCES "bpd"."entity"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6103 (class 2606 OID 17643)
-- Name: class_prop_link_val lnk_entity_class_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val"
    ADD CONSTRAINT "lnk_entity_class_prop_link_val" FOREIGN KEY ("id_entity") REFERENCES "bpd"."entity"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6108 (class 2606 OID 17648)
-- Name: class_prop_link_val_snapshot lnk_entity_class_prop_link_val_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_link_val_snapshot"
    ADD CONSTRAINT "lnk_entity_class_prop_link_val_snapshot" FOREIGN KEY ("id_entity") REFERENCES "bpd"."entity"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6130 (class 2606 OID 793638)
-- Name: doc_link lnk_entity_doc_links; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."doc_link"
    ADD CONSTRAINT "lnk_entity_doc_links" FOREIGN KEY ("id_entity") REFERENCES "bpd"."entity"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6105 (class 2606 OID 17653)
-- Name: object_prop_link_val lnk_entity_object_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_link_val"
    ADD CONSTRAINT "lnk_entity_object_prop_link_val" FOREIGN KEY ("id_entity") REFERENCES "bpd"."entity"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6126 (class 2606 OID 637769)
-- Name: global_prop_link_class_prop lnk_global_prop_link_class_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop_link_class_prop"
    ADD CONSTRAINT "lnk_global_prop_link_class_prop" FOREIGN KEY ("id_global_prop") REFERENCES "bpd"."global_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6127 (class 2606 OID 637863)
-- Name: global_prop_link_pos_temp_prop lnk_global_prop_link_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop_link_pos_temp_prop"
    ADD CONSTRAINT "lnk_global_prop_link_pos_temp" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6128 (class 2606 OID 637774)
-- Name: global_prop_link_pos_temp_prop lnk_global_prop_link_pos_temp_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."global_prop_link_pos_temp_prop"
    ADD CONSTRAINT "lnk_global_prop_link_pos_temp_prop" FOREIGN KEY ("id_global_prop") REFERENCES "bpd"."global_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6086 (class 2606 OID 17663)
-- Name: rulel1_group_on_pos_temp lnk_group_rulel1_group_on_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel1_group_on_pos_temp"
    ADD CONSTRAINT "lnk_group_rulel1_group_on_pos_temp" FOREIGN KEY ("id_group") REFERENCES "bpd"."group"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6147 (class 2606 OID 1443703)
-- Name: plan_range_plan lnk_interval_plan_range_plan; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan"
    ADD CONSTRAINT "lnk_interval_plan_range_plan" FOREIGN KEY ("id_plan_interval") REFERENCES "bpd"."plan_interval"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6041 (class 2606 OID 17668)
-- Name: link_pos_obj lnk_link_type_link_pos_obj; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_pos_obj"
    ADD CONSTRAINT "lnk_link_type_link_pos_obj" FOREIGN KEY ("id_link_type") REFERENCES "bpd"."link_type"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6060 (class 2606 OID 17673)
-- Name: map_class_pos_root lnk_link_type_map_class_pos_root; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."map_class_pos_root"
    ADD CONSTRAINT "lnk_link_type_map_class_pos_root" FOREIGN KEY ("id_link_type") REFERENCES "bpd"."link_type"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6052 (class 2606 OID 17678)
-- Name: message_prop lnk_message_message_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."message_prop"
    ADD CONSTRAINT "lnk_message_message_prop" FOREIGN KEY ("id_message") REFERENCES "bpd"."message"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6042 (class 2606 OID 17683)
-- Name: link_pos_obj lnk_object_link_pos_obj; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_pos_obj"
    ADD CONSTRAINT "lnk_object_link_pos_obj" FOREIGN KEY ("id_obj") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6065 (class 2606 OID 17688)
-- Name: object_accounting lnk_object_object_accounting; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_accounting"
    ADD CONSTRAINT "lnk_object_object_accounting" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6066 (class 2606 OID 17693)
-- Name: object_commercial lnk_object_object_commercial; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_commercial"
    ADD CONSTRAINT "lnk_object_object_commercial" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6075 (class 2606 OID 17698)
-- Name: object_prop_user_big_val lnk_object_object_prop_big_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_user_big_val"
    ADD CONSTRAINT "lnk_object_object_prop_big_val" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6100 (class 2606 OID 17703)
-- Name: object_prop_enum_val lnk_object_object_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_enum_val"
    ADD CONSTRAINT "lnk_object_object_prop_enum_val" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6106 (class 2606 OID 17708)
-- Name: object_prop_link_val lnk_object_object_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_link_val"
    ADD CONSTRAINT "lnk_object_object_prop_link_val" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6073 (class 2606 OID 17713)
-- Name: object_prop_user_small_val lnk_object_object_prop_small_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_user_small_val"
    ADD CONSTRAINT "lnk_object_object_prop_small_val" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6067 (class 2606 OID 17718)
-- Name: object_technical lnk_object_object_technical; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_technical"
    ADD CONSTRAINT "lnk_object_object_technical" FOREIGN KEY ("id_object") REFERENCES "bpd"."object"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6083 (class 2606 OID 735746)
-- Name: class_prop_obj_val_class lnk_object_prop_create_embed_mode_class_prop_object_val_class; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_obj_val_class"
    ADD CONSTRAINT "lnk_object_prop_create_embed_mode_class_prop_object_val_class" FOREIGN KEY ("embed_mode") REFERENCES "bpd"."object_prop_create_emded_mode"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6121 (class 2606 OID 735751)
-- Name: pos_temp_prop_obj_val lnk_object_prop_create_embed_mode_pos_temp_prop_object_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_obj_val"
    ADD CONSTRAINT "lnk_object_prop_create_embed_mode_pos_temp_prop_object_val" FOREIGN KEY ("embed_mode") REFERENCES "bpd"."object_prop_create_emded_mode"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6139 (class 2606 OID 1443663)
-- Name: plan_range_fact lnk_plan_interval_plan_range_fact; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact"
    ADD CONSTRAINT "lnk_plan_interval_plan_range_fact" FOREIGN KEY ("id_plan_interval") REFERENCES "bpd"."plan_interval"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6144 (class 2606 OID 1450419)
-- Name: plan_interval lnk_plan_plan_interval; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_interval"
    ADD CONSTRAINT "lnk_plan_plan_interval" FOREIGN KEY ("id_plan") REFERENCES "bpd"."plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6145 (class 2606 OID 1450424)
-- Name: plan_link lnk_plan_plan_link; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_link"
    ADD CONSTRAINT "lnk_plan_plan_link" FOREIGN KEY ("id_plan") REFERENCES "bpd"."plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6140 (class 2606 OID 1443668)
-- Name: plan_range_fact lnk_plan_plan_range_fact; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact"
    ADD CONSTRAINT "lnk_plan_plan_range_fact" FOREIGN KEY ("id_plan") REFERENCES "bpd"."plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6148 (class 2606 OID 1443708)
-- Name: plan_range_plan lnk_plan_plan_range_plan; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan"
    ADD CONSTRAINT "lnk_plan_plan_range_plan" FOREIGN KEY ("id_plan") REFERENCES "bpd"."plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6137 (class 2606 OID 1443630)
-- Name: plan_range lnk_plan_range_plan; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range"
    ADD CONSTRAINT "lnk_plan_range_plan" FOREIGN KEY ("id_plan") REFERENCES "bpd"."plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6151 (class 2606 OID 1450433)
-- Name: plan_range_plan_link lnk_plan_range_plan_plan_range_plan_link; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan_link"
    ADD CONSTRAINT "lnk_plan_range_plan_plan_range_plan_link" FOREIGN KEY ("id_plan_range_plan") REFERENCES "bpd"."plan_range_plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6141 (class 2606 OID 1443689)
-- Name: plan_range_fact lnk_plan_range_plan_range_fact; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact"
    ADD CONSTRAINT "lnk_plan_range_plan_range_fact" FOREIGN KEY ("id_plan_range") REFERENCES "bpd"."plan_range"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6152 (class 2606 OID 1450404)
-- Name: plan_range_link lnk_plan_range_plan_range_link; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_link"
    ADD CONSTRAINT "lnk_plan_range_plan_range_link" FOREIGN KEY ("id_plan_range") REFERENCES "bpd"."plan_range"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6149 (class 2606 OID 1443713)
-- Name: plan_range_plan lnk_plan_range_plan_range_plan; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_plan"
    ADD CONSTRAINT "lnk_plan_range_plan_range_plan" FOREIGN KEY ("id_plan_range") REFERENCES "bpd"."plan_range"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6039 (class 2606 OID 17723)
-- Name: pos_temp lnk_pos_prototype_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp"
    ADD CONSTRAINT "lnk_pos_prototype_pos_temp" FOREIGN KEY ("id_prototype") REFERENCES "bpd"."pos_prototype"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6045 (class 2606 OID 17728)
-- Name: pos_temp_nested_limit lnk_pos_temp_pos_temp_nested_limit; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_nested_limit"
    ADD CONSTRAINT "lnk_pos_temp_pos_temp_nested_limit" FOREIGN KEY ("id_pos_temp") REFERENCES "bpd"."pos_temp"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6046 (class 2606 OID 17733)
-- Name: pos_temp_nested_limit lnk_pos_temp_pos_temp_nested_limit_nested; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_nested_limit"
    ADD CONSTRAINT "lnk_pos_temp_pos_temp_nested_limit_nested" FOREIGN KEY ("id_pos_temp_nested") REFERENCES "bpd"."pos_temp"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6109 (class 2606 OID 612059)
-- Name: pos_temp_prop lnk_pos_temp_pos_temp_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop"
    ADD CONSTRAINT "lnk_pos_temp_pos_temp_prop" FOREIGN KEY ("id_pos_temp") REFERENCES "bpd"."pos_temp"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6119 (class 2606 OID 612093)
-- Name: pos_temp_prop_enum_val lnk_pos_temp_prop_pos_temp_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_enum_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_pos_temp_prop_enum_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6120 (class 2606 OID 612069)
-- Name: pos_temp_prop_link_val lnk_pos_temp_prop_pos_temp_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_link_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_pos_temp_prop_link_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6122 (class 2606 OID 612084)
-- Name: pos_temp_prop_obj_val lnk_pos_temp_prop_pos_temp_prop_obj_val_class; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_obj_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_pos_temp_prop_obj_val_class" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6123 (class 2606 OID 612074)
-- Name: pos_temp_prop_user_big_val lnk_pos_temp_prop_pos_temp_prop_user_big_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_user_big_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_pos_temp_prop_user_big_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6124 (class 2606 OID 612079)
-- Name: pos_temp_prop_user_small_val lnk_pos_temp_prop_pos_temp_prop_user_small_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."pos_temp_prop_user_small_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_pos_temp_prop_user_small_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6110 (class 2606 OID 612103)
-- Name: position_prop_enum_val lnk_pos_temp_prop_position_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_enum_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_position_prop_enum_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6113 (class 2606 OID 612113)
-- Name: position_prop_link_val lnk_pos_temp_prop_position_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_link_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_position_prop_link_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6115 (class 2606 OID 612123)
-- Name: position_prop_user_big_val lnk_pos_temp_prop_position_prop_user_big_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_user_big_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_position_prop_user_big_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6117 (class 2606 OID 612133)
-- Name: position_prop_user_small_val lnk_pos_temp_prop_position_prop_user_small_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_user_small_val"
    ADD CONSTRAINT "lnk_pos_temp_prop_position_prop_user_small_val" FOREIGN KEY ("id_pos_temp_prop") REFERENCES "bpd"."pos_temp_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6156 (class 2606 OID 1377275)
-- Name: rulel1_class_on_pos_temp lnk_pos_temp_rulel1_class_on_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel1_class_on_pos_temp"
    ADD CONSTRAINT "lnk_pos_temp_rulel1_class_on_pos_temp" FOREIGN KEY ("id_pos_temp") REFERENCES "bpd"."pos_temp"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6087 (class 2606 OID 17743)
-- Name: rulel1_group_on_pos_temp lnk_pos_temp_rulel1_group_on_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel1_group_on_pos_temp"
    ADD CONSTRAINT "lnk_pos_temp_rulel1_group_on_pos_temp" FOREIGN KEY ("id_pos_temp") REFERENCES "bpd"."pos_temp"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6043 (class 2606 OID 17748)
-- Name: link_pos_obj lnk_position_link_pos_obj; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."link_pos_obj"
    ADD CONSTRAINT "lnk_position_link_pos_obj" FOREIGN KEY ("id_pos") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6058 (class 2606 OID 17753)
-- Name: object lnk_position_object; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object"
    ADD CONSTRAINT "lnk_position_object" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6036 (class 2606 OID 1145900)
-- Name: position lnk_position_pos_temp; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position"
    ADD CONSTRAINT "lnk_position_pos_temp" FOREIGN KEY ("id_pos_temp") REFERENCES "bpd"."pos_temp"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6111 (class 2606 OID 612098)
-- Name: position_prop_enum_val lnk_position_position_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_enum_val"
    ADD CONSTRAINT "lnk_position_position_prop_enum_val" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6114 (class 2606 OID 612108)
-- Name: position_prop_link_val lnk_position_position_prop_link_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_link_val"
    ADD CONSTRAINT "lnk_position_position_prop_link_val" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6116 (class 2606 OID 612118)
-- Name: position_prop_user_big_val lnk_position_position_prop_user_big_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_user_big_val"
    ADD CONSTRAINT "lnk_position_position_prop_user_big_val" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6118 (class 2606 OID 612128)
-- Name: position_prop_user_small_val lnk_position_position_prop_user_small_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_user_small_val"
    ADD CONSTRAINT "lnk_position_position_prop_user_small_val" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6037 (class 2606 OID 1145941)
-- Name: position lnk_position_prototype; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position"
    ADD CONSTRAINT "lnk_position_prototype" FOREIGN KEY ("id_prototype") REFERENCES "bpd"."pos_prototype"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6089 (class 2606 OID 17758)
-- Name: rulel2_class_on_position lnk_position_rulel2_class_on_position; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel2_class_on_position"
    ADD CONSTRAINT "lnk_position_rulel2_class_on_position" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6091 (class 2606 OID 17763)
-- Name: rulel2_class_snapshot_on_position lnk_position_rulel2_class_snapshot_on_position; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."rulel2_class_snapshot_on_position"
    ADD CONSTRAINT "lnk_position_rulel2_class_snapshot_on_position" FOREIGN KEY ("id_position") REFERENCES "bpd"."position"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6063 (class 2606 OID 17783)
-- Name: class_prop lnk_prop_data_type_class_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "lnk_prop_data_type_class_prop" FOREIGN KEY ("id_data_type") REFERENCES "bpd"."prop_data_type"("id") MATCH FULL;


--
-- TOC entry 6077 (class 2606 OID 17788)
-- Name: class_prop_snapshot lnk_prop_data_type_class_prop_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot"
    ADD CONSTRAINT "lnk_prop_data_type_class_prop_snapshot" FOREIGN KEY ("id_data_type") REFERENCES "bpd"."prop_data_type"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6096 (class 2606 OID 1148183)
-- Name: class_prop_enum_val lnk_prop_enum_class_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val"
    ADD CONSTRAINT "lnk_prop_enum_class_prop_enum_val" FOREIGN KEY ("id_prop_enum") REFERENCES "bpd"."prop_enum"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6098 (class 2606 OID 599255)
-- Name: class_prop_enum_val_snapshot lnk_prop_enum_class_prop_enum_val_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_enum_val_snapshot"
    ADD CONSTRAINT "lnk_prop_enum_class_prop_enum_val_snapshot" FOREIGN KEY ("id_prop_enum") REFERENCES "bpd"."prop_enum"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6094 (class 2606 OID 17798)
-- Name: prop_enum_val lnk_prop_enum_enum_prop_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum_val"
    ADD CONSTRAINT "lnk_prop_enum_enum_prop_val" FOREIGN KEY ("id_prop_enum") REFERENCES "bpd"."prop_enum"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6101 (class 2606 OID 17803)
-- Name: object_prop_enum_val lnk_prop_enum_object_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."object_prop_enum_val"
    ADD CONSTRAINT "lnk_prop_enum_object_prop_enum_val" FOREIGN KEY ("id_prop_enum") REFERENCES "bpd"."prop_enum"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6112 (class 2606 OID 611732)
-- Name: position_prop_enum_val lnk_prop_enum_position_prop_enum_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."position_prop_enum_val"
    ADD CONSTRAINT "lnk_prop_enum_position_prop_enum_val" FOREIGN KEY ("id_prop_enum") REFERENCES "bpd"."prop_enum"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6093 (class 2606 OID 17808)
-- Name: prop_enum lnk_prop_enum_use_area_prop_enum; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."prop_enum"
    ADD CONSTRAINT "lnk_prop_enum_use_area_prop_enum" FOREIGN KEY ("id_prop_enum_use_area") REFERENCES "bpd"."prop_enum_use_area"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6064 (class 2606 OID 17818)
-- Name: class_prop lnk_prop_type_class_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop"
    ADD CONSTRAINT "lnk_prop_type_class_prop" FOREIGN KEY ("id_prop_type") REFERENCES "bpd"."prop_type"("id") MATCH FULL;


--
-- TOC entry 6078 (class 2606 OID 17823)
-- Name: class_prop_snapshot lnk_prop_type_class_prop_snapshot; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_prop_snapshot"
    ADD CONSTRAINT "lnk_prop_type_class_prop_snapshot" FOREIGN KEY ("id_prop_type") REFERENCES "bpd"."prop_type"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6142 (class 2606 OID 1443684)
-- Name: plan_range_fact lnk_range_plan_range_fact; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact"
    ADD CONSTRAINT "lnk_range_plan_range_fact" FOREIGN KEY ("id_range_plan") REFERENCES "bpd"."plan_range_plan"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6050 (class 2606 OID 17828)
-- Name: message lnk_ticket_message; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."message"
    ADD CONSTRAINT "lnk_ticket_message" FOREIGN KEY ("id_ticket") REFERENCES "bpd"."ticket"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6049 (class 2606 OID 17833)
-- Name: ticket lnk_ticket_state_ticket; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket"
    ADD CONSTRAINT "lnk_ticket_state_ticket" FOREIGN KEY ("state") REFERENCES "bpd"."ticket_state"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6051 (class 2606 OID 17838)
-- Name: ticket_prop lnk_ticket_ticket_prop; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."ticket_prop"
    ADD CONSTRAINT "lnk_ticket_ticket_prop" FOREIGN KEY ("id_ticket") REFERENCES "bpd"."ticket"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6080 (class 2606 OID 17843)
-- Name: class_unit_conversion_rules lnk_unit_conversion_rules_class_unit_conversion_rules; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."class_unit_conversion_rules"
    ADD CONSTRAINT "lnk_unit_conversion_rules_class_unit_conversion_rules" FOREIGN KEY ("id_unit_conversion_rule") REFERENCES "bpd"."unit_conversion_rules"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6092 (class 2606 OID 1324925)
-- Name: unit_conversion_base_rules lnk_units_unit_conversion_base_rules; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."unit_conversion_base_rules"
    ADD CONSTRAINT "lnk_units_unit_conversion_base_rules" FOREIGN KEY ("id_unit") REFERENCES "bpd"."units"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6059 (class 2606 OID 17848)
-- Name: unit_conversion_rules lnk_units_unit_conversion_rules; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."unit_conversion_rules"
    ADD CONSTRAINT "lnk_units_unit_conversion_rules" FOREIGN KEY ("id_unit") REFERENCES "bpd"."units"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6047 (class 2606 OID 17853)
-- Name: user_prop_val lnk_user_prop_user_prop_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_prop_val"
    ADD CONSTRAINT "lnk_user_prop_user_prop_val" FOREIGN KEY ("id_user_prop") REFERENCES "bpd"."user_prop"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6154 (class 2606 OID 1349162)
-- Name: user_role_mapping lnk_user_roles_role_mapping; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_role_mapping"
    ADD CONSTRAINT "lnk_user_roles_role_mapping" FOREIGN KEY ("oid_role") REFERENCES "bpd"."role_user"("oid") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6081 (class 2606 OID 17858)
-- Name: user_options lnk_users_user_options; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_options"
    ADD CONSTRAINT "lnk_users_user_options" FOREIGN KEY ("login") REFERENCES "bpd"."users"("login") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6048 (class 2606 OID 17863)
-- Name: user_prop_val lnk_users_user_prop_val; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."user_prop_val"
    ADD CONSTRAINT "lnk_users_user_prop_val" FOREIGN KEY ("login") REFERENCES "bpd"."users"("login") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6150 (class 2606 OID 1160825)
-- Name: plan_range_fact_link lnk_work_fact_link; Type: FK CONSTRAINT; Schema: bpd; Owner: -
--

ALTER TABLE ONLY "bpd"."plan_range_fact_link"
    ADD CONSTRAINT "lnk_work_fact_link" FOREIGN KEY ("id_plan_range_fact") REFERENCES "bpd"."plan_range_fact"("id") MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


-- Completed on 2021-11-17 21:10:24 +05

--
-- PostgreSQL database dump complete
--

CREATE CAST (bpd.vclass_prop AS bpd.cclass_prop) WITH FUNCTION bpd.int_cast_vclass_prop_to_cclass_prop(bpd.vclass_prop);

